commit ab6184298083541d37356f1f5656380d0cda047c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 18:03:23 2010 +0000

    Release 1.2.0 (stable)

 configure.ac | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 3c9a24f4a78cd676e635ad32df639b57e65e3be7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 18:03:13 2010 +0000

    Update the NEWS file

 NEWS | 42 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 42 insertions(+)

commit 9e4c008117da6b36237608bd896fb164577ef314
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 19:17:28 2010 +0000

    build: Include test-script-model.json
    
    The Model conformance test for ClutterScript parsing requires the file
    to be inside the dist.

 tests/data/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 2d51432e52745d9484cf2d54567c2f95670ea5ae
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 19:29:22 2010 +0000

    build: Add test-animator-3.json to EXTRA_DIST

 tests/data/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 2f68949962d964e38a640581e232c4b673ce3023
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 19:09:20 2010 +0000

    conformance: Use g_assert_no_error() if available
    
    GLib 2.20 has a nice g_assert() wrapper which will print out the GError
    if it's not NULL.

 tests/conform/test-animator.c      | 15 +++++++++++++++
 tests/conform/test-model.c         |  5 +++++
 tests/conform/test-script-parser.c | 30 ++++++++++++++++++++++++++++++
 3 files changed, 50 insertions(+)

commit 048fcea988446af1ce18356eb1718f85088e73c8
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Mar 2 18:30:31 2010 +0000

    clutter-actor: Initialize with the identity matrix in get_transform
    
    The documentation and name of the get_transformation_matrix function
    implies that 'matrix' is purely an out parameter. However it wasn't
    initializing the matrix before calling the 'apply_transform' virtual
    so it was basically just a wrapper for the virtual. The virtual
    assumes the matrix parameter is in/out and applies the actor's
    transformation on top of any existing transformations. This causes
    unexpected semantics that are inconsistent with the documentation.

 clutter/clutter-actor.c | 2 ++
 1 file changed, 2 insertions(+)

commit e550755f3dc13f11a9d956bb9b52294ea33c8da6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 17:47:13 2010 +0000

    text-field: Cast GString->len to integer before printing
    
    The compiler will warn on 64bit architectures when using %d for
    printing a gsize field.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2019

 tests/interactive/test-text-field.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 38a24144980bd0c6d717f39eb5d215d3abc30ef5
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Mar 2 14:04:54 2010 +0000

    glx tfp: make clutter_glx_texture_pixmap_update_area cheap
    
    This changes clutter_glx_texture_pixmap_update_area so it defers the
    call to glXBindTexImageEXT until our pre "paint" signal handler which
    makes clutter_glx_texture_pixmap_update_area cheap to call.
    
    The hope is that mutter can switch to reporting raw damage updates to
    ClutterGLXTexturePixmap and we can use these to queue clipped redraws.

 clutter/glx/clutter-glx-texture-pixmap.c | 186 +++++++++++++++----------------
 1 file changed, 89 insertions(+), 97 deletions(-)

commit c0d5af5de5bcc504abeb81a7f7a1ec0f696b574d
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 30 17:47:55 2009 +0000

    Adds initial clipped redraw support to Clutter
    
    A new (internal only currently) API, _clutter_actor_queue_clipped_redraw
    can be used to queue a redraw along with a clip rectangle in actor
    coordinates. This clip rectangle propagates up to the stage and clutter
    backend which may optionally use the information to optimize stage
    redraws. The GLX backend in particular may scissor the next redraw to
    the clip rectangle and use GLX_MESA_copy_sub_buffer to present the stage
    subregion.
    
    The intention is that any actors that can naturally determine the bounds
    of updates should queue clipped redraws to reduce the cost of updating
    small regions of the screen.
    
    Notes:
    » If GLX_MESA_copy_sub_buffer isn't available then the GLX backend
      ignores any clip rectangles.
    
    » queuing multiple clipped redraws will result in the bounding box of
      each clip rectangle being used.
    
    » If a clipped redraw has a height > 300 pixels then it's promoted into
      a full stage redraw, so that the GPU doesn't end up blocking too long
      waiting for the vsync to reach the optimal position to avoid tearing.
    
      » Note: no empirical data was used to come up with this threshold so
        we may need to tune this.
    
    » Currently only ClutterX11TexturePixmap makes use of this new API. This
      is done via a new "queue-damage-redraw" signal that is emitted when
      the pixmap is updated. The default handler queues a clipped redraw
      with the assumption that the pixmap is being painted as a rectangle
      covering the actors transformed allocation. If you subclass
      ClutterX11TexturePixmap and change how it's painted you now also
      need to override the signal handler and queue your own redraw.
    
      Technically this is a semantic break, but it's assumed that no one
      is currently doing this.
    
    This still leaves a few unsolved issues with regards to optimizing sub
    stage redraws that need to be addressed in further work so this can only
    be considered a stepping stone a this point:
    
    » Because we have no reliable way to determine if the painting of any
      given actor is being modified any optimizations implemented using
      _clutter_actor_queue_redraw_with_clip must be overridable by a
      subclass, and technically must be opt-in for existing classes to avoid
      a change in semantics. E.g. consider that a user connects to the paint
      signal for ClutterTexture and paints a circle instead of a rectangle.
      In this case any original logic to queue clipped redraws would be
      incorrect.
    
    » Currently only the implementation of an actor has enough information
      with which to queue clipped redraws. E.g. It is not possible for
      generic code in clutter-actor.c to queue a clipped redraw when hiding
      an actor because actors have no way to report a "paint box". (remember
      actors can draw outside their allocation and actors with depth may
      also be projected outside of their allocation)
    
      » The current plan is to add a actor_class->get_paint_cuboid()
        virtual so actors can report a bounding cube for everything they
        would draw in their current state and use that to queue clipped
        redraws against the stage by projecting the paint cube into stage
        coordinates.
    
    » Our heuristics for promoting clipped redraws into full redraws to
      avoid blocking the GPU while we wait for the vsync need improving:
    
      » vsync issues aren't relevant for redirected/composited applications
        so they should use different heuristics. In this case we instead
        need to trade off the cost of blitting when using glXCopySubBuffer
        vs promoting to a full redraw and flipping instead.

 clutter/clutter-actor.c                  | 402 ++++++++++++++++++++++-------
 clutter/clutter-actor.h                  |  20 ++
 clutter/clutter-debug.h                  |   6 +-
 clutter/clutter-main.c                   |   4 +-
 clutter/clutter-private.h                |  39 ++-
 clutter/clutter-stage-window.c           |  29 +++
 clutter/clutter-stage-window.h           |  82 +++---
 clutter/clutter-stage.c                  |  64 +++++
 clutter/glx/clutter-backend-glx.c        | 185 ++------------
 clutter/glx/clutter-backend-glx.h        |   5 +
 clutter/glx/clutter-glx-texture-pixmap.c |  14 +-
 clutter/glx/clutter-stage-glx.c          | 426 +++++++++++++++++++++++++++++++
 clutter/glx/clutter-stage-glx.h          |   8 +-
 clutter/x11/clutter-x11-texture-pixmap.c | 172 ++++++++++---
 14 files changed, 1116 insertions(+), 340 deletions(-)

commit 09d8460a5c3f905573378172ed553fd57d49913e
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Tue Mar 2 17:03:03 2010 +0000

    animator: s/clutter_animator_run/clutter_animator_start/
    
    This is consistent with choice of words in clutter_timeline_start and
    makes the API less surprising.

 clutter/clutter-animator.c                 | 4 ++--
 clutter/clutter-animator.h                 | 2 +-
 doc/reference/clutter/clutter-sections.txt | 2 +-
 tests/interactive/test-animator.c          | 2 +-
 4 files changed, 5 insertions(+), 5 deletions(-)

commit 9d1ea81dc51464e86d7a4eee27874136e9e34cad
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Mar 2 02:07:40 2010 +0000

    cogl debug: Adds missing guards around debug cogl_args[]
    
    commit 511e5ceb516dc accidentally removed the #ifdef COGL_ENABLE_DEBUG
    guards around the "cogl-debug" and "cogl-no-debug" cogl_args[] which
    this patch restores.

 clutter/cogl/cogl/cogl-debug.c | 2 ++
 1 file changed, 2 insertions(+)

commit aba6c5acc7f1cb15f92666d1681a95b5a805efaf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 15:08:01 2010 +0000

    flow-layout: Provide a preferred size
    
    The FlowLayout fails to provide a preferred size in case no sizing is
    specified on one axis. It should, instead, have the preferred size of
    the sum of its children, depending on the orientation property.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2013

 clutter/clutter-flow-layout.c        | 92 +++++++++++++++++++++++++++---------
 tests/interactive/test-flow-layout.c | 20 ++++----
 2 files changed, 82 insertions(+), 30 deletions(-)

commit e3fba5f2e80a4c72cc4ef0c193a0b6569e1d8cbf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 13:32:46 2010 +0000

    build: Require libtool >= 2.2.6
    
    Update the configure.ac to use the LT_INIT() instead of the deprecated
    AC_PROG_LIBTOOL. This also allows us to depend on a specific libtool
    version, namely one that doesn't thoroughly suck.

 configure.ac | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 9a55ddc7c36185b31120b5c5275dac60f5926d8d
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Tue Mar 2 12:38:51 2010 +0000

    animator: restore accidentally removed break
    
    In 505e5966 a break statement was removed by accident, causing the
    animator to enter infinite loops if no initial key is present.

 clutter/clutter-animator.c | 2 ++
 1 file changed, 2 insertions(+)

commit 3a84af0106522e46d930fc81013c86465357dc89
Merge: 0baeabc2a a2573ad2a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 12:25:45 2010 +0000

    Merge branch 'eglnative-update'
    
    * eglnative-update:
      eglnative: Add CLUTTER_FB_DEVICE
      eglnative: Update implementation

commit a2573ad2ad39931d2a817d4585d87b70c3f86526
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 1 11:38:41 2010 +0000

    eglnative: Add CLUTTER_FB_DEVICE
    
    Some EGL drivers for embedded devices require a specific framebuffer
    device to be opened and passed to eglCreateWindowSurface(). Since it's
    optional, we can provide an environment variabled called
    CLUTTER_FB_DEVICE that can be used to specify the path of the device
    to be opened.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1997

 clutter/eglnative/clutter-backend-egl.c | 59 ++++++++++++++++++++++++++++++---
 clutter/eglnative/clutter-backend-egl.h |  3 ++
 2 files changed, 57 insertions(+), 5 deletions(-)

commit b4e9f40394fb2e4d63bccc9f9d932a5da87cc2a2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Feb 27 09:42:42 2010 +0000

    eglnative: Update implementation
    
    Update the EGL native framebuffer backend to be 1.2-ready:
    
      » create the EGL context and the surface inside the create_context()
        implementation so that a context is always available
    
      » simplify the StageWindow implementation
    
      » clean up old code
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1997

 clutter/eglnative/clutter-backend-egl.c | 186 +++++++++++++++++++++--
 clutter/eglnative/clutter-backend-egl.h |  20 ++-
 clutter/eglnative/clutter-event-egl.c   |  60 +++++---
 clutter/eglnative/clutter-stage-egl.c   | 259 +++++++-------------------------
 clutter/eglnative/clutter-stage-egl.h   |   8 +-
 5 files changed, 275 insertions(+), 258 deletions(-)

commit 0baeabc2aa1a4b2a1908b7acd15f947cb8b1eb4d
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Mar 1 13:54:03 2010 -0500

    Fall back in _cogl_texture_2d_new_from_bitmap()
    
    Just like _cogl_texture_2d_new_with_size(),
    _cogl_texture_2d_new_from_bitmap() needs to check if an unsliced
    texture can be created at the given size, or if hardware
    limitations prevent this.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2014
    
    Signed-off-by: Neil Roberts <neil@linux.intel.com>

 clutter/cogl/cogl/cogl-texture-2d.c | 3 +++
 1 file changed, 3 insertions(+)

commit 74a27bbb1c0ae12ba937d215323d5a716781cb1b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Mar 2 09:53:55 2010 +0000

    docs: Documentation fixes
    
    Let's see if we can get a 100% coverage for Clutter too.

 clutter/clutter-animatable.h               |  9 +++++
 clutter/clutter-animator.c                 |  5 +--
 clutter/clutter-box.c                      |  3 ++
 clutter/clutter-box.h                      | 49 +++++++++++++++++++++++++++
 clutter/clutter-container.h                |  9 +++++
 clutter/clutter-device-manager.h           | 13 ++++++--
 clutter/clutter-media.h                    |  9 +++++
 clutter/clutter-scriptable.h               |  9 +++++
 clutter/clutter-version.h.in               | 38 +++++++++++++++++++++
 clutter/eglnative/clutter-backend-egl.c    |  7 ++++
 clutter/glx/clutter-glx-texture-pixmap.c   | 53 +++++++++++++++---------------
 clutter/glx/clutter-glx-texture-pixmap.h   | 16 +++++++++
 clutter/x11/clutter-backend-x11.c          |  8 +++++
 clutter/x11/clutter-x11-texture-pixmap.c   | 36 +++++++++++++++-----
 clutter/x11/clutter-x11-texture-pixmap.h   | 20 ++++++++++-
 clutter/x11/clutter-x11.h                  |  8 ++++-
 doc/reference/clutter/Makefile.am          |  4 ---
 doc/reference/clutter/clutter-sections.txt |  4 +--
 18 files changed, 252 insertions(+), 48 deletions(-)

commit c0a553163b5e82cb70e956e802d7f9b61bb13948
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Mar 1 18:08:41 2010 +0000

    cogl: Support any format in cogl_read_pixels
    
    cogl_read_pixels() no longer asserts that the format passed in is
    RGBA_8888 but instead accepts any format. The appropriate GL enums for
    the format are passed to glReadPixels so OpenGL should be perform a
    conversion if neccessary.
    
    It currently assumes glReadPixels will always give us premultiplied
    data. This will usually be correct because the result of the default
    blending operations for Cogl ends up with premultiplied data in the
    framebuffer. However it is possible for the framebuffer to be in
    whatever format depending on what CoglMaterial is used to render to
    it. Eventually we may want to add a way for an application to inform
    Cogl that the framebuffer is not premultiplied in case it is being
    used for some special purpose.
    
    If the requested format is not premultiplied then Cogl will convert
    it. The tests have been changed to read the data as premultiplied so
    that they won't be affected by the conversion. Picking in Clutter has
    been changed to use COGL_PIXEL_FORMAT_RGB_888 because it doesn't need
    the alpha component. clutter_stage_read_pixels is left unchanged
    because the application can't specify a format for that so it seems to
    make most sense to store unpremultiplied values.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1959

 clutter/clutter-main.c                             | 10 +--
 clutter/cogl/cogl/cogl.c                           | 84 +++++++++++++++-------
 clutter/cogl/cogl/cogl.h                           |  8 ++-
 tests/conform/test-cogl-backface-culling.c         |  2 +-
 tests/conform/test-cogl-blend-strings.c            |  4 +-
 tests/conform/test-cogl-materials.c                |  2 +-
 tests/conform/test-cogl-multitexture.c             |  2 +-
 tests/conform/test-cogl-offscreen.c                |  8 +--
 tests/conform/test-cogl-premult.c                  |  2 +-
 tests/conform/test-cogl-readpixels.c               | 26 ++++++-
 tests/conform/test-cogl-texture-mipmaps.c          |  2 +-
 tests/conform/test-cogl-vertex-buffer-contiguous.c | 10 +--
 tests/conform/test-cogl-vertex-buffer-interleved.c |  2 +-
 tests/conform/test-cogl-vertex-buffer-mutability.c |  4 +-
 tests/conform/test-cogl-viewport.c                 |  2 +-
 15 files changed, 113 insertions(+), 55 deletions(-)

commit 505e5966e4ee649b7528cdf0410a4e52d59a25ec
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Mon Mar 1 18:35:01 2010 +0000

    Do not overwrite the initial key, making ease-in work as expected.
    
    Fixes bug #2008, where a property with ease-in would jump instead of
    start at the properties initial value.

 clutter/clutter-animator.c | 9 ---------
 1 file changed, 9 deletions(-)

commit 7d0ad7ac1b8f6b8a92d0c97180d2885a3a18bcdd
Author: Bastian Winkler <buz@netbuz.org>
Date:   Mon Mar 1 17:00:41 2010 +0100

    animator: Remove redundant declaration in header file
    
    clutter_animator_property_set_interpolation was declared twice in
    clutter-animator.h
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2012

 clutter/clutter-animator.h | 5 -----
 1 file changed, 5 deletions(-)

commit 53eecb8469855d17e863c2113a58f0b6e9c26729
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 1 17:47:52 2010 +0000

    docs: Add Animator.compute_value()
    
    The clutter_animator_compute_value() has been added to the API, but it
    is missing from the API reference.

 doc/reference/clutter/clutter-sections.txt | 1 +
 1 file changed, 1 insertion(+)

commit 1d9ddad9a3ee79d32091b12197bd18e0b283da22
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 1 17:45:00 2010 +0000

    docs: Fix syntax error in Model's documentation
    
    A missing opening quote sign is breaking gtk-doc for ClutterModel.

 clutter/clutter-model.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1777a69f2f036e2ead5986a5c91f18480a14e4fd
Merge: 8146d8d08 7ffb62eab
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 1 15:37:12 2010 +0000

    Merge branch 'stage-min-size-rework'
    
    * stage-min-size-rework:
      docs: Update minimum size accessors
      actor: Use the TOPLEVEL flag instead of a type check
      [stage] Use min-width/height props for min size

commit 8146d8d08deafd6cf86238a4a8c2fa6149e5c691
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Feb 26 09:44:29 2010 +0000

    profile: avoid segfault generating reports with no stats
    
    The clutter-profile.c print_report() code would crash if no stats had
    been gathered because uprof would return NULL for the "Redrawing" timer
    which we then dereferenced.
    
    This changes the code to start by checking for the "Mainloop",
    "Redrawing" and "Do Pick" timers and if none are present it returns
    immediately without generating any report.

 clutter/clutter-profile.c | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit b9a91594f4b37388222b587eaea7618ea8c78381
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Feb 26 09:48:43 2010 +0000

    build: Fixes out of tree builds
    
    When building the gobject introspection data the build wasn't able to
    find clutter/clutter-json.h so this adds $(top_builddir) to INCLUDES.

 clutter/Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 79acb088e7f6916fb77a6341c22f9022c0f50208
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 1 12:56:10 2010 +0000

    Remove mentions of the FSF address
    
    Since using addresses that might change is something that finally
    the FSF acknowledge as a plausible scenario (after changing address
    twice), the license blurb in the source files should use the URI
    for getting the license in case the library did not come with it.
    
    Not that URIs cannot possibly change, but at least it's easier to
    set up a redirection at the same place.
    
    As a side note: this commit closes the oldes bug in Clutter's bug
    report tool.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=521

 clutter/clutter-actor.c                                |  7 +++----
 clutter/clutter-actor.h                                |  3 ++-
 clutter/clutter-alpha.c                                |  6 ++----
 clutter/clutter-backend.c                              | 11 ++++++-----
 clutter/clutter-behaviour-depth.c                      |  4 +---
 clutter/clutter-behaviour-ellipse.c                    | 10 +---------
 clutter/clutter-behaviour-opacity.c                    |  4 +---
 clutter/clutter-behaviour-path.c                       | 11 ++++++-----
 clutter/clutter-behaviour-rotate.c                     |  4 +---
 clutter/clutter-behaviour-scale.c                      |  4 +---
 clutter/clutter-behaviour.c                            |  4 +---
 clutter/clutter-bezier.c                               |  4 +---
 clutter/clutter-cairo-texture.c                        |  6 ++----
 clutter/clutter-cairo-texture.h                        |  7 +++----
 clutter/clutter-child-meta.c                           |  4 +---
 clutter/clutter-color.c                                |  4 +---
 clutter/clutter-container.c                            |  6 +++---
 clutter/clutter-event.c                                |  6 +++---
 clutter/clutter-feature.c                              |  6 +++---
 clutter/clutter-fixed.c                                |  6 +++---
 clutter/clutter-frame-source.c                         |  6 +++---
 clutter/clutter-group.c                                |  6 +++---
 clutter/clutter-id-pool.c                              |  6 +++---
 clutter/clutter-keysyms.h                              |  6 +++---
 clutter/clutter-list-model.c                           |  6 +++---
 clutter/clutter-main.c                                 |  6 +++---
 clutter/clutter-model.c                                |  6 +++---
 clutter/clutter-private.h                              |  6 +++---
 clutter/clutter-rectangle.c                            |  6 +++---
 clutter/clutter-score.c                                |  6 +++---
 clutter/clutter-script-parser.c                        |  6 +++---
 clutter/clutter-script-private.h                       |  6 +++---
 clutter/clutter-script.c                               |  6 +++---
 clutter/clutter-scriptable.c                           |  6 +++---
 clutter/clutter-shader-types.c                         |  6 +++---
 clutter/clutter-shader.c                               |  6 +++---
 clutter/clutter-stage.c                                |  6 +++---
 clutter/clutter-texture.c                              |  6 +++---
 clutter/clutter-timeline.c                             |  6 +++---
 clutter/clutter-timeout-pool.c                         |  6 +++---
 clutter/clutter-units.c                                |  6 +++---
 clutter/clutter-util.c                                 |  6 +++---
 clutter/clutter-version.h.in                           |  6 +++---
 clutter/clutter.h                                      |  6 +++---
 clutter/cogl/cogl/cogl-atlas-texture-private.h         |  6 +++---
 clutter/cogl/cogl/cogl-atlas-texture.c                 |  6 +++---
 clutter/cogl/cogl/cogl-atlas.c                         |  6 +++---
 clutter/cogl/cogl/cogl-atlas.h                         |  6 +++---
 clutter/cogl/cogl/cogl-bitmap-fallback.c               |  6 +++---
 clutter/cogl/cogl/cogl-bitmap-pixbuf.c                 |  6 +++---
 clutter/cogl/cogl/cogl-bitmap-private.h                |  6 +++---
 clutter/cogl/cogl/cogl-bitmap.c                        |  6 +++---
 clutter/cogl/cogl/cogl-bitmap.h                        |  6 +++---
 clutter/cogl/cogl/cogl-blend-string.c                  |  6 +++---
 clutter/cogl/cogl/cogl-blend-string.h                  |  6 +++---
 clutter/cogl/cogl/cogl-buffer-private.h                |  6 +++---
 clutter/cogl/cogl/cogl-buffer.c                        |  6 +++---
 clutter/cogl/cogl/cogl-buffer.h                        |  6 +++---
 clutter/cogl/cogl/cogl-clip-stack.c                    |  6 +++---
 clutter/cogl/cogl/cogl-clip-stack.h                    |  6 +++---
 clutter/cogl/cogl/cogl-color.c                         |  6 +++---
 clutter/cogl/cogl/cogl-color.h                         |  6 +++---
 clutter/cogl/cogl/cogl-context.c                       |  6 +++---
 clutter/cogl/cogl/cogl-context.h                       |  6 +++---
 clutter/cogl/cogl/cogl-debug.c                         |  6 +++---
 clutter/cogl/cogl/cogl-debug.h                         |  6 +++---
 clutter/cogl/cogl/cogl-deprecated.h                    |  6 +++---
 clutter/cogl/cogl/cogl-feature-private.c               |  6 +++---
 clutter/cogl/cogl/cogl-feature-private.h               |  6 +++---
 clutter/cogl/cogl/cogl-fixed.c                         |  6 +++---
 clutter/cogl/cogl/cogl-fixed.h                         |  6 +++---
 clutter/cogl/cogl/cogl-framebuffer-private.h           |  6 +++---
 clutter/cogl/cogl/cogl-framebuffer.c                   |  6 +++---
 clutter/cogl/cogl/cogl-handle.h                        |  6 +++---
 clutter/cogl/cogl/cogl-internal.h                      |  6 +++---
 clutter/cogl/cogl/cogl-journal-private.h               |  6 +++---
 clutter/cogl/cogl/cogl-journal.c                       |  6 +++---
 clutter/cogl/cogl/cogl-material-private.h              |  6 +++---
 clutter/cogl/cogl/cogl-material.c                      |  6 +++---
 clutter/cogl/cogl/cogl-material.h                      |  6 +++---
 clutter/cogl/cogl/cogl-matrix-mesa.c                   |  6 +++---
 clutter/cogl/cogl/cogl-matrix-mesa.h                   |  6 +++---
 clutter/cogl/cogl/cogl-matrix-private.h                |  6 +++---
 clutter/cogl/cogl/cogl-matrix-stack.c                  |  6 +++---
 clutter/cogl/cogl/cogl-matrix-stack.h                  |  6 +++---
 clutter/cogl/cogl/cogl-matrix.c                        |  6 +++---
 clutter/cogl/cogl/cogl-matrix.h                        |  6 +++---
 clutter/cogl/cogl/cogl-offscreen.h                     |  6 +++---
 clutter/cogl/cogl/cogl-path.c                          |  6 +++---
 clutter/cogl/cogl/cogl-path.h                          |  6 +++---
 clutter/cogl/cogl/cogl-pixel-buffer-private.h          |  6 +++---
 clutter/cogl/cogl/cogl-pixel-buffer.c                  |  6 +++---
 clutter/cogl/cogl/cogl-pixel-buffer.h                  |  6 +++---
 clutter/cogl/cogl/cogl-primitives.c                    |  6 +++---
 clutter/cogl/cogl/cogl-primitives.h                    |  6 +++---
 clutter/cogl/cogl/cogl-profile.h                       |  6 +++---
 clutter/cogl/cogl/cogl-shader.h                        |  6 +++---
 clutter/cogl/cogl/cogl-spans.c                         |  6 +++---
 clutter/cogl/cogl/cogl-spans.h                         |  6 +++---
 clutter/cogl/cogl/cogl-sub-texture-private.h           |  6 +++---
 clutter/cogl/cogl/cogl-sub-texture.c                   |  6 +++---
 clutter/cogl/cogl/cogl-texture-2d-private.h            |  6 +++---
 clutter/cogl/cogl/cogl-texture-2d-sliced-private.h     |  6 +++---
 clutter/cogl/cogl/cogl-texture-2d-sliced.c             |  6 +++---
 clutter/cogl/cogl/cogl-texture-2d.c                    |  6 +++---
 clutter/cogl/cogl/cogl-texture-driver.h                |  6 +++---
 clutter/cogl/cogl/cogl-texture-private.h               |  6 +++---
 clutter/cogl/cogl/cogl-texture.c                       |  6 +++---
 clutter/cogl/cogl/cogl-texture.h                       |  6 +++---
 clutter/cogl/cogl/cogl-types.h                         |  6 +++---
 clutter/cogl/cogl/cogl-util.c                          |  6 +++---
 clutter/cogl/cogl/cogl-util.h                          |  6 +++---
 clutter/cogl/cogl/cogl-vertex-buffer-private.h         |  6 +++---
 clutter/cogl/cogl/cogl-vertex-buffer.c                 |  6 +++---
 clutter/cogl/cogl/cogl-vertex-buffer.h                 |  6 +++---
 clutter/cogl/cogl/cogl.c                               |  6 +++---
 clutter/cogl/cogl/cogl.h                               |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-context-driver.c      |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-context-driver.h      |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-defines.h.in          |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-feature-functions.h   |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-program.c             |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-program.h             |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-shader-private.h      |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-shader.c              |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl-texture-driver.c      |  6 +++---
 clutter/cogl/cogl/driver/gl/cogl.c                     |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-context-driver.c    |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-context-driver.h    |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-defines.h.in        |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-feature-functions.h |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c     |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h     |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-program.c           |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-program.h           |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-shader-private.h    |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-shader.c            |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl-texture-driver.c    |  6 +++---
 clutter/cogl/cogl/driver/gles/cogl.c                   |  6 +++---
 clutter/cogl/cogl/winsys/cogl-eglnative.c              |  6 +++---
 clutter/cogl/cogl/winsys/cogl-eglx.c                   |  6 +++---
 clutter/cogl/cogl/winsys/cogl-fruity.c                 |  6 +++---
 clutter/cogl/cogl/winsys/cogl-glx.c                    |  6 +++---
 clutter/cogl/cogl/winsys/cogl-osx.c                    |  6 +++---
 clutter/cogl/cogl/winsys/cogl-sdl.c                    |  6 +++---
 clutter/cogl/cogl/winsys/cogl-win32.c                  |  6 +++---
 clutter/cogl/cogl/winsys/cogl-winsys.h                 |  6 +++---
 clutter/eglnative/clutter-backend-egl.h                |  6 +++---
 clutter/eglnative/clutter-egl-headers.h                |  6 +++---
 clutter/eglnative/clutter-egl.h                        |  6 +++---
 clutter/eglnative/clutter-event-egl.c                  |  6 +++---
 clutter/eglx/clutter-backend-egl.h                     |  6 +++---
 clutter/eglx/clutter-egl-headers.h                     |  6 +++---
 clutter/eglx/clutter-eglx.h                            |  6 +++---
 clutter/fruity/clutter-backend-fruity.h                |  6 +++---
 clutter/fruity/clutter-fruity.h                        |  6 +++---
 clutter/glx/clutter-backend-glx.c                      |  6 +++---
 clutter/glx/clutter-backend-glx.h                      |  6 +++---
 clutter/glx/clutter-event-glx.c                        |  6 +++---
 clutter/glx/clutter-event-glx.h                        |  6 +++---
 clutter/glx/clutter-glx-texture-pixmap.c               |  6 +++---
 clutter/glx/clutter-glx-texture-pixmap.h               |  6 +++---
 clutter/glx/clutter-glx.h                              |  6 +++---
 clutter/glx/clutter-stage-glx.c                        |  6 +++---
 clutter/glx/clutter-stage-glx.h                        |  6 +++---
 clutter/osx/clutter-backend-osx.c                      |  6 +++---
 clutter/osx/clutter-backend-osx.h                      |  6 +++---
 clutter/osx/clutter-event-osx.c                        |  6 +++---
 clutter/osx/clutter-osx.h                              |  6 +++---
 clutter/osx/clutter-stage-osx.c                        |  6 +++---
 clutter/osx/clutter-stage-osx.h                        |  6 +++---
 clutter/win32/clutter-backend-win32.c                  |  6 +++---
 clutter/win32/clutter-backend-win32.h                  |  6 +++---
 clutter/win32/clutter-event-win32.c                    |  6 +++---
 clutter/win32/clutter-stage-win32.c                    |  6 +++---
 clutter/win32/clutter-stage-win32.h                    |  6 +++---
 clutter/win32/clutter-win32.h                          |  6 +++---
 clutter/x11/clutter-backend-x11-private.h              |  6 +++---
 clutter/x11/clutter-backend-x11.c                      |  6 +++---
 clutter/x11/clutter-backend-x11.h                      |  6 +++---
 clutter/x11/clutter-event-x11.c                        |  6 +++---
 clutter/x11/clutter-stage-x11.c                        |  6 +++---
 clutter/x11/clutter-stage-x11.h                        |  6 +++---
 clutter/x11/clutter-x11-texture-pixmap.c               |  6 +++---
 clutter/x11/clutter-x11-texture-pixmap.h               |  6 +++---
 clutter/x11/clutter-x11.h                              |  6 +++---
 186 files changed, 543 insertions(+), 570 deletions(-)

commit 23867875a14ab6d7288d6a67c67b20a1f136be94
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 1 11:12:16 2010 +0000

    build: Remove unused checks on platform functions
    
    There is no need for us to check for low-level functions and header
    files, especially since we haven't been checking the results until
    now. This makes cross-compiling slightly more bearable.

 clutter/clutter-private.h         |  8 ++------
 clutter/x11/clutter-backend-x11.c |  9 +++++----
 clutter/x11/clutter-stage-x11.c   |  4 ++++
 configure.ac                      | 12 +++---------
 4 files changed, 14 insertions(+), 19 deletions(-)

commit ce6a24eb2b5eaba4b60f82855af7a24d0f5afdad
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Feb 28 10:59:29 2010 +0000

    actor: Call unparent() in destroy
    
    If the actor is an internal child of another actor then we should call
    unparent() when destroying it, like clutter_actor_reparent() does;
    otherwise we'll leak the actor, since the parent holds a reference to
    it.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2009

 clutter/clutter-actor.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 7ffb62eab939de46b8234243cab6f6c4b40d60ec
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Feb 27 18:56:34 2010 +0000

    docs: Update minimum size accessors
    
    Expand the documentation for set_minimum_size() and get_minimum_size(),
    and add introspection annotations for get_minimum_size().

 clutter/clutter-stage.c | 41 +++++++++++++++++++++++++++++------------
 1 file changed, 29 insertions(+), 12 deletions(-)

commit 52ba9a1800302f887ebe6d2e7aa7ab4503ea6e5e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Feb 27 18:24:17 2010 +0000

    actor: Use the TOPLEVEL flag instead of a type check
    
    We can use the internal private CLUTTER_ACTOR_IS_TOPLEVEL flag, which is
    set only on Stages.

 clutter/clutter-actor.c | 19 +++++++++++++++----
 1 file changed, 15 insertions(+), 4 deletions(-)

commit cd62dfbd1419870fb6792bcab87ea8e7d0e760f5
Author: Chris Lord <chris@linux.intel.com>
Date:   Fri Feb 26 18:36:38 2010 +0000

    [stage] Use min-width/height props for min size
    
    Instead of shadowing these properties with different properties with the
    same names on stage, actually use them. Behaviour should be identical,
    except the minimum stage size can now be enforced by setting the
    min-width/height properties as well as using the set_minimum_size
    function.

 clutter/clutter-actor.c |  13 ++++--
 clutter/clutter-stage.c | 102 ++++++++++++++++++++++++++++++++----------------
 2 files changed, 77 insertions(+), 38 deletions(-)

commit 9f67e4826c9880732e4f2a74ac42f729e7e80042
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 26 16:43:02 2010 +0000

    docs: Update --enable-cogl-debug description
    
    The 'no' value is not the default any more. The 'minimum' value is
    always the default, regardless of the release status.

 README | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 62f2961f8a9b2974e0a7a11ea534f0b14f8fef1a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 26 15:12:27 2010 +0000

    docs: Unicode-ify NEWS

 NEWS | 1302 +++++++++++++++++++++++++++++++++---------------------------------
 1 file changed, 651 insertions(+), 651 deletions(-)

commit c8c62af0cf5d33f3fe3e4aab44ed49363263252c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 26 15:00:47 2010 +0000

    build: More options for Automake
    
    Require automake >= 1.10, and add the following options:
    
      » dist-bzip2: create a bz2 tarball in the dist process
      » check-news: check that we changed the NEWS file prior to dist,
        to avoid another release without NEWS updates, like 1.1.10

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e0f04efa411c0987db32c056958ad2c7cf5b6736
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 26 10:36:17 2010 +0000

    device: When changing the stage, unset the pointer actor
    
    If we do not unset the Stage we will have stale data, and the Crossing
    event when re-entering a Stage will not be emitted, as the actor under
    the pointer might be the same as before.

 clutter/clutter-input-device.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit 5d8346829585bb4b6d4617a232f87e3dab4eee5f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 23 14:45:44 2010 +0000

    cogl-vertex-buffer: Add support for unsigned int indices
    
    This adds a COGL_INDICES_TYPE_UNSIGNED_INT enum value so that unsigned
    ints can be used with cogl_vertex_buffer_indices_new.  Unsigned ints
    are not supported in core on GLES so a feature flag has also been
    added to advertise this. GLES only sets the feature if the
    GL_OES_element_index_uint extension is available. It is an error to
    call indices_new() with unsigned ints unless the feature is
    advertised.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1998

 clutter/cogl/cogl/cogl-types.h                         |  6 +++++-
 clutter/cogl/cogl/cogl-vertex-buffer.c                 | 17 ++++++++++++++++-
 clutter/cogl/cogl/cogl-vertex-buffer.h                 |  8 ++++++++
 clutter/cogl/cogl/driver/gl/cogl.c                     |  3 ++-
 clutter/cogl/cogl/driver/gles/cogl-feature-functions.h |  6 ++++++
 5 files changed, 37 insertions(+), 3 deletions(-)

commit 67d9d928147aa59905960480a5d0b4c19c9d1920
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 23:23:53 2010 +0000

    docs: Document the "columns" syntax for ClutterModel
    
    Like we do for other classes implementing custom properties, we should
    document the syntax of the "columns" scriptable property of ClutterModel.

 clutter/clutter-model.c | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit 70d7bad98ba50a657204ee356fd5ac5ccf4e8bea
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 23:15:59 2010 +0000

    conformance: Use g_test_verbose() for logging
    
    Protect g_print() calls behind the g_test_verbose() check, to avoid
    unwanted output during the conformance test run.

 tests/conform/test-model.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 96c31bbf0ea14c7cb6eaa824a6d5cf66d58b8d5b
Author: Bastian Winkler <buz@netbuz.org>
Date:   Thu Feb 25 23:47:49 2010 +0100

    model: Implement ClutterScriptable interface
    
    Allow a ClutterModel to be constructed through the ClutterScript API.
    Currently this allows a model to be generated like like this:
    
    {
      "id" : "test-model",
      "type" : "ClutterListModel",
      "columns" : [
        [ "text-column", "gchararray" ],
        [ "int-column", "gint" ],
        [ "actor-column", "ClutterRectangle" ]
      ]
    }
    
    where 'columns' is an array containing arrays of column-name,
    column-type pairs.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2007

 .gitignore                        |   1 +
 clutter/clutter-model.c           | 105 +++++++++++++++++++++++++++++++++++++-
 tests/conform/test-conform-main.c |   1 +
 tests/conform/test-model.c        |  34 ++++++++++++
 tests/data/test-script-model.json |   9 ++++
 5 files changed, 149 insertions(+), 1 deletion(-)

commit 63279f827e9d4e517c3dc88633a8b5ed47fbd74e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 22:50:38 2010 +0000

    docs: gtk-doc fixes for Animator
    
    Fix the syntax for:
    
      → enumeration values
      → return values
      → @since tags
    
    Also, fix the introspection annotations.

 clutter/clutter-animator.c | 40 +++++++++++++++++++++++++++-------------
 1 file changed, 27 insertions(+), 13 deletions(-)

commit 9db135c4eff97a3d3520cc05c9c3e85c153e8cc4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 18:28:37 2010 +0000

    glx: Clean up sync-to-vblank mechanism discovery
    
    The code has gotten really complicated to follow.
    
    As soon as we have a sync-to-vblank mechanism we should just bail out.
    
    Also, __GL_SYNC_TO_VBLANK (which is used by nVidia) should be assumed
    equivalent to a CLUTTER_VBLANK_GLX_SWAP.

 clutter/glx/clutter-backend-glx.c | 169 +++++++++++++++++++++-----------------
 1 file changed, 92 insertions(+), 77 deletions(-)

commit 655cb966c08b0ec3a0b73ed1b18fc9ebbe9a93b8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 17:09:55 2010 +0000

    docs: Add visual cue for Animator's key frames
    
    We should explain what a "key frame" is for ClutterAnimator, possibly
    with some sort of visual cue.
    
    This allows me to demonstrate my poor skills at using Inkscape, as well
    as my overall bad taste for graphics design.

 clutter/clutter-animator.c                    |  21 ++
 doc/reference/clutter/Makefile.am             |   3 +
 doc/reference/clutter/animator-key-frames.png | Bin 0 -> 11936 bytes
 doc/reference/clutter/animator-key-frames.svg | 271 ++++++++++++++++++++++++++
 4 files changed, 295 insertions(+)

commit d3d05261e6a394736757cebb5aad9b9267e7cf53
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 14:22:08 2010 +0000

    script-parser: Remove top-level types list
    
    The top-level types list was comically out of date, and it was only
    determining whether the type we were constructing was initially unowned
    or a full object. We can safely replace it with a simple type check.

 clutter/clutter-script-parser.c | 36 ++++--------------------------------
 1 file changed, 4 insertions(+), 32 deletions(-)

commit c0be19eff65c4c72aa5c934cee3b582903db40f6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 14:20:05 2010 +0000

    script-parser: Be more strict with "children" members
    
    The "children" member for Container definitions should only reference
    actors, and warn about any other type.

 clutter/clutter-script-parser.c | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit c291d5a660f4ebac3dc57acad79b8153686a47f0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 14:08:57 2010 +0000

    animator: Add a :timeline property
    
    It would be useful to be able to share the Timeline across different
    animator instances, or with different animation constructs. Also this
    allows sharing definitions of Timelines in ClutterScript.

 clutter/clutter-animator.c | 26 +++++++++++++++++++++++++-
 1 file changed, 25 insertions(+), 1 deletion(-)

commit 641582533952c91576fb53724b70cbe6afb119db
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 14:02:29 2010 +0000

    animator: Remove NULL check in remove_key()
    
    The arguments for remove_key() can be NULL, but there is an extraneous
    assertion that fails if they are. The pre-conditions should match the
    documentation, in this case.

 clutter/clutter-animator.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 4bc4c604e926b07af9ef4c02fd5f000fc939259b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 12:45:02 2010 +0000

    box: Let pack_at() create the ChildMeta, if any
    
    A sub-class of ClutterBox might add ChildMeta support, and since
    pack_at() does not go through clutter_container_add_actor(), we
    need to manually call the create_child_meta() ourselves.

 clutter/clutter-box.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 543e2d3f0609864cebb1f1eaf258108abab50770
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 12:39:24 2010 +0000

    container: Expose create and destroy ChildMeta methods
    
    It is conceivable that Container implementations might add children
    outside of the Container::add() implementation - e.g. for packing at
    a specific index. Since the addition (and removal) might happen outside
    the common path we need to expose all the API that is implicitly called
    by ClutterContainer when adding and removing a child - namely the
    ChildMeta creation and destruction.

 clutter/clutter-container.c                | 44 ++++++++++++++++++++++--------
 clutter/clutter-container.h                |  4 +++
 doc/reference/clutter/clutter-sections.txt |  2 ++
 3 files changed, 38 insertions(+), 12 deletions(-)

commit 31b5856d69e8d53de17270da7ab59dd290e2868a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 24 23:04:39 2010 +0000

    test-cogl-blend-strings: Add some more tests
    
    The adds tests for the remaining layer combine functions, the 1 minus
    value operator and the TEXTURE_N source. Note however that Cogl
    currently fails when parsing a TEXTURE_N source so the test is
    commented out.

 tests/conform/test-cogl-blend-strings.c | 46 +++++++++++++++++++++++++++++++++
 1 file changed, 46 insertions(+)

commit 14999bec5e6b3d0aab057ef544f233d968e5cf67
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 24 11:13:55 2010 +0000

    gles2: Remove the special wrapper for glBindTexture
    
    Previously the GLES2 backend needed a special wrapper for
    glBindTexture because it needed to know the internal GL format of the
    texture in order to correctly implement the GL_MODULATE texture env
    mode. When GL_MODULATE is used then the RGB values are taken from the
    previous texture layer rather than being fetched from the
    texture. However since the material API was added Cogl no longer uses
    the GL_MODULATE texture env mode but instead always uses GL_COMBINE.
    
    Compiling the GLES2 backend broke since the more-texture-backends
    branch merge because the cogl_get_internal_gl_format function was
    removed and there was one place in GLES2 specific code that was using
    this to bind the texture.

 clutter/cogl/cogl/cogl-material.c                  | 10 ----------
 clutter/cogl/cogl/cogl-texture-2d-sliced.c         |  5 ++---
 clutter/cogl/cogl/cogl-texture-driver.h            |  7 -------
 clutter/cogl/cogl/driver/gl/cogl-texture-driver.c  | 12 ------------
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c | 22 ----------------------
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h | 12 ------------
 .../cogl/cogl/driver/gles/cogl-texture-driver.c    | 13 -------------
 7 files changed, 2 insertions(+), 79 deletions(-)

commit eba07020c549ff0ede9982c6d911d67e353ca5a3
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 24 16:50:32 2010 +0000

    cogl-gles2-wrapper: Add support for the layer combine operations
    
    The texture layer combine functions are now hard coded to GL_COMBINE
    instead of GL_MODULATE. The combine function can be customized with
    all the parameters of GL_COMBINE. A shader is generated to implement
    the given parameters.
    
    Currently it will try to generate code for the constant color but it
    will use a uniform which does not exist.

 clutter/cogl/cogl/cogl-blend-string.c              |   9 -
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c | 382 +++++++++++++++++++--
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h |  16 +
 3 files changed, 371 insertions(+), 36 deletions(-)

commit 02b952394ae9efe9e80b803e671bca1b1f711a9a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 24 10:42:59 2010 +0000

    gles2: Implement a wrapper for glGetIntegerv(GL_MAX_TEXTURE_UNITS)
    
    The GLES2 backend for Cogl is failing to compile because
    GL_MAX_TEXTURE_UNITS is not defined. Let's define it and provide a
    wrapper which uses GL_MAX_TEXTURE_IMAGE_UNITS or
    COGL_GLES2_MAX_TEXTURE_UNITS, whichever is the smallest.

 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c | 6 ++++++
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h | 2 ++
 2 files changed, 8 insertions(+)

commit 3bc0672feff7c58326c4d50612bedf15aa9c02cb
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Thu Feb 25 12:30:07 2010 +0000

    animator: handle no initial key
    
    Fixing the crasher reported in bug #1995.

 clutter/clutter-animator.c | 108 +++++++++++++++++++++++++++------------------
 1 file changed, 65 insertions(+), 43 deletions(-)

commit d2db512788aac496a3741cb424caea41cf4357a1
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Thu Feb 25 11:48:44 2010 +0000

    animator: added clutter_animator_compute_value
    
    Allow querying the computed values of properties managed by a
    ClutterAnimator.

 clutter/clutter-animator.c | 212 ++++++++++++++++++++++++++++++++++++++++++---
 clutter/clutter-animator.h |  12 +++
 2 files changed, 211 insertions(+), 13 deletions(-)

commit e8d32fd153268c653c1adc5c66f30f0ee624b432
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Thu Feb 25 11:28:32 2010 +0000

    animator: removed bogus arg in keys interpolation accessor
    
    A bogus ClutterInterpolation argument had been carried from
    clutter_animator_set_interpolation to clutter_animator_get_interpolation
    in copy and paste.

 clutter/clutter-animator.c | 16 +++++++---------
 clutter/clutter-animator.h |  3 +--
 2 files changed, 8 insertions(+), 11 deletions(-)

commit be8f53f229397e72fcf5a1bed245d555ea4747e9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 12:01:03 2010 +0000

    animation: Fix a typo
    
    This will teach me to check before compiling a version-dependent branch
    that I'm actually using my jhbuild environment and not the system
    libraries.

 clutter/clutter-animation.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 26e22b2ede0eb0fdfbe3d96189cb2aa196da83f8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 25 10:22:36 2010 +0000

    Conditionally use G_VALUE_COLLECT_INIT() macro
    
    GLib 2.24 (but starting from the 2.23.2 unstable release) added a new
    macro for collecting GValues from a va_list.
    
    The newly added G_VALUE_COLLECT_INIT() macro should be used in place
    of initializing the GValue and calling G_VALUE_COLLECT(), and improves
    the collection performances by avoiding multiple checks, free and
    initialization calls.

 clutter/clutter-animation.c      |  8 ++++++++
 clutter/clutter-animator.c       |  7 ++++++-
 clutter/clutter-box.c            |  7 +++++++
 clutter/clutter-container.c      |  7 +++++++
 clutter/clutter-interval.c       | 10 ++++++++++
 clutter/clutter-layout-manager.c |  7 +++++++
 6 files changed, 45 insertions(+), 1 deletion(-)

commit bd303d6efb7dfddbdf671f7c66ff5b73bb216f3f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 16:43:17 2010 +0000

    conform: Verify parsing of multiple properties
    
    The ClutterAnimator support for parsing multiple properties should be
    verified in the conformance test suite.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2003

 .gitignore                        |  1 +
 tests/conform/test-animator.c     | 98 +++++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c |  1 +
 tests/data/test-animator-3.json   | 40 ++++++++++++++++
 4 files changed, 140 insertions(+)

commit 59fd7e4a810f51bad31c2eafb609d545557ef264
Author: Bastian Winkler <buz@netbuz.org>
Date:   Wed Feb 24 16:32:19 2010 +0100

    animator: Append parsed animator keys to previously parsed ones
    
    Reuse the GSList of the previously parsed property when building a
    ClutterAnimator from script, otherwise only the last used property will
    be used
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2003

 clutter/clutter-animator.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit fd6f6707433a8ab57c8232afee65038213d4120c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 14:40:22 2010 +0000

    Post-release version bump to 1.1.15

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 18659b008c800b2dde6e5a2453fba04f5990f2b7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 14:26:46 2010 +0000

    Release 1.1.14

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ec0c7fcd9bb734c3fd488b4b3ec3d469ba5e967f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 14:23:58 2010 +0000

    build: Use the right headers when enumerating them
    
    The installed _HEADERS should be the public ones and the enumeration
    types; repeating clutter-x11-texture-pixmap.h breaks with automake 1.11
    and doesn't strictly make any sense.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=2002

 clutter/x11/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1370d72a7a1490c1ed60f02634f146995482116d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 14:20:14 2010 +0000

    Update NEWS file

 NEWS | 44 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 44 insertions(+)

commit d1ca0e1b8f3dc6f5b5fec0ce3fba4702b9e75386
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 12:23:46 2010 +0000

    fixed layout: Store a back pointer to the Container
    
    When set_container() is called with a NULL container we cannot use the
    passed pointer to unset the CLUTTER_ACTOR_NO_LAYOUT flag. We should
    store a back pointer to the container as object data (there's no need
    to add a Private data structure in this case) and unset the flag on the
    back pointer instead.

 clutter/clutter-fixed-layout.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit 3a9d842164708baa8fe877d829f9e9cdcbde3831
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 12:09:13 2010 +0000

    conformance: Show the Stage to test invariants
    
    We need to make the Stage set the MAPPED flag on itself if we want to
    verify the MAPPED state. That was always the case - it just worked
    before because the Stage was shown at least once.

 tests/conform/test-actor-invariants.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit aa8c8127059326c2d13d9f8dd6a294e787e3760e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 12:08:07 2010 +0000

    box: Do not short-circuit size negotiation for empty Boxes
    
    The LayoutManager used might decide to have a default allocation or a
    default preferred size when empty.

 clutter/clutter-box.c | 31 -------------------------------
 1 file changed, 31 deletions(-)

commit 523bab0868255e3f2b2910a60a868bffeb5bf64a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Feb 11 11:45:36 2010 +0000

    layout: allow wider use of the CLUTTER_ACTOR_NO_LAYOUT flag
    
    Previously only ClutterGroup was able to set the CLUTTER_ACTOR_NO_LAYOUT
    flag which allows clutter-actor.c to avoid a relayout when showing or
    hiding fixed layout containers. Instead of it being the responsibility
    of the container to set this flag this patch makes the layout manager
    itself decide in the ::set_container method. This way both ClutterBox
    and ClutterGroup can take advantage of the optimization.

 clutter/clutter-fixed-layout.c | 17 +++++++++++++++++
 clutter/clutter-group.c        |  8 +++-----
 2 files changed, 20 insertions(+), 5 deletions(-)

commit f21e649c80a3e0db5db7dc1128f7828535dbebc2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 11:28:44 2010 +0000

    docs: Detail replacement for cogl_check_extension()
    
    The cogl_check_extension() function has been deprecated, but it's easily
    replaceable with a simple strstr() call.

 clutter/cogl/cogl/cogl.h | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit 829d3f4bc5d083320f7f1b70d25e0115e1b6512f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 11:27:51 2010 +0000

    docs: Update NEWS and README
    
    The NEWS file was not updated for the 1.1.12 release, so we need to
    update it now.
    
    The Release Notes section for Clutter and Cogl also needs some more
    entries that escaped previous releases.

 NEWS   | 33 +++++++++++++++++++++++++++++++++
 README | 21 +++++++++++++++++++++
 2 files changed, 54 insertions(+)

commit d54af2363d390bf598aaa931821a46604d4f192a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 24 10:20:10 2010 +0000

    build: Use template for ClutterX11 enumerationt types
    
    Clutter and Cogl use the template Makefile.am.enums for building the
    enumeration GTypes from public headers, but ClutterX11 is not.

 .gitignore              | 13 ++++-----
 clutter/x11/Makefile.am | 77 ++++++++++++++++++++-----------------------------
 2 files changed, 37 insertions(+), 53 deletions(-)

commit eb35c446b119274658ba45937e02b5cfd1ec27fe
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 23 22:06:59 2010 +0000

    clutter-box: Layer new actors on top of all others at the same depth
    
    g_list_insert_sorted inserts the new actor before all others that
    compare equal so for the normal case when all actors have depth==0
    this has the surprising behaviour of layering the actors in reverse
    order. To fix this it now manually inserts the actor in the right
    place by searching until it finds an actor at a higher depth and
    inserting before that.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1988

 clutter/clutter-box.c | 25 ++++++++++++++++++++++---
 1 file changed, 22 insertions(+), 3 deletions(-)

commit da0315e4d666cc7cbfcfe7dab63d731df2a02338
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 23 22:10:30 2010 +0000

    box: Revert "Tweak the depth sorting function"
    
    This reverts commit 939e56e2b12e5c96fa1173be33c2786ddfe57c25.
    
    Changing the depth sort function to have inconsistent behaviour for
    nodes that compare equal breaks the stability of g_list_sort. It ends
    up so that every time clutter_container_sort_depth_order is called the
    order of all actors with the same depth is reversed.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1988

 clutter/clutter-box.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1c65f2ee1e4595d3044d05cadb4f33fc2d03a6f3
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 17 18:45:08 2010 +0000

    cogl debug: Adds glViewport call tracing
    
    To aid in the debugging of Clutter stage resize issues this adds a
    COGL_DEBUG=opengl option that will trace "some select OpenGL calls"
    (currently just glViewport calls)

 clutter/cogl/cogl/cogl-debug.c       | 2 ++
 clutter/cogl/cogl/cogl-debug.h       | 3 ++-
 clutter/cogl/cogl/cogl-framebuffer.c | 6 ++++++
 3 files changed, 10 insertions(+), 1 deletion(-)

commit fa3830ff20962dc72b676a5411a7fa1829a870cd
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 17 17:53:28 2010 +0000

    cogl debug: hint that all debugging paths are G_UNLIKELY
    
    Most Cogl debugging code conditions are marked as G_UNLIKELY with the
    intention of having the CPU branch prediction always assume the
    path is disabled so having debugging support in release binaries has
    negligible overhead.
    
    This patch simply fixes a few cases where we weren't using G_UNLIKELY.

 clutter/cogl/cogl/cogl-journal.c | 9 +++++----
 clutter/cogl/cogl/cogl.c         | 2 +-
 2 files changed, 6 insertions(+), 5 deletions(-)

commit a58d6e8ee5e26185ff090845df68b61076275c21
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 17 17:40:57 2010 +0000

    cogl debug: Support "minimum" level debugging by default
    
    We basically want all Clutter applications out in the wild to at least
    have the basic set of COGL_DEBUG/--cogl-debug options available for
    investigating issues.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 511e5ceb516dcbf2c406a7c2e8e0e56d2135fb0d
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 17 14:38:11 2010 +0000

    cogl debug: Makes COGL_DEBUG=all|verbose|help more useful
    
    COGL_DEBUG=all wasn't previously useful as there are several options
    that change the behaviour of Cogl and all together wouldn't help anyone
    debug anything.
    
    This patch makes it so COGL_DEBUG=all|verbose now only enables options
    that don't change the behaviour of Cogl, i.e. they only affect the
    amount of noise we'll print to a terminal.
    
    In addition to that this patch also improves the output from
    COGL_DEBUG=help so we now print a table of options including one liner
    descriptions of what each option enables.

 clutter/cogl/cogl/cogl-debug.c             | 121 ++++++++++++++++++++++-------
 clutter/cogl/cogl/cogl-debug.h             |  37 ++++-----
 clutter/cogl/cogl/cogl-texture-2d-sliced.c |   2 +-
 3 files changed, 111 insertions(+), 49 deletions(-)

commit 939e56e2b12e5c96fa1173be33c2786ddfe57c25
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 23 17:59:09 2010 +0000

    box: Tweak the depth sorting function
    
    By changing the depth sorting function we can achieve the same effect as
    ClutterGroup but without the costly append+sort.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1988

 clutter/clutter-box.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 95960ab902852e9c4830815b89d0a315fb9e4c50
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 23 16:51:26 2010 +0000

    cogl: Add deprecation annotation to CoglMaterial ref/unref
    
    The G_GNUC_DEPRECATED annotation was missing from the material ref and
    unref functions.

 clutter/cogl/cogl/cogl-material.h | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a9941e94995d2701783f055e69fba52a64f609e0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 20:08:35 2010 +0000

    debug: Split debugging notes from behavioural modifiers
    
    Some of the ClutterDebugFlags are not meant as a logging facility: they
    actually change Clutter's behaviour at run-time.
    
    It would be useful to have this distinction ratified, and thus split
    ClutterDebugFlags into two: one DebugFlags for logging facilities and
    another set of flags for behavioural changes.
    
    This split is warranted because:
    
      • it should be possible to do "CLUTTER_DEBUG=all" and only have
        log messages on the output
    
      • it should be possible to use behavioural modifiers even on a
        Clutter that has been compiled without debugging messages
        support
    
    The commit adds two new debugging flags:
    
      ClutterPickDebugFlags - controlled by the CLUTTER_PICK environment
                              variable
    
      ClutterPaintDebugFlags - controlled by the CLUTTER_PAINT environment
                               variable
    
    The PickDebugFlags are:
    
      nop-picking
      dump-pick-buffers
    
    While the PaintDebugFlags is:
    
      disable-swap-events
    
    The mechanism is equivalent to the CLUTTER_DEBUG environment variable,
    but it does not depend on the debug level selected when configuring and
    compiling Clutter. The picking and painting debugging flags are
    initialized at clutter_init() time.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1991

 clutter/clutter-debug.h           | 14 ++++++++---
 clutter/clutter-main.c            | 49 +++++++++++++++++++++++++++++++--------
 clutter/glx/clutter-backend-glx.c |  6 +++--
 3 files changed, 54 insertions(+), 15 deletions(-)

commit a9c307ff5d94489b30d7398ac80072fe7222a434
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 17 22:16:17 2010 +0000

    cogl-vertex-buffer: Fix the malloc fallback for indices
    
    The size of the malloc'd buffer for indices when VBOs are not
    available was too small so memory corruption would result if it was
    used.
    
    http://bugzilla.o-hand.com/show_bug.cgi?id=1996

 clutter/cogl/cogl/cogl-vertex-buffer.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 14669657737cc1547fb0db261232e63bdd2755d9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 22 11:34:04 2010 +0000

    device: Motion events compression should honour the device
    
    The motion event compression should be affected by the device field of
    the event; that is: we should compress motion events coming from the
    same device.

 clutter/clutter-stage.c | 29 ++++++++++++++++++++++-------
 1 file changed, 22 insertions(+), 7 deletions(-)

commit 5ed4732737202c3051044455a91dc70c213fb800
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 22 11:30:14 2010 +0000

    device: Force ENTER on Stage with overlapping Actors
    
    If an actor is on the boundary of a Stage and the pointer for a device
    enters the Stage over that actor, the sequence of events currently is:
    
      ➔ ENTER (source: actor, related: NULL)
      ➔ MOTION
    
    Thus the Stage never gets an ENTER event. This is a regression from
    Clutter 1.0.
    
    The correct sequence is:
    
      ➔ ENTER (source: stage, related: NULL)
      ➔ ENTER (source: actor, related: stage)
      ➔ MOTION
    
    This also maps to the sequence of events sythesized by Clutter when
    leaving the Stage through an actor overlapping the Stage boundary.
    
    http://bugzilla.moblin.org/show_bug.cgi?id=9781

 clutter/clutter-input-device.c | 27 +++++++++++++++++++++++----
 1 file changed, 23 insertions(+), 4 deletions(-)

commit ee33357fd5d08be824a5ecb3161a79568afa4e5c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 18 16:58:29 2010 +0000

    stage: Only clutter_stage_get_default() creates the default stage
    
    The introduction of the StageManager in 0.8 implied that the first Stage
    instance to be created was automatically assigned the status of "default
    stage". This was all well and good, since the default stage was created
    behind the curtains by the initialization sequence.
    
    Now that the initialization sequence does not create a default stage any
    longer, it means that the first stage created using clutter_stage_new()
    gets to be the default, and all special and warm and fuzzy - which also
    means that the first stage created by clutter_stage_new() cannot be
    destroyed or handled as any other stage. Whoopsie.
    
    Let's go back to the old semantics: the stage created by the first
    invocation of clutter_stage_get_default() is the default stage, and
    nothing else can be set as default. One day we'll be able to break the
    API and the whole default stage business will be a thing of the past.

 clutter/clutter-private.h       | 10 ++++++----
 clutter/clutter-stage-manager.c | 32 +++++++++++++++++++++++++-------
 clutter/clutter-stage.c         |  1 +
 3 files changed, 32 insertions(+), 11 deletions(-)

commit 9a6de8757f27ff8a8cf9f89209f9366e03b7aadf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 18 11:34:06 2010 +0000

    docs: Document the InputDevice update method
    
    Embedding toolkits should benefit from a proper documentation of
    clutter_input_device_update_from_event(): its meaning, its use and
    the caveats for the "update_stage" argument.

 clutter/clutter-input-device.c | 49 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 49 insertions(+)

commit a2afc9d7ba0a80733044b97498a7df26de5a4ab2
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 17 18:18:38 2010 +0000

    win32: Fixup compilation errors from b398292089b0f7
    
    That commit added some Win32 code which breaks compilation.
    
    Thanks to Samuel Degrande for help with this.

 clutter/win32/clutter-backend-win32.c        |  5 ++---
 clutter/win32/clutter-device-manager-win32.c | 18 ++++++------------
 clutter/win32/clutter-event-win32.c          |  2 +-
 3 files changed, 9 insertions(+), 16 deletions(-)

commit 5de743de705ba9bb9a2061a66045b32091165ad5
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 16 14:53:10 2010 +0000

    cogl_texture_new_from_foreign: improve docs
    
    Improve the explanation of what the x_pot_waste and y_pot_waste
    arguments can be used for.

 clutter/cogl/cogl/cogl-texture.h | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

commit 9c06c94374c61c019ca49fa6fd80679e6ad2f29a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 16 14:23:11 2010 +0000

    cogl-texture: for foreign textures; always trust user geom
    
    We now never query the width and height of the given texture object
    from OpenGL. The problem is that the user may be creating a Cogl
    texture from a texture_from_pixmap object where glTexImage2D was
    never called and the texture_from_pixmap spec doesn't clarify that
    it's reliable to query the width from OpenGL.
    
    This should address:
    http://bugzilla.openedhand.com/show_bug.cgi?id=1502
    
    Thanks to Johan Bilien for reporting

 clutter/cogl/cogl/cogl-texture-2d-sliced.c | 24 +++++++++---------------
 1 file changed, 9 insertions(+), 15 deletions(-)

commit 8b040cac4dfaaa9d91635d31d93a79d00f637772
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 17 19:02:43 2010 +0000

    docs: Fixes for DeviceManager

 clutter/clutter-device-manager.h           | 12 ++++++------
 doc/reference/clutter/clutter-sections.txt |  6 ++++++
 2 files changed, 12 insertions(+), 6 deletions(-)

commit 51a3e49c8228a22c1fbcd42971ad27d26d83991b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 17 18:21:50 2010 +0000

    device: Allow updating devices from embedding toolkits
    
    Embedding toolkits most likely will disable the event handling, so all
    the input device code will not be executed. Unfortunately, the newly
    added synthetic event generation of ENTER and LEAVE event pairs depends
    on having input devices.
    
    In order to unbreak things without reintroducing the madness of the
    previous code we should allow embedding toolkits to just update the
    state of an InputDevice by using the data contained inside the
    ClutterEvent. This strategy has two obvious reasons:
    
      • the embedding toolkit is creating a ClutterEvent by translating
        a toolkit-native event anyway
    
      • this is exactly what ClutterStage does when processing events
    
    We are, essentially, deferring input device handling to the embedding
    toolkits, just like we're deferring event handling to them.

 clutter/clutter-event.h                    |  2 -
 clutter/clutter-input-device.c             | 59 ++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h             |  5 +++
 clutter/clutter-types.h                    |  2 +
 doc/reference/clutter/clutter-sections.txt |  2 +
 5 files changed, 68 insertions(+), 2 deletions(-)

commit b398292089b0f70b9457985426d6b962d9179fa7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 17 17:06:25 2010 +0000

    device: Impose per-backend DeviceManager
    
    The DeviceManager class should be abstract in Clutter, and implemented
    by each backend, as different backends will have different ways to
    detect, initialize and list devices; the X11 backend alone has *two*
    ways of dealing with devices.
    
    This commit makes DeviceManager an abstract class and delegates the
    device initialization and enumeration to per-backend sub-classes.
    
    The responsible for creating the device manager is, obviously, the
    backend singleton.
    
    The X11 and Win32 backends have been updated to the new layout; the
    Win32 backend has been updated blindly, so it might require additional
    testing.

 clutter/clutter-backend.h                    |  38 +--
 clutter/clutter-device-manager.c             | 166 +++++++++----
 clutter/clutter-device-manager.h             |  51 +++-
 clutter/clutter-private.h                    |   7 -
 clutter/win32/Makefile.am                    |   2 +
 clutter/win32/clutter-backend-win32.c        |  38 +--
 clutter/win32/clutter-backend-win32.h        |   3 +-
 clutter/win32/clutter-device-manager-win32.c | 173 +++++++++++++
 clutter/win32/clutter-device-manager-win32.h |  60 +++++
 clutter/win32/clutter-event-win32.c          |  34 ++-
 clutter/x11/Makefile.am                      |   2 +
 clutter/x11/clutter-backend-x11.c            | 168 +++----------
 clutter/x11/clutter-backend-x11.h            |   3 +-
 clutter/x11/clutter-device-manager-x11.c     | 349 +++++++++++++++++++++++++++
 clutter/x11/clutter-device-manager-x11.h     |  68 ++++++
 clutter/x11/clutter-event-x11.c              |  14 +-
 16 files changed, 930 insertions(+), 246 deletions(-)

commit 0bf6d57ab128f301588695d011a9ab5d1b1dce1a
Author: Chris Lord <chris@linux.intel.com>
Date:   Wed Feb 17 16:56:30 2010 +0000

    [event-x11] Don't relayout on window move
    
    ConfigureNotify is delivered on window movements too, but there is no
    need to queue a relayout on these as the viewport hasn't changed size.
    Check for the window actually changing size on ConfigureNotify before
    queueing a relayout.
    
    This fixes laggy window movement when moving a window in response to
    Clutter mouse motion events.

 clutter/x11/clutter-event-x11.c | 26 ++++++++++++++++----------
 1 file changed, 16 insertions(+), 10 deletions(-)

commit 05054bed87866d10c927642fe6273c5bd8f89a95
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 17 15:58:32 2010 +0000

    cogl-clip-stack: Round the coords when clipping to a window rect
    
    The size and position of the window rectangle for clipping in
    try_pushing_rect_as_window_rect is calculated by projecting the
    rectangle coordinates. Due to rounding errors, this can end up with
    slightly off numbers like 34.999999. These were then being cast
    directly to an integer so it could end up off by one.
    
    This uses a new macro called COGL_UTIL_NEARBYINT which is a
    replacement for the C99 nearbyint function.

 clutter/cogl/cogl/cogl-clip-stack.c | 6 +++++-
 clutter/cogl/cogl/cogl-util.h       | 8 ++++++++
 2 files changed, 13 insertions(+), 1 deletion(-)

commit a726ef32aa4721070b57df2e08c304096cb24736
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 17 14:38:45 2010 +0000

    test-cogl-vertex-buffer: Fix the maximum index number
    
    It was passing the number of vertices to
    cogl_vertex_buffer_draw_elements but instead it should take the
    maximum index which would be the number of vertices minus one. This
    was causing errors to be reported with the checks filterset of Bugle.

 tests/interactive/test-cogl-vertex-buffer.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fbcaf1e0b34f68934e0c84b01adfa5ea920c6c6a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 17 10:46:16 2010 +0000

    Improve LEAVE events for border actors
    
    If an actor is lying on the border of the Stage it might miss the LEAVE
    event when the pointer of a device leaves the Stage window. Since the
    backend is unsetting the Stage back pointer on the InputDevice we can
    queue the emission of a LEAVE event on the pointer actor as well.
    
    http://bugzilla.moblin.org/show_bug.cgi?id=9677

 clutter/clutter-input-device.c  | 23 ++++++++++++++++++++++-
 tests/interactive/test-events.c | 22 +++++++++++++++++-----
 2 files changed, 39 insertions(+), 6 deletions(-)

commit 719e314b8e364955b046c990ddc1c9f07b0cc55f
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Feb 16 18:25:46 2010 +0000

    [stage-x11] Fix a warning due to a missing cast
    
    I stupidly forgot to cast a ClutterStage to a ClutterActor and somehow
    missed or didn't get the compiler warning. Fix.

 clutter/x11/clutter-stage-x11.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f9f03894a691cfb8f791f34c684d82f8a6d5b5b8
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Feb 16 18:17:55 2010 +0000

    [stage-x11] Fix resizing for foreign windows
    
    As well as manually setting the geometry size, we needed to queue a
    relayout. This is what the ConfigureNotify handler would normally do,
    but we don't get this event when using a foreign window (obviously).
    
    This should fix resizing in things like gtk-clutter.

 clutter/x11/clutter-stage-x11.c | 5 +++++
 1 file changed, 5 insertions(+)

commit df6e7aee73a3c3818acab8218732659eb77a3cdc
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Feb 16 17:46:52 2010 +0000

    [stage-x11] Set the geometry size for foreign wins
    
    If we get into the resize function and it's a foreign window, set the
    geometry size so that the allocate will set the backend size and call
    glViewport.

 clutter/x11/clutter-stage-x11.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit c2d016471258c529d7829ed807e76a4e029b614b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 16:31:20 2010 +0000

    Add test-stage-sizing to the ignore file

 .gitignore | 1 +
 1 file changed, 1 insertion(+)

commit d42f928c43994331017bca7145b7b06fd5848909
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Feb 16 15:39:08 2010 +0000

    [test-interactive] Add a stage sizing test
    
    Add an interactive stage sizing test to test the interaction of
    fullscreening/resizing/expanding/shrinking a visible stage.

 tests/interactive/Makefile.am         |   3 +-
 tests/interactive/test-stage-sizing.c | 113 ++++++++++++++++++++++++++++++++++
 2 files changed, 115 insertions(+), 1 deletion(-)

commit 1117b6a9ac974dd5855c5e76965c15329c608ff4
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Feb 16 14:50:14 2010 +0000

    [stage-x11] Fix switching fullscreen mode
    
    Setting/unsetting fullscreen on a mapped or unmapped window now works
    correctly.
    
    If you unfullscreen a window that was initially full-screened, it will
    unset the fullscreen hint and the WM will likely push the size down to
    the largest valid size.
    
    If the window was previously un-fullscreened, Clutter will restore the
    previous size.
    
    Fullscreening also now works if the WM switches the hint without the
    application's knowledge (as happens when you resize a window to the size
    of the screen, for example, with stock metacity).

 clutter/clutter-stage.c         |  3 +-
 clutter/x11/clutter-event-x11.c | 13 ++++++--
 clutter/x11/clutter-stage-x11.c | 71 +++++++++++++++++++++++------------------
 clutter/x11/clutter-stage-x11.h |  2 +-
 4 files changed, 54 insertions(+), 35 deletions(-)

commit dd36c3ad5c4f3d25d0286cf1c2a9a25abf7d2ea4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 12:32:37 2010 +0000

    Post-release version bump to 1.1.13

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 21354b2b7518c9518fa8405f07ed1f929736d4a2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 12:21:15 2010 +0000

    Release 1.1.12 (developers snapshot)

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 7a3eb452b802e5b38542d224da179c4267706e7b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 12:16:02 2010 +0000

    conform: Do not resize the stage
    
    Since all conformance tests share the same state we should not touch
    stuff like the stage size; sharing is already fairly complex and adds a
    lot of caveats on the implementation of a conformance test unit, and if
    we make tests influence later ones then we might slip in bugs or false
    negatives - thus defeating the whole point of a conformance test suite.

 tests/conform/test-cogl-offscreen.c  | 1 -
 tests/conform/test-cogl-readpixels.c | 1 -
 tests/conform/test-cogl-viewport.c   | 1 -
 tests/conform/test-pick.c            | 1 -
 4 files changed, 4 deletions(-)

commit 4cadc7300504828fa0db8cb21e1b9d8e23be6319
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 12:15:23 2010 +0000

    conform: Use a 640x480 stage in test-pick
    
    Do not resize the stage to a smaller size: the default size is perfectly
    fine.

 tests/conform/test-pick.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 958545aa70e526a12720bf2dd0d9b9a24d273b8d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 16 12:01:18 2010 +0000

    cogl-atlas-texture: Don't use the atlas if FBOs aren't supported
    
    If FBOs aren't supported then it will end up very slow to reorganize
    the atlas. Also currently the CoglTexture2D backend will refuse to
    create any textures anyway so the full atlas texture won't be created.

 clutter/cogl/cogl/cogl-atlas-texture.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit a5021ba30f553d641399545d9777eb5b4b385ac1
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 16 11:58:47 2010 +0000

    cogl-atlas-texture: Check for errors when creating the atlas texture
    
    cogl_texture_2d_new may fail in certain circumstances so
    cogl_atlas_texture_reserve_space should detect this and also
    fail. This will cause cogl_texture_new to fallback to a sliced
    texture.
    
    Thanks to Vladimir Ivakin for reporting this problem.

 clutter/cogl/cogl/cogl-atlas-texture.c | 19 ++++++++++++-------
 1 file changed, 12 insertions(+), 7 deletions(-)

commit e65bb38720c8990684ce24bda08b78d8da49cc1b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 16 11:38:51 2010 +0000

    conform: Use g_assert_cmpint() in cogl-readpixels test
    
    The g_assert_cmpint() macro prints out not just the assertion condition
    but also the assertion contents; this is useful to catch wrong values
    without incrementing the verbosity of the test itself.

 tests/conform/test-cogl-readpixels.c | 18 ++++++++----------
 1 file changed, 8 insertions(+), 10 deletions(-)

commit 56f164f8a1c634e2d0ba6ffb5879672d456e1488
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 19:03:37 2010 +0000

    docs: Document SWAP_EVENTS feature flag

 clutter/clutter-feature.h | 1 +
 1 file changed, 1 insertion(+)

commit 2fcb644e4fb02375bdf8b1f54677bcde7abdceba
Author: Chris Lord <chris@linux.intel.com>
Date:   Mon Feb 15 18:53:58 2010 +0000

    [stage] Fix some races to do with window resizing
    
    When we resize, we relied on the stage's allocate to re-initialise the
    GL viewport. Unfortunately, if we resized within Clutter, the new size
    was cached before the window is actually resized, so glViewport wasn't
    being called after resizing (some of the time, it's a race condition).
    
    Change the way resizing works slightly so that we only resize when the
    geometry size doesn't match our preferred size, and queue a relayout on
    ConfigureNotify so the glViewport gets called.
    
    Also change window creation slightly so that setting the size of a
    window before it's realized works correctly.

 clutter/clutter-stage.c         | 36 +++++++++++++++---------------------
 clutter/glx/clutter-stage-glx.c | 19 +++++++++++++++++--
 clutter/x11/clutter-event-x11.c | 13 +++++++++++++
 clutter/x11/clutter-stage-x11.c | 24 ++++++++++--------------
 4 files changed, 55 insertions(+), 37 deletions(-)

commit 0d428655e23c18064176aa823db0d7165581ba02
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 16:09:26 2010 +0000

    actor: Turn push/pop_internal into Actor methods
    
    Since the "internal" state is global, it will leak onto actors that you
    didn't intend for it to, because it applies not just to the actors you
    create, but also to any actors *they* create. Eg, if you have a dialog
    box class, you might push/pop_internal around creating its buttons, so
    that those buttons get marked as internal to the dialog box. But
    ctx->internal_child will still be set during the *button*'s constructor
    as well, and so, eg, the label and icon inside the button actor will
    *also* be marked as internal children, even if that isn't what the
    button class wanted.
    
    The least intrusive change at this point is to make push_internal() and
    pop_internal() two methods of the Actor class, and take a ClutterActor
    pointer as the argument - thus moving the locality of the internal_child
    counter to the Actor itself.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1990

 clutter/clutter-actor.c            | 31 ++++++++++++++++++-------------
 clutter/clutter-actor.h            |  4 ++--
 clutter/clutter-private.h          |  2 --
 tests/conform/test-actor-destroy.c |  4 ++--
 4 files changed, 22 insertions(+), 19 deletions(-)

commit 2229cafc3833a017b3a107b4f6b207f0a95908f5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 12:04:50 2010 +0000

    stage: Add sanity checks for get_pending_swaps()
    
    The master clock might have a Stage during its destruction phase,
    without a StageWindow attached to it. If this happens and we try
    to dereference the StageWindow to get its class and call a virtual
    function we might experience some slight turbulence and... then...
    explode.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1987

 clutter/clutter-master-clock.c | 21 +++++++++++++--------
 clutter/clutter-stage.c        | 10 +++++++++-
 2 files changed, 22 insertions(+), 9 deletions(-)

commit fef82fae5c716f15cd345fcfbc37f01578a82580
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 11:58:55 2010 +0000

    build: Enable experimental COGL API in tests/conform
    
    Enable the experimental API when building the conformance test suite.

 tests/conform/Makefile.am              | 1 +
 tests/conform/test-cogl-pixel-buffer.c | 3 ---
 2 files changed, 1 insertion(+), 3 deletions(-)

commit 032121ce17fb825592ba435cf260107b52f8196c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 11:57:48 2010 +0000

    build: Disable deprecated API in tests/conform
    
    We should not be using deprecated API in the conformance test suite.

 tests/conform/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit c3354cb2c0acc7d80b2cea3f970a1d83a47d585c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 11:56:34 2010 +0000

    conform: Do not use deprecated API
    
    There is no more type-specific ref/unref pairs: it is all under
    CoglHandle now.

 tests/conform/test-cogl-blend-strings.c   | 6 +++---
 tests/conform/test-cogl-multitexture.c    | 2 +-
 tests/conform/test-cogl-texture-mipmaps.c | 2 +-
 3 files changed, 5 insertions(+), 5 deletions(-)

commit d607400f01be1c1e26f54b3d83794e0d246e8db0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 11:45:35 2010 +0000

    x11: Do not set pid or title on foreign windows
    
    If a StageX11 is using a foreign window we should not need to set the
    _NET_WM_PID or the WM_TITLE properies.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1989

 clutter/x11/clutter-stage-x11.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 89191e8bbc591f33dd0f45e2317f31eeaa7d4023
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 15 11:44:02 2010 +0000

    docs: Mention signal-swapped-after modifier
    
    The signal-swapped-after:: modifier for signal connection inside the
    clutter_actor_animate* variadic arguments functions is not mentioned in
    the documentation.

 clutter/clutter-animation.c | 34 ++++++++++++++++++++++++----------
 1 file changed, 24 insertions(+), 10 deletions(-)

commit 262782feae4e8130321be414f7aac9141ae22eab
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Feb 8 19:18:36 2010 +0000

    docs: Add 2010 in COGL's Copyright notice
    
    While at it, fix the usage of <year> in <copyright> to let the
    stylesheet do the collation when having several years.

 doc/reference/clutter/clutter-docs.xml.in | 7 +++++--
 doc/reference/cogl/cogl-docs.xml.in       | 1 +
 2 files changed, 6 insertions(+), 2 deletions(-)

commit 01bf50905689b363877f85942403cdc947f8c82c
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri Feb 12 17:24:15 2010 +0000

    cogl-buffer: fix compilation for GL ES
    
    In the frenzy of the last 10mins before API freeze, I obviously forgot
    to update the OpenGL path for _cogl_buffer_hints_to_gl_enum(). This
    commit fixes this.

 clutter/cogl/cogl/cogl-buffer.c | 15 +++++----------
 1 file changed, 5 insertions(+), 10 deletions(-)

commit e668a2f228acb1f38853eea4245f87e10e82fe23
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Feb 12 15:33:56 2010 +0000

    cogl-atlas-texture: Flush the journal before adding a new texture
    
    When the atlas is reorganised we could potentially be moving around
    textures that are already referenced in the journal. We therefore need
    to flush the journal otherwise they will be rendered with incorrect
    texture coordinates. We also need to flush the journal even if we are
    not reorganizing so that we can rely on the old texture contents
    remaining in the atlas after migrating a texture out.

 clutter/cogl/cogl/cogl-atlas-texture.c | 26 +++++++++++++++++++++++++-
 1 file changed, 25 insertions(+), 1 deletion(-)

commit 4be4f56bdf463ccac89c7068b47ba1450bee95ee
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Feb 12 10:08:51 2010 +0000

    cogl-sub-texture: Optimise taking a sub texture of a sub texture
    
    When creating a Cogl sub-texture, if the full texture is also a sub
    texture it will now just offset the x and y and reference the full
    texture instead. This avoids one level of indirection when rendering
    the texture which reduces the chances of getting rounding errors in
    the calculations.

 clutter/cogl/cogl/cogl-sub-texture-private.h | 17 +++++-
 clutter/cogl/cogl/cogl-sub-texture.c         | 29 +++++++--
 clutter/cogl/cogl/cogl-texture.h             |  4 ++
 tests/conform/test-cogl-sub-texture.c        | 89 ++++++++++++++++++----------
 4 files changed, 99 insertions(+), 40 deletions(-)

commit 2018b5b16750b090c5592ebd5262fc66d809183e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 16:24:27 2010 +0000

    actor: Split get_paint_opacity() from the type check
    
    Since get_paint_opacity() recurses through the hierarchy it might lead
    to a lot of type checks while we walk the parent-child chain. We can
    split the recursive function from the public entry point and perform the
    type check just once.

 clutter/clutter-actor.c | 55 +++++++++++++++++++++++++++++++------------------
 1 file changed, 35 insertions(+), 20 deletions(-)

commit 37d51cb78e41ea36f01c049eda6163bddc84ce33
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 16:18:12 2010 +0000

    actor: Do not call get_opacity() from get_paint_opacity()
    
    We already have access to the opacity private field, there's no need to
    go through the public API.

 clutter/clutter-actor.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 124f30cccef75feabb0933c074753b392f373e82
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 15:52:07 2010 +0000

    docs: Fixes for Cogl

 clutter/cogl/cogl/cogl-material.h     | 1 +
 clutter/cogl/cogl/cogl-pixel-buffer.h | 2 +-
 doc/reference/cogl/Makefile.am        | 3 ++-
 doc/reference/cogl/cogl-sections.txt  | 8 ++++----
 4 files changed, 8 insertions(+), 6 deletions(-)

commit 27e6c3b1e0db6fcb36a8f7e44e457b672ee34565
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 14:46:43 2010 +0000

    build: Use -Wuninitialized instead of -Wno-uninitialized
    
    We want to be warned about uninitialized variables.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 00c4bfc3c69ba1c1c37852392b46c0fe601a98a1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 14:45:49 2010 +0000

    analysis: Interactive tests
    
    Abort if test-behave was passed the wrong type of behaviour to test.

 tests/interactive/test-behave.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 46182233c031c480b5d4d1f6109ab28a6199d369
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 14:45:04 2010 +0000

    analysis: Conformance tests
    
    Initialize ClutterPathNote members to 0 using "{ 0, }".

 tests/conform/test-path.c | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 78f1f508af88ccd9652d38811a4ebc6662c566dd
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:24:41 2010 +0000

    analysis: x11: ClutterEvent
    
    Remove an unused variable.

 clutter/x11/clutter-event-x11.c | 3 ---
 1 file changed, 3 deletions(-)

commit 081696fdb5d83c41ed201277db272572eb534db2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:24:17 2010 +0000

    analysis: CoglPangoRenderer
    
    Remove unused variables.

 clutter/cogl/pango/cogl-pango-render.c | 17 +++++++----------
 1 file changed, 7 insertions(+), 10 deletions(-)

commit 2d8bdf9e5ebd101b40854e0066b06037dd261ea5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:20:25 2010 +0000

    analysis: ClutterTimeoutPool
    
    Do not pre-initialize the list iterator, the for loop will do it for us.

 clutter/clutter-timeout-pool.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9c8f8818784ba7c709c70ead6d8e103ee28d0c8c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:20:07 2010 +0000

    analysis: ClutterTimeline
    
    Remove an unused variable.

 clutter/clutter-timeline.c | 4 ----
 1 file changed, 4 deletions(-)

commit 65af411cb4675eab722fe16acc93fa6e7183e3c8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:19:46 2010 +0000

    analysis: ClutterTexture
    
    Remove unused variables.

 clutter/clutter-texture.c | 25 +++++++++----------------
 1 file changed, 9 insertions(+), 16 deletions(-)

commit 09644e4bb6cff70d2c9a59bbe9b461b7e53676e2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:19:32 2010 +0000

    analysis: ClutterText
    
    Remove unused variables.

 clutter/clutter-text.c | 2 --
 1 file changed, 2 deletions(-)

commit c2d434e3af3d3b862866273a7dd15541ecbebcd5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:19:18 2010 +0000

    analysis: ClutterStage
    
    Remove unused variables.

 clutter/clutter-stage.c | 8 +-------
 1 file changed, 1 insertion(+), 7 deletions(-)

commit 136e8c1acb15c078c0898a834f55666c6f0ef384
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:17:53 2010 +0000

    analysis: ClutterScriptParser
    
    We parse a JSON value depending on the initial state of an uninitialized
    variable. Ouch.

 clutter/clutter-script-parser.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4d9010dd5e9c5a69ba5f7a0c3969ce5ac337c08d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:17:32 2010 +0000

    analysis: ClutterRectangle
    
    Remove unused variables.

 clutter/clutter-rectangle.c | 10 +++-------
 1 file changed, 3 insertions(+), 7 deletions(-)

commit 8ba65cfd4aba677530b25d9ab1323d2b1b281282
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:17:07 2010 +0000

    analysis: ClutterModel
    
    Remove unused variables.

 clutter/clutter-model.c | 10 ----------
 1 file changed, 10 deletions(-)

commit bea1a0a6a22ecd0ed96720bcecb3919d3fbb2757
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:13:40 2010 +0000

    analysis: ClutterMain
    
    • Remove unused variables.
    
    • Do not pre-initialize ClutterActor's GType; pre-emptive optimizations
      like these are more black magic than real optimization.

 clutter/clutter-main.c | 21 ++++++---------------
 1 file changed, 6 insertions(+), 15 deletions(-)

commit 66920ea540834c0264434f64a0dcfae4150e625f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:13:20 2010 +0000

    analysis: ClutterInterval
    
    Remove unused variables.

 clutter/clutter-interval.c | 8 --------
 1 file changed, 8 deletions(-)

commit 853f9941da5f40b936307ce45f67265f978d9c2b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:11:51 2010 +0000

    analysis: ClutterBoxLayout
    
    Remove an useless assignment. The n_expand_children is not used outside
    the extra_space check, and if n_expand_children is 0 then the extra
    space we allocate is 0.

 clutter/clutter-box-layout.c | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit cd058562538633962089cd30787b7a98d9733144
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:11:25 2010 +0000

    analysis: ClutterBehaviour
    
    Remove an unused variable.

 clutter/clutter-behaviour.c | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 6dc0e9632cc2597240d9e42c98cd567dbcc1dbec
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:09:51 2010 +0000

    analysis: ClutterAnimation
    
    • Remove one unused variable.
    
    • We ignore the result of get_timeline_internal() so we need to tell
      the compiler that - though a better solution would be to split the
      timeline implicit creation into its own function.

 clutter/clutter-animation.c | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit a287ca7a2824efef2608877555711c408122a400
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:09:12 2010 +0000

    analysis: ClutterAnimator/2
    
    Clean up an unused variable.

 clutter/clutter-animator.c | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 667222c301ca0f19c570938055208e564e4d02ef
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:08:19 2010 +0000

    analysis: ClutterAnimator/1
    
    Do not de-reference a void*; use a temporary variable -- after
    checking the contents of the pointer. This actually simplifies
    the readability and avoids pulling a Lisp with the parentheses.

 clutter/clutter-animator.c | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit fcd3cfc0bfc656d63088a443355b30e7b50d2850
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:07:38 2010 +0000

    analysis: ClutterAlpha
    
    Clean up unused variables.

 clutter/clutter-alpha.c | 12 ++----------
 1 file changed, 2 insertions(+), 10 deletions(-)

commit aa6d7a30291c199fc1d26a93574d88c027367bf0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 11 15:05:18 2010 +0000

    analysis: ClutterActor
    
    Clean up ClutterActor for unused variables.

 clutter/clutter-actor.c | 12 +-----------
 1 file changed, 1 insertion(+), 11 deletions(-)

commit 7a372bc0011b6301cc8b46767493a23218a67cff
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Feb 12 14:26:33 2010 +0000

    cogl: Cache the value for GL_MAX_TEXTURE_UNITS
    
    The function _cogl_get_max_texture_units is called quite often while
    rendering and it returns a constant value so we might as well cache
    the result. Calling glGetInteger on Mesa can be expensive because it
    flushes a lot of state.

 clutter/cogl/cogl/cogl-context.c |  2 ++
 clutter/cogl/cogl/cogl-context.h |  4 ++++
 clutter/cogl/cogl/cogl.c         | 12 +++++++++---
 3 files changed, 15 insertions(+), 3 deletions(-)

commit 22c33b2fea1fd60239280aa1f4fd112f533688aa
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Feb 11 16:12:26 2010 +0000

    cogl: resolves some low hanging issues flagged by clang
    
    An initial pass over the Cogl source code using the Clang static
    analysis tool flagged a few low hanging issues such as un-used variables
    or redundant initializing of variables which this patch fixes.

 clutter/cogl/cogl/cogl-texture-2d-sliced.c | 9 ++-------
 clutter/cogl/cogl/cogl-texture.c           | 8 ++++----
 2 files changed, 6 insertions(+), 11 deletions(-)

commit 18305cbd98e02ab139beef769cbc90a2121bd1f5
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Feb 11 15:33:01 2010 +0000

    cogl_rectangle: avoid redundant copy of geometry
    
    All the cogl_rectangle* APIs normalize their input into into an array of
    _CoglMutiTexturedRect rectangles and pass these on to our work horse;
    _cogl_rectangles_with_multitexture_coords. The definition of
    _CoglMutiTexturedRect had 4 separate float members, x_1, y_1, x_2 and
    y_2 which meant for some common cases we were having to copy out from an
    array into these members. We are now able to simply point into the users
    array avoiding a copy which seems desirable when submiting lots of
    rectangles.

 clutter/cogl/cogl/cogl-journal-private.h |   5 +-
 clutter/cogl/cogl/cogl-journal.c         |  31 ++++---
 clutter/cogl/cogl/cogl-primitives.c      | 135 ++++++++++++++++---------------
 3 files changed, 91 insertions(+), 80 deletions(-)

commit 5f18fc928d85499d6ee2ac433dde247286e2de4e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 10 22:47:49 2010 +0000

    cogl: explicitly mark cogl_<object>_ref/unref APIs as deprecated
    
    This uses the G_GNUC_DEPRECATED macros to mark the
    cogl_{texture,vertex_buffer,shader}_ref and unref APIs as deprecated.
    Since this flagged that cogl-pango-display-list.c and
    clutter-glx-texture-pixmap.c were still using deprecated _ref/_unref
    APIs they have now been changed to use the cogl_handle_ref/unref API
    instead.

 clutter/cogl/cogl/cogl-shader.h              | 8 ++++++--
 clutter/cogl/cogl/cogl-texture.h             | 4 ++--
 clutter/cogl/cogl/cogl-vertex-buffer.h       | 4 ++--
 clutter/cogl/pango/cogl-pango-display-list.c | 8 ++++----
 clutter/glx/clutter-glx-texture-pixmap.c     | 2 +-
 5 files changed, 15 insertions(+), 11 deletions(-)

commit 48660349dbcabdde05fc9e1334734bcc62bb790e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 10 22:30:37 2010 +0000

    cogl: cleanly separate primitives + paths code
    
    The function prototypes for the primitives API were spread between
    cogl-path.h and cogl-texture.h and should have been in a
    cogl-primitives.h.
    
    As well as shuffling the prototypes around into more sensible places
    this commit splits the cogl-path API out from cogl-primitives.c into
    a cogl-path.c

 clutter/cogl/cogl/Makefile.am       |    3 +
 clutter/cogl/cogl/cogl-internal.h   |   28 +
 clutter/cogl/cogl/cogl-path.c       | 1121 +++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-path.h       |   33 +-
 clutter/cogl/cogl/cogl-primitives.c | 1078 ---------------------------------
 clutter/cogl/cogl/cogl-primitives.h |  188 +++++-
 clutter/cogl/cogl/cogl-texture.h    |  133 -----
 clutter/cogl/cogl/cogl.h            |    1 +
 8 files changed, 1316 insertions(+), 1269 deletions(-)

commit 9f5a3e14451ed77f47260bbd6a1b2271e8003361
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 10 18:18:30 2010 +0000

    cogl: remove redundant _cogl_journal_flush prototype
    
    There was a redundant _cogl_journal_flush function prototype in
    cogl-primitives.h

 clutter/cogl/cogl/cogl-clip-stack.c        | 1 +
 clutter/cogl/cogl/cogl-framebuffer.c       | 1 +
 clutter/cogl/cogl/cogl-journal-private.h   | 5 +++--
 clutter/cogl/cogl/cogl-material.c          | 1 +
 clutter/cogl/cogl/cogl-primitives.h        | 3 ---
 clutter/cogl/cogl/cogl-texture-2d-sliced.c | 1 +
 clutter/cogl/cogl/cogl-texture-2d.c        | 1 +
 clutter/cogl/cogl/cogl-vertex-buffer.c     | 1 +
 clutter/cogl/cogl/driver/gl/cogl-program.c | 1 +
 9 files changed, 10 insertions(+), 5 deletions(-)

commit 7edcbaa1f9444848fcaac052557f7c444e3905e0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 10 01:57:32 2010 +0000

    cogl: improves header and coding style consistency
    
    We've had complaints that our Cogl code/headers are a bit "special" so
    this is a first pass at tidying things up by giving them some
    consistency. These changes are all consistent with how new code in Cogl
    is being written, but the style isn't consistently applied across all
    code yet.
    
    There are two parts to this patch; but since each one required a large
    amount of effort to maintain tidy indenting it made sense to combine the
    changes to reduce the time spent re indenting the same lines.
    
    The first change is to use a consistent style for declaring function
    prototypes in headers. Cogl headers now consistently use this style for
    prototypes:
    
     return_type
     cogl_function_name (CoglType arg0,
                         CoglType arg1);
    
    Not everyone likes this style, but it seems that most of the currently
    active Cogl developers agree on it.
    
    The second change is to constrain the use of redundant glib data types
    in Cogl. Uses of gint, guint, gfloat, glong, gulong and gchar have all
    been replaced with int, unsigned int, float, long, unsigned long and char
    respectively. When talking about pixel data; use of guchar has been
    replaced with guint8, otherwise unsigned char can be used.
    
    The glib types that we continue to use for portability are gboolean,
    gint{8,16,32,64}, guint{8,16,32,64} and gsize.
    
    The general intention is that Cogl should look palatable to the widest
    range of C programmers including those outside the Gnome community so
    - especially for the public API - we want to minimize the number of
    foreign looking typedefs.

 clutter/cogl/cogl/cogl-atlas-texture.c             |  52 ++--
 clutter/cogl/cogl/cogl-atlas.c                     |  22 +-
 clutter/cogl/cogl/cogl-atlas.h                     |  18 +-
 clutter/cogl/cogl/cogl-bitmap-fallback.c           |  82 +++---
 clutter/cogl/cogl/cogl-bitmap-pixbuf.c             |  60 ++--
 clutter/cogl/cogl/cogl-bitmap-private.h            |  30 +-
 clutter/cogl/cogl/cogl-bitmap.c                    |  34 +--
 clutter/cogl/cogl/cogl-bitmap.h                    |  15 +-
 clutter/cogl/cogl/cogl-blend-string.c              |  12 +-
 clutter/cogl/cogl/cogl-blend-string.h              |   4 +-
 clutter/cogl/cogl/cogl-buffer-private.h            |  14 +-
 clutter/cogl/cogl/cogl-buffer.c                    |   8 +-
 clutter/cogl/cogl/cogl-buffer.h                    |  26 +-
 clutter/cogl/cogl/cogl-clip-stack.c                |  16 +-
 clutter/cogl/cogl/cogl-clip-stack.h                |  14 +-
 clutter/cogl/cogl/cogl-color.h                     |  75 +++--
 clutter/cogl/cogl/cogl-context.c                   |   2 +-
 clutter/cogl/cogl/cogl-context.h                   |  10 +-
 clutter/cogl/cogl/cogl-debug.c                     |   8 +-
 clutter/cogl/cogl/cogl-debug.h                     |   4 +-
 clutter/cogl/cogl/cogl-feature-private.c           |  19 +-
 clutter/cogl/cogl/cogl-feature-private.h           |  14 +-
 clutter/cogl/cogl/cogl-fixed.c                     |  24 +-
 clutter/cogl/cogl/cogl-fixed.h                     |  72 +++--
 clutter/cogl/cogl/cogl-handle.h                    |   2 +-
 clutter/cogl/cogl/cogl-internal.h                  |  32 ++-
 clutter/cogl/cogl/cogl-journal.c                   |  26 +-
 clutter/cogl/cogl/cogl-material-private.h          |  67 +++--
 clutter/cogl/cogl/cogl-material.c                  |  22 +-
 clutter/cogl/cogl/cogl-material.h                  | 175 +++++++-----
 clutter/cogl/cogl/cogl-matrix.h                    | 110 ++++----
 clutter/cogl/cogl/cogl-path.h                      | 138 +++++----
 clutter/cogl/cogl/cogl-pixel-buffer-private.h      |   9 +-
 clutter/cogl/cogl/cogl-pixel-buffer.c              |  53 ++--
 clutter/cogl/cogl/cogl-pixel-buffer.h              |  46 +--
 clutter/cogl/cogl/cogl-primitives.c                |  48 ++--
 clutter/cogl/cogl/cogl-primitives.h                |  13 +-
 clutter/cogl/cogl/cogl-shader.h                    |  96 ++++---
 clutter/cogl/cogl/cogl-sub-texture-private.h       |  14 +-
 clutter/cogl/cogl/cogl-sub-texture.c               |  70 ++---
 clutter/cogl/cogl/cogl-texture-2d-private.h        |   4 +-
 clutter/cogl/cogl/cogl-texture-2d-sliced-private.h |   6 +-
 clutter/cogl/cogl/cogl-texture-2d-sliced.c         | 163 +++++------
 clutter/cogl/cogl/cogl-texture-2d.c                |  34 +--
 clutter/cogl/cogl/cogl-texture-private.h           |   6 +-
 clutter/cogl/cogl/cogl-texture.c                   | 106 +++----
 clutter/cogl/cogl/cogl-texture.h                   | 220 ++++++++-------
 clutter/cogl/cogl/cogl-types.h                     |  15 +-
 clutter/cogl/cogl/cogl-util.c                      |  30 +-
 clutter/cogl/cogl/cogl-vertex-buffer-private.h     |   2 +-
 clutter/cogl/cogl/cogl-vertex-buffer.c             |  18 +-
 clutter/cogl/cogl/cogl-vertex-buffer.h             |   6 +-
 clutter/cogl/cogl/cogl.c                           |  52 ++--
 clutter/cogl/cogl/cogl.h                           | 310 +++++++++++++--------
 clutter/cogl/cogl/driver/gl/cogl-program.c         |  18 +-
 clutter/cogl/cogl/driver/gl/cogl-shader.c          |   2 +-
 clutter/cogl/cogl/driver/gl/cogl-texture-driver.c  |   2 +-
 clutter/cogl/cogl/driver/gl/cogl.c                 |   8 +-
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c |   6 +-
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h |  12 +-
 clutter/cogl/cogl/driver/gles/cogl-program.c       |  42 +--
 clutter/cogl/cogl/driver/gles/cogl-shader.c        |   4 +-
 .../cogl/cogl/driver/gles/cogl-texture-driver.c    |   4 +-
 clutter/cogl/doc/CODING_STYLE                      |  49 ++++
 64 files changed, 1491 insertions(+), 1184 deletions(-)

commit 8c9472bc4c0350bc28f6ca152e82a0a507063d19
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Feb 5 16:32:19 2010 +0000

    cogl: deprecates cogl_check_extension
    
    OpenGL is an implementation detail for Cogl so it's not appropriate to
    expose OpenGL extensions through the Cogl API.
    
    Note: Clutter is currently still using this API, because it is still
    doing raw GL calls in ClutterGLXTexturePixmap, so this introduces a
    couple of (legitimate) build warnings while compiling Clutter.

 clutter/cogl/cogl/cogl-feature-private.c |  4 ++--
 clutter/cogl/cogl/cogl-internal.h        |  1 +
 clutter/cogl/cogl/cogl.c                 | 32 ++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl.h                 | 11 ++++++++++-
 clutter/cogl/cogl/driver/gl/cogl.c       | 31 +++----------------------------
 clutter/cogl/cogl/driver/gles/cogl.c     | 25 -------------------------
 clutter/glx/clutter-backend-glx.c        |  6 +++---
 clutter/glx/clutter-glx-texture-pixmap.c |  5 +++--
 8 files changed, 54 insertions(+), 61 deletions(-)

commit b898f0e227aeabeb0513d1228a8f432c467d95b9
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 9 19:34:32 2010 +0000

    never presume queuing redraws on invisible actors is redundant
    
    This replaces code like this:
      if (CLUTTER_ACTOR_IS_VISIBLE (self))
        clutter_actor_queue_redraw (self);
    with:
      clutter_actor_queue_redraw (self);
    
    clutter_actor_queue_redraw internally knows what can be optimized when
    the actor is not visible, but it also knows that the queue_redraw signal
    must always be sent in case a ClutterClone is cloning a hidden actor.

 clutter/clutter-actor.c     | 11 ++++-------
 clutter/clutter-group.c     | 12 ++++--------
 clutter/clutter-rectangle.c |  9 +++------
 clutter/clutter-stage.c     |  8 +++-----
 clutter/clutter-text.c      | 30 ++++++++++--------------------
 clutter/clutter-texture.c   |  9 +++------
 6 files changed, 27 insertions(+), 52 deletions(-)

commit bfb271b40332240f40c79dabf8f78f7a68293286
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 9 19:19:44 2010 +0000

    box: port a ClutterGroup::foreach fix to ClutterBox
    
    ClutterGroup::foreach was recently changed (ref: ce030a3fce) to use
    g_list_foreach() to iterate the children instead of manually iterating
    the list so it would safely handle calls like:
    
      clutter_container_foreach (container, clutter_actor_destroy);
    
      (In this example clutter_actor_destroy will result in the current
       list item being iterated being freed.)

 clutter/clutter-box.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 60a4664d6e4f67b5e527cc2ecd190a538ed994ec
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 9 19:06:59 2010 +0000

    box: Adds missing copyright header
    
    Adds a Copyright (C) 2009,2010  Intel Corporation header

 clutter/clutter-box.c | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 4355621aebb075bc34b50a89f8ba99e8b8e12ff7
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 9 18:54:28 2010 +0000

    group: make it comparable to ClutterBox
    
    There is a lot of duplication between ClutterGroup and ClutterBox so
    this makes the two files diff-able so that new fixes can easily be
    ported to both and bug fixes missing in one or the other can be spotted
    more easily. This doesn't change the behaviour of either actor; it's
    really just a shuffle around of code and normalizes the coding style to
    make the files comparable.
    
    This has already uncovered one bug in ClutterBox, and also highlights
    a bug in ClutterGroup + many other actors:
    
    1) ClutterGroup::real_foreach was recently changed to use
       g_list_foreach instead of manually iterating the child list so it can
       safely handle calls like:
         clutter_container_foreach (container, clutter_actor_destroy);
       ClutterBox is still manually iterating the list.
    
    2) In ClutterGroup we guard _queue_redraw() calls like this:
        if (CLUTTER_ACTOR_IS_VISIBLE (container))
            clutter_actor_queue_redraw (CLUTTER_ACTOR (container));
       In ClutterBox we don't:
         I think ClutterBox is correct here because
         clutter_actor_queue_redraw already optimizes the case where the
         actor's not visible, but it also considers that the actor may be
         cloned and so the guard in ClutterGroup could break clones. This
         actually highlights a wider clutter bug since the same kinds of
         guards can be found in all other clutter actors.

 clutter/clutter-box.c   |   1 -
 clutter/clutter-group.c | 366 ++++++++++++++++++++++--------------------------
 2 files changed, 167 insertions(+), 200 deletions(-)

commit 34c7611407154fcbb61c82c959c2a38972c2534f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 12 11:38:47 2010 +0000

    docs: Update the backend HACKING file
    
    Clarify the Backend::create_context() vfunc role, and the
    Stage::realize() vfunc with regards to creating the GL/GLES
    context.

 doc/HACKING.backends | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 44818a48273baa7dabfbb9370ac218ae8b0cf38e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Feb 11 14:20:48 2010 +0000

    cogl: Add a fallback for when the signbit macro is missing
    
    The signbit macro is defined in C99 so it should be available but some
    versions of GCC don't appear to define it by default. If it's not
    available we can use a hack to test the bit directly.

 clutter/cogl/cogl/cogl-sub-texture.c |  2 +-
 clutter/cogl/cogl/cogl-texture-2d.c  |  2 +-
 clutter/cogl/cogl/cogl-util.h        | 27 ++++++++++++++++++++++++++-
 3 files changed, 28 insertions(+), 3 deletions(-)

commit 59463c2213b79a553d3d7999bb56106fb7c5a4ad
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 10 17:20:31 2010 +0000

    Do a sanity check on _clutter_do_pick() arguments
    
    We should check that the passed ClutterStage pointer is indeed: a) still
    valid and b) a Stage.

 clutter/clutter-main.c | 1 +
 1 file changed, 1 insertion(+)

commit d0734bc4741d77e7c239cf860b73b49e9564aa91
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 10 17:12:27 2010 +0000

    input-device: Do not pick() on NULL stages
    
    If the stage associated to the InputDevice is not set we should
    short-circuit out and return NULL. This will result in a pick()
    done on the event's stage - if applicable.
    
    http://bugzilla.moblin.org/show_bug.cgi?id=9602

 clutter/clutter-input-device.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 4208169ab48795ca8f10287bd67031e161bf1f82
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 10 15:38:41 2010 +0000

    text: Bump up the preferred height
    
    Instead of returning a sub-pixel height round up the preferred height to
    the nearest integral value that is not less than the size reported by
    Pango, once converted in pixels.

 clutter/clutter-text.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f54b29a0c0c182f1396abd9df7d46d99b81a133d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 10 15:38:07 2010 +0000

    test-text-field: Tone down the border
    
    Use a low opacity for the text field border.

 tests/interactive/test-text-field.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2670fc58710b1d9d1ad5afae7b6ac397e1dc54dd
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 10 15:37:26 2010 +0000

    test-text-field: Use ActorBox methods for the border
    
    Clamp to pixel and use get_size() when painting the border of the text
    field.

 tests/interactive/test-text-field.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3fdb0a59509aeaeb07c276ebd09df355626cfb92
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 10 11:57:58 2010 +0000

    uprof: make the Redrawing timer a child of the Master Clock
    
    Previously it was a child of the Mainloop, but it's more closely
    a child of the Master Clock.

 clutter/clutter-backend.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1899dbdc270e0bd494d174dd6bfbb9c5d18e174f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Feb 10 12:18:41 2010 +0000

    backend-glx: Fix glXQueryVersion test
    
    This fixes some backwards logic for asserting that we have a GLX major
    version == 1 and a minor version >= 2. (NB: Although we technically
    depend on GLX 1.3 features, we still have to support drivers that report
    GLX 1.2 because there are a lot of mesa drivers out there incorrectly
    report GLX 1.2 even though they export extensions that depend on GLX
    1.3)

 clutter/glx/clutter-backend-glx.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce1bb3d858fd02d6bcfb94b2b8999cfd7d0a4535
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 10 12:41:09 2010 +0000

    cogl-material: Layers are not equal if the filters aren't equal
    
    A material layer can not be considered equal if it is using different
    texture filtering modes. This was causing problems where rectangles
    with different filters would end up batched together and then rendered
    with the wrong filter mode.

 clutter/cogl/cogl/cogl-material.c | 5 +++++
 1 file changed, 5 insertions(+)

commit b61c2b510b5f5a72ae6181cdce646d7018fbd996
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 10 10:58:14 2010 +0000

    build: Tweak internal defines for building Clutter
    
    When building Clutter we should:
    
      • disable Cogl deprecated API;
      • enable experimental API.

 clutter/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 4a9f08639f7127719f5b59ee9287641ba4912063
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 20 18:53:36 2010 +0000

    debug: Adds CLUTTER_DEBUG=disable-swap-events option
    
    This allows us to forcibly disable the use of the GLX_INTEL_swap_events
    extension for testing or debugging purposes.

 clutter/clutter-debug.h           | 37 +++++++++++++++++++------------------
 clutter/clutter-main.c            |  3 ++-
 clutter/glx/clutter-backend-glx.c |  3 ++-
 3 files changed, 23 insertions(+), 20 deletions(-)

commit 5d702853b814445590aafe448bfc8f7993b06638
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Nov 12 20:37:01 2009 +0000

    glx backend: Adds support for GLX_INTEL_swap_event
    
    If your OpenGL driver supports GLX_INTEL_swap_event that means when
    glXSwapBuffers is called it returns immediatly and an XEvent is sent when
    the actual swap has finished.
    
    Clutter can use the events that notify swap completion as a means to
    throttle rendering in the master clock without blocking the CPU and so it
    should help improve the performance of CPU bound applications.

 clutter/clutter-feature.h         |  3 +-
 clutter/clutter-master-clock.c    | 72 +++++++++++++++++++++++++----
 clutter/clutter-private.h         |  2 +
 clutter/clutter-stage-window.c    | 13 ++++++
 clutter/clutter-stage-window.h    |  3 ++
 clutter/clutter-stage.c           |  8 ++++
 clutter/glx/Makefile.am           |  2 +
 clutter/glx/clutter-backend-glx.c | 56 ++++++++++++++++++-----
 clutter/glx/clutter-backend-glx.h |  3 ++
 clutter/glx/clutter-event-glx.c   | 96 +++++++++++++++++++++++++++++++++++++++
 clutter/glx/clutter-event-glx.h   | 38 ++++++++++++++++
 clutter/glx/clutter-stage-glx.c   | 21 +++++++++
 clutter/glx/clutter-stage-glx.h   |  2 +
 clutter/x11/clutter-backend-x11.c | 10 ++++
 clutter/x11/clutter-backend-x11.h |  7 +++
 clutter/x11/clutter-event-x11.c   |  5 ++
 doc/HACKING.backends              |  8 ++++
 17 files changed, 327 insertions(+), 22 deletions(-)

commit 848db1ee4cc910542435bbcd3a57933bdf70269e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 14 14:03:23 2010 +0000

    glx backend: when running with GLX 1.3 then create GLXWindows for stages
    
    Some extensions only support GLX versions > 1.3 and may not support
    old style X Windows as GLXDrawables, so we now create GLXWindows for
    stages when possible.

 clutter/glx/clutter-backend-glx.c | 72 ++++++++++++++++++++++++++++++---------
 clutter/glx/clutter-backend-glx.h |  1 +
 clutter/glx/clutter-stage-glx.c   | 28 +++++++++++++++
 clutter/glx/clutter-stage-glx.h   |  1 +
 4 files changed, 86 insertions(+), 16 deletions(-)

commit ca3ab41a1b12f661fe6eecddfaf5e03b0d94d682
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 9 18:33:09 2010 +0000

    clutter-backend: Fix the error check in _clutter_backend_create_stage
    
    Commit d2bdd3cb62 fixed some compiler warnings but also broke the
    ability to create a stage. Although not having warnings from the
    compiler is nice, it is also nice to be able to create a stage so lets
    not invert the meaning of the error check.

 clutter/clutter-backend.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7b1925df82fa92fd68623c9a999ece6bf4ddfde3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 17:07:08 2010 +0000

    cogl: Move material_copy() out of the deprecated section
    
    We strongly suggest people should be using cogl_material_copy(), but it
    was hidden behind the deprecation guards.

 clutter/cogl/cogl/cogl-material.h | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d2bdd3cb62c1cba24619ae843cf087709a02643d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 16:57:14 2010 +0000

    Fix some compiler warnings
    
    GCC complains that some variable might be used uninitialized.

 clutter/clutter-backend.c             | 6 ++++--
 clutter/clutter-bin-layout.c          | 1 +
 clutter/clutter-flow-layout.c         | 6 ++++++
 clutter/clutter-text.c                | 6 ++----
 clutter/cogl/cogl/cogl-matrix-stack.c | 6 +++++-
 5 files changed, 18 insertions(+), 7 deletions(-)

commit 193c477495488446d2f3d8ab0184f882f3255f48
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 9 16:30:28 2010 +0000

    cogl-bitmap: Remove const from premult_alpha_last_four_pixels_sse2
    
    The function modifies the pixels pointed by p in-place so the pointer
    can not be constant. The compiler was accepting this because the
    modification is done from inline assembler.

 clutter/cogl/cogl/cogl-bitmap-fallback.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f5d2f58b03bf03b69f6cb92b3bdddb92b8a8ecc2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 15:29:29 2010 +0000

    docs: Clean up the unused symbols for Cogl
    
    Gtk-doc is reporting a lot of false positives in the unused text file,
    mostly because of new private files that have been added to Cogl but not
    to the gtk-doc ignore list for the Cogl API reference.
    
    Once the false positives have been removed we have a couple of really
    missing symbols that should be added to the cogl-sections.txt file.

 doc/reference/cogl/Makefile.am       | 54 ++++++++++++++++++++----------------
 doc/reference/cogl/cogl-sections.txt |  7 +++++
 2 files changed, 37 insertions(+), 24 deletions(-)

commit ecc5ffe91ace38c9d288251807e721a4cd71b052
Author: Bastian Winkler <buz@netbuz.org>
Date:   Tue Feb 9 15:19:03 2010 +0100

    cogl-buffer: Use correct argument types in cogl_buffer_set_data_EXP
    
    offset and size arguments are gsize in cogl-buffer.h
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1980
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/cogl/cogl/cogl-buffer.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9aac36b47e43e95d12c8d28bd3671e6f5e000d32
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 14:48:11 2010 +0000

    docs: Move some Cogl defines in the private section
    
    The PixelFormat bit and mask #defines should not be used and are there
    mostly for convenience, so we can push them to the "private" sub-section
    of the API reference.
    
    This pushed Cogl's API reference coverage to 100%.

 doc/reference/cogl/cogl-sections.txt | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 7ebb1e7157ab5d3efbeb37d7879d851adc7da40e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 14:41:37 2010 +0000

    docs: Fixes for Cogl API reference
    
      98% symbol docs coverage.
      335 symbols documented.
      0 symbols incomplete.
      8 not documented.
    
    Not bad, if I may say so.

 clutter/cogl/cogl/cogl-buffer.h           | 12 ++++++---
 clutter/cogl/cogl/cogl-color.h            | 41 +++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-fixed.h            |  2 +-
 clutter/cogl/cogl/cogl-material-private.h |  2 +-
 clutter/cogl/cogl/cogl-matrix.h           |  3 ++-
 clutter/cogl/cogl/cogl-types.h            | 23 ++++++++++++++++-
 doc/reference/cogl/cogl-sections.txt      | 16 +++---------
 7 files changed, 80 insertions(+), 19 deletions(-)

commit 1d28ed035f360b14cfbf5b01db4ffe2979172cf0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 13:39:08 2010 +0000

    Post-release bump to 1.1.11

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a24d4d21a0eeca771476705ef407d55fdb32e68f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 12:31:42 2010 +0000

    Release 1.1.10
    
    Brown paper bag release.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 738e73873dd0c05a44f7cb0ad40c8a854e0c75a6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 12:59:18 2010 +0000

    Update NEWS file

 NEWS | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit cccf23caa481a239b747d1fdd5e0ca5ae7f6682c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 11:29:39 2010 +0000

    build: Always build conformance tests with debug symbols
    
    Having the conformance test suite build without debug symbols doesn't
    make any sense.

 tests/conform/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e46db37c03b6adae1594729c2c5c86e65701d95b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Feb 9 13:00:39 2010 +0000

    conform: fix stack corruption in test-behaviours.c
    
    The test was calling g_object_get to fetch the "opacity-start" property
    (unsigned int) into a guint8 local variable. It's a bit of a mean trap
    given that the getter function returns guint8 values so this also adds a
    comment explaining what's going on.

 tests/conform/test-behaviours.c | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit a02253f19a722dcfbf0a32543dd563127dd7b80e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Feb 9 12:21:10 2010 +0000

    cogl-texture-2d: Use _cogl_texture_driver_gen to generate the GL tex
    
    _cogl_texture_driver_gen is needed to set the texture minification
    mode to Cogl's default of GL_LINEAR. There was also a line to set this
    in _cogl_texture_2d_new_with_size but it wasn't working because it was
    called *before* the texture was bound. If the texture was later
    rendered with the default material it then it would end up with GL's
    default mipmap filtering mode but without mipmaps so it would render
    white squares instead.

 clutter/cogl/cogl/cogl-texture-2d.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 1b2ff7eff7e97d8542e35514bfa010be706973ee
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 18 21:17:21 2009 +0000

    cogl: Use SSE2 when possible for premultiplying
    
    This adds a fast path for premultiplying an RGBA image using SSE2
    instructions. SSE registers are 128-bit and we need at least 16-bits
    per component for the intermediate result of the multiplication so we
    can do two pixels in parallel with one register. The function
    interleaves 2 SSE registers to multiply 4 pixels in one function call
    with the hope that this will pipeline better.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1939
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/cogl/cogl/cogl-bitmap-fallback.c | 104 ++++++++++++++++++++++++++++++-
 1 file changed, 103 insertions(+), 1 deletion(-)

commit bbb058df40a5e1acf7b8e42049c3cd5d966f762d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 9 10:34:41 2010 +0000

    actor: Improve readability of raise/lower warnings
    
    • Add the function name in the warning, since the text is the same in
      both clutter_actor_raise() and clutter_actor_lower().
    
    • If an actor has a name then prefer it to the type name.

 clutter/clutter-actor.c | 46 +++++++++++++++++++++++++++++-----------------
 1 file changed, 29 insertions(+), 17 deletions(-)

commit 7664568fff63501339d2cb1682ae1a9f1c27e068
Author: Halton Huo <halton.huo@gmail.com>
Date:   Tue Feb 9 10:21:37 2010 +0000

    Remove return from void functions
    
    This patch fixes compilation on suncc.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1978
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/cogl/cogl/cogl-buffer.c      | 2 +-
 clutter/cogl/cogl/cogl-sub-texture.c | 2 +-
 clutter/cogl/cogl/cogl-texture.c     | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit a23ce8606860075e35fca28eb82e57e340f2b9b9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 18:09:14 2010 +0000

    Post-release bump to 1.1.9

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a2889ed0772503dce504ab260fbbf662a0ad25d8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:57:48 2010 +0000

    Release Clutter 1.1.8

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a139bf9c40f88b46055e4cd9754ba51acca97c87
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:56:35 2010 +0000

    test-animator: Do not use mid-function blocks
    
    The test_animator_properties unit is so small that declaring a
    mid-function block for two variables is not that clever.

 tests/conform/test-animator.c | 57 +++++++++++++++++++++----------------------
 1 file changed, 28 insertions(+), 29 deletions(-)

commit 4d9327bbe14c2771896999844df3eac28da75347
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:55:29 2010 +0000

    animator: Zero the AnimatorKey:value member
    
    The test suite is showing random segfaults because the GValue member of
    AnimatorKey is not zero-ed on creation.

 clutter/clutter-animator.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit d62ddc374f88448fbde6db11ed4b10a594ecc5c4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:37:00 2010 +0000

    docs: Fixes for ClutterAnimator

 clutter/clutter-animator.c                 |  2 +-
 clutter/clutter-animator.h                 | 16 ++++++++--------
 doc/reference/clutter/clutter-sections.txt |  1 +
 3 files changed, 10 insertions(+), 9 deletions(-)

commit 9806f78905eea6e7c3b5b1f35b35650a823cb295
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:34:11 2010 +0000

    Merge me

 NEWS | 4 ++++
 1 file changed, 4 insertions(+)

commit 814d3acd0730f2e418ccc44d550e1fa369c142fe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:27:20 2010 +0000

    docs: Update NEWS

 NEWS | 53 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 53 insertions(+)

commit 419afc01e8f2c96f7cf5c0962e5c421f8f3a476f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 17:27:13 2010 +0000

    docs: Update the release notes

 README | 6 ++++++
 1 file changed, 6 insertions(+)

commit c02dded0f6793ad377b566360371c23dbe61b4bc
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Feb 8 17:11:43 2010 +0000

    cogl-buffer: Use TEXTURE as the only value for CoglBufferUsageHint
    
    We should try to use more explicit defines than GL for our hints. For
    now we only support using a CoglBuffer to generate textures.

 clutter/cogl/cogl/cogl-buffer.c        | 38 ++++++++--------------------------
 clutter/cogl/cogl/cogl-buffer.h        | 12 +++--------
 clutter/cogl/cogl/cogl-pixel-buffer.c  |  2 +-
 tests/conform/test-cogl-pixel-buffer.c | 12 +++++------
 4 files changed, 19 insertions(+), 45 deletions(-)

commit 54a6df22b038b047931dc108df35bc9e097d4e5e
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Feb 2 16:44:16 2010 +0000

    cogl-buffer: make sure the code compiles on GL ES
    
    OpenGL ES has no PBO extension, so we fallback to using a malloc'ed
    buffer. Make sure the OpenGL-only defines don't leak into the OpenGL ES
    compilation.

 clutter/cogl/cogl/cogl-buffer.c       | 28 ++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pixel-buffer.c |  7 +++++++
 clutter/cogl/cogl/cogl-texture.c      |  5 ++++-
 3 files changed, 39 insertions(+), 1 deletion(-)

commit d0fe4795368ddc55411fb081832bfcdfdfeb4314
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Feb 2 12:59:51 2010 +0000

    cogl-pixel-buffer: Add a fallback path
    
    First, let's add a new public feature called, surprisingly,
    COGL_FEATURE_PBOS to check the availability of PBOs and provide a
    fallback path when running on older GL implementations or on OpenGL ES
    
    In case the underlying OpenGL implementation does not provide PBOs, we
    need a fallback path (a malloc'ed buffer). The CoglPixelBufer
    constructors will instanciate a subclass of CoglBuffer that handles
    map/unmap and set_data() with a malloc'ed buffer.
    
    The public feature is useful to check before using set_data() on a
    buffer as it will mean doing a memcpy() when not supporting PBOs (in
    that case, it's better to create the texture directly instead of using a
    CoglBuffer).

 clutter/cogl/cogl/cogl-pixel-buffer.c              | 56 ++++++++++++++++++++--
 clutter/cogl/cogl/cogl-texture.c                   | 38 ++++++++++-----
 clutter/cogl/cogl/cogl-types.h                     |  4 +-
 .../cogl/cogl/driver/gl/cogl-feature-functions.h   |  5 ++
 4 files changed, 88 insertions(+), 15 deletions(-)

commit b5d5821304e8ca15ee4411bf7ff8f26a6a23c855
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri Jan 22 15:38:31 2010 +0000

    tests: Add a test for CoglPixelBuffers
    
    Exercise the whole public CoglBuffer / CoglPixelBuffer and
    cogl_texture_new_from_buffer API.

 .gitignore                             |   1 +
 tests/conform/Makefile.am              |   1 +
 tests/conform/test-cogl-pixel-buffer.c | 337 +++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c      |   3 +
 4 files changed, 342 insertions(+)

commit b7f049495b527547d093ca337588ceb289c9cb2b
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri Jan 22 15:07:27 2010 +0000

    cogl-texture: Add a new constructor to turn CoglBuffers into textures
    
    The only goal of using COGL buffers is to use them to create
    textures. cogl_texture_new_from_buffer() is the new symbol to create
    textures out of buffers.

 clutter/cogl/cogl/cogl-texture.c     | 55 +++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-texture.h     | 60 ++++++++++++++++++++++++++++++++++++
 doc/reference/cogl/cogl-sections.txt |  3 ++
 3 files changed, 118 insertions(+)

commit abbb668163537598790cb3eca564ea19b1e010ad
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Sun Jan 10 18:04:29 2010 +0000

    cogl-pixel-buffer: add a pixel buffer object class
    
    This subclass of CoglBuffer aims at wrapping PBOs or other system
    surfaces like DRM buffer objects. Two constructors are available:
    
    cogl_pixel_buffer_new() with a size when you only care about the size of
    the buffer (such a buffer can be used to store several texture data such
    as the three planes of a I420 frame).
    
    cogl_pixel_buffer_new_full() is more a 1:1 mapping between the data and
    an underlying surface, with the possibility of having access to a low
    level memory buffer that may have a stride.

 clutter/cogl/cogl/Makefile.am                 |   3 +
 clutter/cogl/cogl/cogl-pixel-buffer-private.h |  72 ++++++
 clutter/cogl/cogl/cogl-pixel-buffer.c         | 317 ++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pixel-buffer.h         | 165 ++++++++++++++
 clutter/cogl/cogl/cogl.h                      |   1 +
 doc/reference/cogl/cogl-sections.txt          |   6 +
 6 files changed, 564 insertions(+)

commit b5e9710cdf5795f532fe46b9dfcc704a07d99ac9
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Sun Jan 10 17:28:24 2010 +0000

    cogl-buffer: add an abstract class around openGL's buffer objects
    
    Buffer objects are cool! This abstracts the buffer API first introduced
    by GL_ARB_vertex_buffer_object and then extended to other objects.
    
    The coglBuffer abstract class is intended to be the base class of all
    the buffer objects, letting the user map() buffers. If the underlying
    implementation does not support buffer objects (or only support VBO but
    not FBO for instance), fallback paths should be provided.

 clutter/cogl/cogl/Makefile.am           |   3 +
 clutter/cogl/cogl/cogl-buffer-private.h | 102 ++++++++++++
 clutter/cogl/cogl/cogl-buffer.c         | 282 +++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-buffer.h         | 287 ++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-context.c        |   2 +
 clutter/cogl/cogl/cogl-context.h        |   5 +
 clutter/cogl/cogl/cogl.h                |   4 +
 doc/reference/cogl/cogl-docs.xml.in     |  21 +++
 doc/reference/cogl/cogl-sections.txt    |  17 ++
 9 files changed, 723 insertions(+)

commit de8a6314f12854e748de515afb487af56eaac845
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Jan 25 11:21:05 2010 +0000

    cogl: new textures sould have GL_TEXTURE_MIN_FILTER set to GL_LINEAR
    
    The only way the user has to set the mipmap filters is through the
    material/layer API. This API defaults to GL_LINEAR/GL_LINEAR for the max
    and min filters. With the main use case of cogl being 2D interfaces, it
    makes sense do default to GL_LINEAR for the min filter.
    
    When creating new textures, we did not set any filter on them, using
    OpenGL defaults': GL_NEAREST_MIPMAP_LINEAR for the min filter and
    GL_LINEAR for the max filter. This will make the driver allocate memory
    for the mipmap tree, memory that will not be used in the nominal case
    (as the material API defaults to GL_LINEAR).
    
    This patch tries to ensure that the min filter is set to GL_LINEAR
    before any glTexImage*() call is done on the texture by setting the
    filter when generating new OpenGL handles.

 clutter/cogl/cogl/cogl-texture-2d-sliced.c         |  9 ++++----
 clutter/cogl/cogl/cogl-texture-2d.c                |  9 ++++----
 clutter/cogl/cogl/cogl-texture-driver.h            |  9 ++++++++
 clutter/cogl/cogl/driver/gl/cogl-texture-driver.c  | 27 ++++++++++++++++++++++
 .../cogl/cogl/driver/gles/cogl-texture-driver.c    | 27 ++++++++++++++++++++++
 5 files changed, 72 insertions(+), 9 deletions(-)

commit c0f65212baee25dd4e66f4366a54bd847c782eb3
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Jan 11 00:15:25 2010 +0000

    cogl: Introduce the GE_RET() debug macro
    
    Some GL functions have a return value that the GE() macro is not able to
    handle. Let's define a new Ge_RET() macro which will be able to handle
    functions such as glMapBuffer().
    
    While at it, removed the unused variadic dots to the GE() macro.

 clutter/cogl/cogl/cogl-internal.h | 14 +++++++++++++-
 1 file changed, 13 insertions(+), 1 deletion(-)

commit 069ba6daf9d39b471eb5c1de6e621f1343d5f00c
Merge: cc6aefad3 6ab90899b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 16:53:11 2010 +0000

    Merge branch 'animator-parser'
    
    * animator-parser:
      docs: Describe the Animation definition syntax
      animator: Provide a ClutterScript parser
      animator: Allow retrieving type property type from a key
      script: Use a node when resolving an animation mode

commit 6ab90899badf7820ffc4f40f23bf18c979762577
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 16:50:29 2010 +0000

    docs: Describe the Animation definition syntax
    
    The ClutterAnimator documentation needs a section on the syntax of its
    ClutterScript definition, possibly with an example.

 clutter/clutter-animator.c | 59 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 59 insertions(+)

commit 4dd11d6915f75ba62b8292c3138d4cc11a28fb21
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 15:52:18 2010 +0000

    animator: Provide a ClutterScript parser
    
    The whole point of having the Animator class is that the developer can
    describe a complex animation using ClutterScript. Hence, ClutterAnimator
    should hook into the Script machinery and parse a specific description
    format for its keys.

 .gitignore                        |   2 +
 clutter/clutter-animator.c        | 303 +++++++++++++++++++++++++++++++++++---
 tests/conform/Makefile.am         |   1 +
 tests/conform/test-animator.c     |  88 +++++++++++
 tests/conform/test-conform-main.c |   2 +
 tests/data/Makefile.am            |   2 +
 tests/data/test-animator-1.json   |   5 +
 tests/data/test-animator-2.json   |  29 ++++
 8 files changed, 409 insertions(+), 23 deletions(-)

commit 790a13c0d9d2249747cfb81dcb13f83c6cc2cec1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 15:47:46 2010 +0000

    animator: Allow retrieving type property type from a key
    
    When asking a key for its target value we also ask the developer to pass
    in an initialized GValue - but we don't make it easy to know the type of
    the GValue. A developer has to ask the GObject class for the GParamSpec
    and then initialize the GValue, instead.
    
    Since we know the type of the GValue we should provide a getter for it.
    
    We should also allow developers to throw at us GValue with compatible and
    transformable types.
    
    Finally, all the accessors should be constified.

 clutter/clutter-animator.c | 93 +++++++++++++++++++++++++++++++++-------------
 clutter/clutter-animator.h | 13 ++++---
 2 files changed, 75 insertions(+), 31 deletions(-)

commit 09f91ff6eab3d617be88e11bd17c226fa4d23aed
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 15:45:43 2010 +0000

    script: Use a node when resolving an animation mode
    
    Instead of taking a string and duplicating the "is it a string or an
    integer" check in both Alpha and Animation, the function in
    ClutterScript that resolves the animation mode values should take a
    JsonNode and do all the checks it needs.

 clutter/clutter-alpha.c          | 21 +++++-------------
 clutter/clutter-animation.c      | 25 +++++----------------
 clutter/clutter-script-parser.c  | 47 +++++++++++++++++++++++++---------------
 clutter/clutter-script-private.h |  2 +-
 4 files changed, 41 insertions(+), 54 deletions(-)

commit cc6aefad345f4490f59f33eaef6f7589de1f3f9b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 14 18:11:57 2010 +0000

    cogl path: make sure marking the clip state dirty takes affect
    
    When we trashed the contents of the stencil buffer during
    _cogl_path_fill_nodes we marked the clip stack state as dirty and expected
    the clip stack code would clean up our glStencilFunc state.
    
    The problem is that we only try and update the clip state during
    _cogl_journal_init (when we flush the framebuffer state) which is only
    called when the journal first gets something logged in it.
    
    To make sure the stencil state is cleaned up we now also flush the journal
    so _cogl_journal_init will be called for the next logged rectangle.

 clutter/cogl/cogl/cogl-primitives.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 24338a7511cd09298695f0a0b51ea6a97fa6786a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Feb 5 21:56:31 2010 +0000

    clutter-master-clock: Don't wait for a frame if time goes backwards
    
    If we aren't syncing to vblank or if the last dispatch didn't cause a
    redraw then the master clock will try to wait at least a small amount
    of time before dispatching again. However if time goes backwards then
    it would not do a dispatch until time catches up again. To fix this it
    know just runs a dispatch immediately if time goes backwards.
    
    This is related to Moblin bug #3839. There was a similar fix for this
    in 9dc012c07, however that only fixed the case where timelines
    wouldn't update. If there are no animations running then the master
    clock won't even try updating timelines until time catches up.
    
    http://bugzilla.o-hand.com/show_bug.cgi?id=1974

 clutter/clutter-master-clock.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 8ac27e60707b2dfd13ba978b81421423e37ebf98
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 10:40:39 2010 +0000

    test-flow-layout: Remove unneeded Stage sizing
    
    The bug with resizable stages getting a 1, 1 window on X11 has been
    fixed by Chris.

 tests/interactive/test-flow-layout.c | 1 -
 1 file changed, 1 deletion(-)

commit 6106010b6f20980fc51d1431b623567eed10853d
Merge: 4cc269a46 c82c94e62
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 8 10:34:22 2010 +0000

    Merge remote branch 'origin/cwiiis-stage-resize'
    
    * origin/cwiiis-stage-resize:
      [stage-x11] Set the default size differently
      [stage] Set default size correctly
      Revert "[x11] Don't set actor size on ConfigureNotify"
      [x11] Don't set actor size on ConfigureNotify
      [stage] Now that get_geometry works, use it
      [stage-x11] make get_geometry always get geometry
      [stage] Get the current size correctly
      [stage] Set minimum width/height to 1x1
      [stage] Add set/get_minumum_size

commit 4cc269a4687f6ca4fcd88ada134cfa00e2b13a1a
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Fri Feb 5 12:32:00 2010 +0000

    Add ClutterAnimator
    
    ClutterAnimator is a class for managing the animation of multiple
    properties of multiple actors over time with keyframing of values.
    
    The Animator class is meant to be used to effectively describe
    animations using the ClutterScript definition format, and to construct
    complex implicit animations from the ground up.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 .gitignore                                 |    1 +
 clutter/Makefile.am                        |    2 +
 clutter/clutter-animator.c                 | 1435 ++++++++++++++++++++++++++++
 clutter/clutter-animator.h                 |  166 ++++
 clutter/clutter-types.h                    |    1 +
 clutter/clutter.h                          |    1 +
 doc/reference/clutter/clutter-docs.xml.in  |    4 +-
 doc/reference/clutter/clutter-sections.txt |   48 +
 doc/reference/clutter/clutter.types        |    1 +
 tests/interactive/Makefile.am              |    1 +
 tests/interactive/test-animator.c          |  134 +++
 11 files changed, 1793 insertions(+), 1 deletion(-)

commit c82c94e6205eda962faf5a51e663680c313be062
Author: Chris Lord <chris@linux.intel.com>
Date:   Sun Feb 7 19:17:43 2010 +0100

    [stage-x11] Set the default size differently
    
    We want to set the default size without triggering the layout machinary,
    so change the window creation process slightly so we start with a
    640x480 window.

 clutter/clutter-stage.c         | 3 ---
 clutter/glx/clutter-stage-glx.c | 4 +++-
 clutter/x11/clutter-stage-x11.c | 4 ++--
 3 files changed, 5 insertions(+), 6 deletions(-)

commit b968defae92f3fbd5a4a762b4c817ab58989ee82
Author: Chris Lord <chris@linux.intel.com>
Date:   Sun Feb 7 14:18:14 2010 +0100

    [stage] Set default size correctly
    
    Due to the way the new sizing works, clutter stage must set its size in
    init (to maintain old behaviour) and the properties on the X11 stage
    must be initialised to 1x1 so that it actually goes ahead with the
    resize.
    
    Fixes stages that aren't user resizable and have no size set from
    appearing at 1x1.

 clutter/clutter-stage.c         | 3 +++
 clutter/x11/clutter-stage-x11.c | 4 ++--
 2 files changed, 5 insertions(+), 2 deletions(-)

commit 8083dc418b3c2b069a9b0db9323650050a3f63b1
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 16:57:37 2010 +0100

    Revert "[x11] Don't set actor size on ConfigureNotify"
    
    This reverts commit 29cc027f069c9ad900b9044cd40075c2d17be736.
    
    I misunderstood the problem, this commit breaks resizes coming from
    outside of Clutter.

 clutter/x11/clutter-event-x11.c | 4 ++++
 clutter/x11/clutter-stage-x11.c | 5 +----
 clutter/x11/clutter-stage-x11.h | 1 -
 3 files changed, 5 insertions(+), 5 deletions(-)

commit 29cc027f069c9ad900b9044cd40075c2d17be736
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 16:47:22 2010 +0100

    [x11] Don't set actor size on ConfigureNotify
    
    Calling clutter_actor_set_size in response to ConfigureNotify makes
    setting the size of the stage racy - the most common result of which
    seems to be that you can't set the stage dimensions to anything less
    than 640x480.
    
    Instead, add a first_allocation bit to the private structure of the X11
    stage and force the first resize (necessary or the default stage will be
    a 1x1 window).

 clutter/x11/clutter-event-x11.c | 4 ----
 clutter/x11/clutter-stage-x11.c | 5 ++++-
 clutter/x11/clutter-stage-x11.h | 1 +
 3 files changed, 5 insertions(+), 5 deletions(-)

commit cea9de7f047cb8c2b1d54f41ca1d77c3aff882e0
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 15:41:01 2010 +0100

    [stage] Now that get_geometry works, use it
    
    We want the actual window geometry in clutter_stage_set_minimum_size,
    not the set size. Now that the geometry function has been changed to do
    what it says, use it.

 clutter/clutter-stage.c | 14 ++++++--------
 1 file changed, 6 insertions(+), 8 deletions(-)

commit 4887707bb34faca0d7ad92f6628d18345163f5e0
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 15:34:55 2010 +0100

    [stage-x11] make get_geometry always get geometry
    
    Now that we have a minimum size getter on the stage object, change
    get_geometry to actually always return the geometry. This fixes stages
    that are set as user-resizable appearing at 1x1 size.
    
    This will need changing in other back-ends too.

 clutter/x11/clutter-stage-x11.c | 57 +++++++++++++++++------------------------
 1 file changed, 23 insertions(+), 34 deletions(-)

commit 27e33aa14ff5d14f6066da74922c960a037b5089
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 14:59:51 2010 +0100

    [stage] Get the current size correctly
    
    Get the current size of the stage correctly in
    clutter_stage_set_minimum_size. The get_geometry StageWindow function is
    not equivalent of the current size, use clutter_actor_get_size().

 clutter/clutter-stage.c | 14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit be11564b556a1b1c08b7b9e7a0a94bc00c4e6550
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 14:04:47 2010 +0100

    [stage] Set minimum width/height to 1x1
    
    Whoops, to maintain the old behaviour, make sure the default minimum
    width/height are 1x1.

 clutter/clutter-stage.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fd11d3098f0182f24666ed77973269111cb0a8f5
Author: Chris Lord <chris@linux.intel.com>
Date:   Sat Feb 6 11:23:37 2010 +0000

    [stage] Add set/get_minumum_size
    
    Add two functions to set/get the minimum stage size. This takes effect
    when a stage is set to user resizable.

 clutter/clutter-stage.c                    | 75 ++++++++++++++++++++++++++++++
 clutter/clutter-stage.h                    |  7 +++
 clutter/x11/clutter-stage-x11.c            |  6 +--
 doc/reference/clutter/clutter-sections.txt |  2 +
 4 files changed, 87 insertions(+), 3 deletions(-)

commit f973b73208bad266a2362e22e5aed1a0780d096d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Feb 6 11:00:50 2010 +0000

    Add cogl-subtexture test to the Git ignore file

 .gitignore | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit e55966d675e57d516ea5aff36b03fde63d4839d3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 5 16:22:09 2010 +0000

    Deprecate clutter_util_next_p2()
    
    The next_p2() function should have never been publicly exposed by
    Clutter.

 clutter/clutter-util.c          | 15 ++++++++-------
 clutter/clutter-util.h          |  9 ++++++---
 tests/interactive/test-shader.c | 19 +++++++++++++++++--
 3 files changed, 31 insertions(+), 12 deletions(-)

commit bbaf6b233d0120e3199d779eeb2829e56ecc279b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 5 15:31:18 2010 +0000

    docs: Fix whitespace in the App manual stub

 doc/manual/clutter-manual.xml.in | 185 +++++++++++++++++----------------------
 1 file changed, 81 insertions(+), 104 deletions(-)

commit dcdb97006b563407d43f19779ac47f0330052541
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Feb 5 14:47:39 2010 +0000

    build: Add suppressions file to EXTRA_DIST

 tests/data/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 830f2402d4f49b7173eb7fa0bda5762a4c430c9a
Merge: 1bdc3db9a 6b1b27d4f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Feb 6 00:20:07 2010 +0000

    Merge branch 'more-texture-backends'
    
    This adds three new texture backends.
    
    - CoglTexture2D: This is a trimmed down version of CoglTexture2DSliced
      which only supports a single texture and only works with the
      GL_TEXTURE_2D target. The code is a lot simpler so it has a less
      overheads than dealing with slices. Cogl will use this wherever
      possible.
    
    - CoglSubTexture: This is used to get a CoglHandle to represent a
      subregion of another texture. The texture can be used as if it was a
      standalone texture but it does not need to copy the resources.
    
    - CoglAtlasTexture: This collects RGB and RGBA textures into a single
      GL texture with the aim of reducing texture state changes and
      increasing batching. The backend will try to manage the atlas and
      may move the textures around to close gaps in the texture. By
      default all textures will be placed in the atlas.

commit 6b1b27d4f894cbefc90601eaf6214b55a71834b7
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Feb 6 00:12:10 2010 +0000

    cogl-bitmap: Update the format after (un)premultiplying
    
    The pixel format of the bitmap needs to have its premult flag cleared
    or set after the premult conversion otherwise it may get converted
    again.

 clutter/cogl/cogl/cogl-bitmap-fallback.c | 4 ++++
 clutter/cogl/cogl/cogl-texture.c         | 3 +--
 2 files changed, 5 insertions(+), 2 deletions(-)

commit 191d20eb56f31786660cd04aacc710344eb8df7a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Feb 5 17:03:04 2010 +0000

    cogl-atlas-texture: Fix a cut and paste error when getting the height
    
    There was a typo in getting the height of the full texture to check
    whether the sub region fits so that it was using the width
    instead. This was causing crashes when debugging is enabled for some
    apps.

 clutter/cogl/cogl/cogl-sub-texture.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1bdc3db9ab54316f5f313dc3e991f3a621e83586
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Feb 4 21:10:02 2010 +0000

    docs: Use % for defines not #
    
    Some links to defines in the gtk-doc annotations were using '#' instead
    of '%'.

 clutter/clutter-actor.c        |  4 ++--
 clutter/clutter-path.c         | 10 +++++-----
 clutter/cogl/cogl/cogl-fixed.c |  4 ++--
 3 files changed, 9 insertions(+), 9 deletions(-)

commit 1b94cc9268e57cc49e3bac914c4b979aec955f77
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Wed Jan 27 16:03:28 2010 +0000

    docs: fix new line in the cogl xml top level document
    
    A comma in the FSF address is wrong. Supreme Offence.

 doc/reference/cogl/cogl-docs.xml.in | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 0ea25d661b887c27beaf0bd848dfda994d88782f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 4 18:29:47 2010 +0000

    event: Do not generate click count for SCROLL events
    
    The ClutterScrollEvent structure does not have a click count field,
    so Clutter should not generate the click count for events of type
    CLUTTER_SCROLL.

 clutter/clutter-main.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 15c6fef7e3e426764bafc316794a195a086e0d03
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 4 16:49:06 2010 +0000

    tests: Add a Valgrind suppression file
    
    When running tests under Valgrind it would be useful to pass a
    suppression file for the known one-off allocations done by Clutter
    and by its dependencies. This trims the output of Valgrind and
    improves the ability to actually spot leaks.

 tests/README                        |  35 ++++++--
 tests/data/clutter-1.0.suppressions | 173 ++++++++++++++++++++++++++++++++++++
 2 files changed, 203 insertions(+), 5 deletions(-)

commit 1f70da62a73e3a10fe1ceb33d11f79fc29586fcf
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Feb 4 16:28:29 2010 +0000

    glx: Create a colormap for the dummy window
    
    Otherwise X will fail to create the window and throw a BadMatch error
    at least on NVidia.

 clutter/glx/clutter-backend-glx.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 466b00a8064ad09f0574f8f46c6df0390d7c7d00
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 4 13:59:39 2010 +0000

    glx: Clarify *why* we need the dummy window
    
    The reason why we have a dummy, offscreen Window when we create the
    GLX context is that GLX does not like it when you ask the context for
    features if it's not made current to a Drawable. Maybe in the future
    it will allow us to do so, but right now we have to make do with what
    GLX offers us.

 clutter/glx/clutter-backend-glx.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit ea5e33cf3a38edddef88ec30131c35bb8ab4bfaf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Feb 4 13:56:33 2010 +0000

    glx: Do not leak a XVisualInfo
    
    The XVisualInfo we retrieve for the dummy window should be freed after
    we used it.

 clutter/glx/clutter-backend-glx.c | 2 ++
 1 file changed, 2 insertions(+)

commit e6a3b6ebe75a2c0c3709fbe12cf04c4357b54fdd
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 3 23:08:30 2010 +0000

    cogl-texture: Avoid copying the bitmap when premultiplying from a file
    
    In cogl_texture_new_from_file we create and own a temporary
    bitmap. There's no need to copy this data if we need to do a premult
    conversion so instead it just does conversion before passing it on to
    cogl_texture_new_from_bitmap.

 clutter/cogl/cogl/cogl-texture.c | 23 ++++++++++++++++++-----
 1 file changed, 18 insertions(+), 5 deletions(-)

commit 59198b8ab8a6a7c1c3dbfa5c72abf36f8d66c543
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 3 22:54:44 2010 +0000

    cogl-texture: Split out _cogl_texture_prepare_for_upload
    
    The Cogl atlas code was using _cogl_texture_prepare_for_upload with a
    NULL pointer for the dst_bmp to determine the internal format of the
    texture without converting the bitmap. It needs to do this to decide
    whether the texture will go in the atlas before wasting time on the
    conversion. This use of the function is a little confusing so that
    part of it has been split out into a new function called
    _cogl_texture_determine_internal_format. The code to decide whether a
    premult conversion is needed has also been split out.

 clutter/cogl/cogl/cogl-atlas-texture.c   | 11 +----
 clutter/cogl/cogl/cogl-texture-private.h |  7 +++
 clutter/cogl/cogl/cogl-texture.c         | 81 +++++++++++++++++++-------------
 3 files changed, 57 insertions(+), 42 deletions(-)

commit 5063f4669c2c94d7288405005f4df14e73a4f578
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 3 19:54:12 2010 +0000

    cogl-atlas: Make the cogl_atlas_* API internal
    
    This just adds an underscore to every entry point for the CoglAtlas
    API so that it's not exported.

 clutter/cogl/cogl/cogl-atlas-texture.c |  89 ++++++++++-----------
 clutter/cogl/cogl/cogl-atlas.c         | 140 ++++++++++++++++-----------------
 clutter/cogl/cogl/cogl-atlas.h         |  32 ++++----
 clutter/cogl/cogl/cogl-context.c       |   2 +-
 4 files changed, 132 insertions(+), 131 deletions(-)

commit cd3c5155d879782a6e6e1d7fa56043e03712b727
Author: Jussi Kukkonen <jku@linux.intel.com>
Date:   Wed Feb 3 17:04:38 2010 +0000

    text: implement del_word_next/del_word_prev()
    
    Bind ctrl-backspace and ctrl-del to functions that delete a word before
    or after the cursor, respectively.
    
    Selection does not affect the deletion, but current selection is
    preserved. This mimicks GTK+ functionality in GtkTextView and GtkEntry.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1767
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-text.c | 95 ++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 95 insertions(+)

commit d8d728a8d7ac4bc56f058379d76f4539d01189de
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 9 00:50:33 2009 +0000

    Remove the SDL backend
    
    The SDL API is far too limited for the windowing system needs of
    Clutter; the status of the SDL backend was always experimental, and
    since the Windows platform is supported by a native backend there is
    no point in having the SDL backend around any more.

 README                            |   8 +-
 clutter/Makefile.am               |   2 +-
 clutter/sdl/Makefile.am           |  26 ---
 clutter/sdl/clutter-backend-sdl.c | 207 ---------------------
 clutter/sdl/clutter-backend-sdl.h |  70 -------
 clutter/sdl/clutter-event-sdl.c   | 377 --------------------------------------
 clutter/sdl/clutter-sdl.h         |  39 ----
 clutter/sdl/clutter-stage-sdl.c   | 197 --------------------
 clutter/sdl/clutter-stage-sdl.h   |  34 ----
 configure.ac                      |  41 +----
 10 files changed, 5 insertions(+), 996 deletions(-)

commit ae188d203c63d680dc58ba1e19f333719a6916d4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jan 20 16:41:25 2010 +0000

    win32: Use a dummy window to support delayed stage creation
    
    The Win32 backend now implements the create_context method which
    creates a context and binds it to a 1x1 invisible window. That way
    there will always be a context bound and the features can be retrieved
    without creating the default stage. This reflects the changes in
    1c6ffc8..b245d55 to the GLX backend.

 clutter/win32/clutter-backend-win32.c | 194 ++++++++++++++++++++++++++++++++--
 clutter/win32/clutter-backend-win32.h |   2 +
 clutter/win32/clutter-stage-win32.c   |  84 +++------------
 3 files changed, 198 insertions(+), 82 deletions(-)

commit 479fdffc7d4f37f9ff104403dd7de685df97e0d5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Dec 6 18:56:14 2009 +0000

    glx: Fix error messages and debug notes
    
    Instead of using g_critical() inside the create_context() implementation
    of the ClutterBackendGLX we should use the passed GError, so that the
    error message can bubble up to the caller.

 clutter/glx/clutter-backend-glx.c | 31 +++++++++++++++++++------------
 1 file changed, 19 insertions(+), 12 deletions(-)

commit ede2cbfab05035247b2a6a2ca837cb8f71871c5d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 21:07:45 2009 +0000

    stage: Create the default stage on demand
    
    Instead of creating the default stage during initialization we can
    now safely create it whenever clutter_stage_get_default() is called.
    
    To maintain the invariant, the default stage is immediately realized
    by Clutter itself.

 clutter/clutter-main.c  | 28 ----------------------------
 clutter/clutter-stage.c | 15 ++++++++++-----
 2 files changed, 10 insertions(+), 33 deletions(-)

commit d2c091e62d4b9e897e8f8ef5de99f20417cc6682
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 20:49:54 2009 +0000

    glx: Create the dummy Window with the GLX context
    
    Since we must guarantee that Cogl has a GL context to query, it is too
    late to use the "dummy Window" trick from within the get_features()
    virtual function implementation.
    
    Instead, we can create a dummy Window from create_context() itself and
    leave it around - basically trading a default stage with a dummy X
    window.
    
    We need to have the dummy X window around all the time so that the
    GLX context can be selected and made current.

 clutter/clutter-main.c            |  16 ++--
 clutter/glx/clutter-backend-glx.c | 169 +++++++++++++++++++-------------------
 clutter/glx/clutter-backend-glx.h |   1 +
 3 files changed, 95 insertions(+), 91 deletions(-)

commit 5eb6fb74b660d22e7f31867b16997ee9f63bef4b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 20:48:55 2009 +0000

    feature: Make sure we have a GL context
    
    Before asking Cogl and ClutterBackend for the list of features we must
    have a GL backend ready.

 clutter/clutter-feature.c | 3 +++
 1 file changed, 3 insertions(+)

commit a8daaa8222c9b4aaf7e46b1bb13a2ce8097153f1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 20:47:48 2009 +0000

    stage: Move default title in Stage.init
    
    The default title should be set from within clutter_stage_init(); at
    that point clutter_init() must have been called.

 clutter/clutter-main.c  | 2 --
 clutter/clutter-stage.c | 1 +
 2 files changed, 1 insertion(+), 2 deletions(-)

commit 38f26634eec3c81d61bb3b88b24563d7e4719f67
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 17:36:03 2009 +0000

    Lazily create the Pango fontmap
    
    The Pango fontmap needed by Clutter should be initialized the first
    time we need a PangoContext, not on initialization.

 clutter/clutter-main.c | 35 ++++++++++++++++-------------------
 1 file changed, 16 insertions(+), 19 deletions(-)

commit 6fbed66add4b8c03a0ba0f4edc1c2f0044608998
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 17:13:44 2009 +0000

    Delay default stage creation
    
    The default stage creation should be delayed as much as possible,
    ideally at the end of the init() process.

 clutter/clutter-backend.c         |  8 ++++
 clutter/clutter-main.c            | 67 +++++++++++++-------------
 clutter/clutter-stage.c           |  6 +--
 clutter/cogl/cogl/cogl-journal.c  |  3 ++
 clutter/glx/clutter-backend-glx.c | 98 +++++++++++++++++++++++++++++----------
 clutter/glx/clutter-stage-glx.c   |  5 ++
 6 files changed, 126 insertions(+), 61 deletions(-)

commit 3191ea1195d5e1d55facc147760b273efca76867
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 3 17:35:19 2009 +0000

    cogl-debug: Remove redundant newlines
    
    The debugging notes wrapping g_debug() already have an implicit newline
    at the end of the passed message.

 clutter/cogl/cogl/cogl-handle.h | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 16a5911cff90a2bba1b283ccd9a9ce6d0f435924
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 3 15:05:37 2010 +0000

    tests: Clean up the cairo-flowers interactive test

 tests/interactive/test-clutter-cairo-flowers.c | 14 ++++++--------
 1 file changed, 6 insertions(+), 8 deletions(-)

commit cb52581a24c157e2bedb74c32d522dc56d9a91a2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Feb 3 14:35:45 2010 +0000

    text: Add :font-description
    
    High level toolkits might wish to construct a PangoFontDescription and
    then set it directly on a ClutterText actor proxy or sub-class.
    ClutterText should have a :font-description property to set (and get)
    the PangoFontDescription.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1960

 clutter/clutter-text.c                     | 131 +++++++++++++++--
 clutter/clutter-text.h                     | 225 +++++++++++++++--------------
 doc/reference/clutter/clutter-sections.txt |   2 +
 3 files changed, 234 insertions(+), 124 deletions(-)

commit 74c0170ccc80504018f2aab849a6a311c64052a6
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Feb 3 14:31:12 2010 +0000

    cogl-vertex-buffer: Refix disabling texture coord arrays
    
    Commit 92a375ab4 changed the initial value of max_texcoord_attrib_unit
    to -1 so that it could disable the texture coord array for the first
    texture unit when there are no texture coords used in the vbo. However
    max_texcoord_attrib_unit was an unsigned value so this actually became
    G_MAXUINT. The disabling loop at the bottom still worked because
    G_MAXUINT+1==0 but the check for whether any texture unit is greater
    than max_texcoord_attrib_unit was failing so it would always end up
    disabling all texture units. This is now fixed by changing
    max_texcoord_attrib_unit to be signed.

 clutter/cogl/cogl/cogl-vertex-buffer.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 301863d43bc79e792f8fe3ea5e9185d87cb74069
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 2 17:07:22 2010 +0000

    text: Fixes for selection bound
    
    The commit ecbb7ce41a1a759e246fce07f146b8bed5e3d730 exposed some issues
    when positioning the cursor with the mouse pointer: the selection is
    not moved along with the cursor when inserting a single character or a
    string.
    
    Also, some freeze_notify() are called too early, leading to decoupling
    from their respective thaw_notify().
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1955

 clutter/clutter-text.c | 44 +++++++++++++++++++-------------------------
 1 file changed, 19 insertions(+), 25 deletions(-)

commit 5bec49aea931e6835b97e549e23458a6214548ce
Author: Kristian Høgsberg <krh@bitplanet.net>
Date:   Wed Jan 27 12:55:18 2010 -0500

    Use ClutterTimeline in test-clutter-cairo-flowers.c
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1969
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 tests/interactive/test-clutter-cairo-flowers.c | 24 +++++++++++++++++-------
 1 file changed, 17 insertions(+), 7 deletions(-)

commit c9a6e63fa4d1d710d9efeb850f3fc336933ee2a8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 2 14:50:03 2010 +0000

    docs: Clarify Group's sizing semantics
    
    The documentation for ClutterGroup behaviour when setting an explicit
    size is not accurate - or, actually, it was accurate by the time
    ClutterGroup was first written but has been neglected in the following
    release cycles.
    
    To avoid confusion for new users of Clutter the documentation should be
    slightly expanded, mentioning the exact semantics of ClutterGroup with
    regards to: preferred size, explicitly set size and how to constrain the
    visible area of a ClutterGroup to an explicitly set size.
    
    Based on a patch by: Neil Roberts <neil@linux.intel.com>

 clutter/clutter-group.c | 16 ++++++++++++----
 1 file changed, 12 insertions(+), 4 deletions(-)

commit 12b004b0e7e13ca64d7d35cd3fe083f582b7aa09
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 2 12:56:04 2010 +0000

    tests: Add an initial Behaviour conformance suite
    
    The coverage of the Behaviour sub-classes is currently abysmal. An
    initial test suite for Behaviours should at least verify that the
    accessors and the constructors are doing the right thing.
    
    This initial test suite just verifies the BehaviourOpacity sub-class,
    but it already bumps up the overall coverage by 2%.

 .gitignore                        |  1 +
 tests/conform/Makefile.am         |  1 +
 tests/conform/test-behaviours.c   | 87 +++++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c |  2 +
 4 files changed, 91 insertions(+)

commit f94e6911510b5376dd490c1f8724e616aaf2e5dc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Feb 2 12:54:51 2010 +0000

    behaviour: Clean up BehaviourOpacity
    
    • Use a consistent coding style
    
    • Call set_bounds() from set_property(), because we need proper
      notification on the modified property

 clutter/clutter-behaviour-opacity.c | 56 +++++++++++++++++++++----------------
 1 file changed, 32 insertions(+), 24 deletions(-)

commit 521d71d4bc4ca4b06343365c71c9520b1ebfdc7f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 1 15:47:50 2010 +0000

    event: Unify the off-stage motion events delivery behaviour
    
    When we disable the per-actor events delivery Clutter replicates the X11
    implicit soft grab for motion events with off-stage. The implicit grab
    is done whenever the pointer of a device leaves a window with a button
    still pressed; with the implicit grab in place the window still receives
    motion events even after the LeaveNotify - until the button is released.
    
    The implicit grab is not honoured in the per-actor event deliver case,
    though, so we have a mismatch between two in theory equivalent cases.
    
    Luckily, the fix is pretty trivial: when we check for a motion event
    with a stage set but without an actor set, and that has off-stage
    coordinates, we arbitrarily set the source to be the stage of the event
    and emit the pointer event.

 clutter/clutter-main.c | 40 ++++++++++++++++++++++++++++++++++------
 1 file changed, 34 insertions(+), 6 deletions(-)

commit 46d6697b9170ba110439cbf61d152890b35a3837
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 1 14:53:13 2010 +0000

    build: -Wformat is required for -Wformat-security
    
    GCC will ignore -Wformat-security without -Wformat on the same compiler
    flags.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 157a0cf9364a9e60b29e5e88ca1783d9e174a635
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 1 14:48:50 2010 +0000

    build: Retrieve X11 cflags and libraries
    
    When using pkg-config to check for the x11 package compiler flags and
    libraries we actually need to retrieve those values from the pc file.
    
    This should also fix the issue with non-canonical installations of the
    X11 headers and shared objects.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1966

 configure.ac | 5 +++++
 1 file changed, 5 insertions(+)

commit 145cc9d3dfd1dc51f254eefde35042fc20a6375e
Merge: aa6731e33 5f1c8a17e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Feb 1 13:37:19 2010 +0000

    Merge remote branch 'master' into texture-debugging
    
    Conflicts:
            clutter/cogl/cogl/cogl-context.h

commit aa6731e338a88d03e718980604ac8f2393391a9f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Feb 1 13:25:19 2010 +0000

    cogl-material: Compare GL texture numbers for material layer textures
    
    When deciding if a material layer is equal it now compares the GL
    target and texture number if the textures are not sliced. This is
    needed to get batching across atlased textures.

 clutter/cogl/cogl/cogl-material.c | 25 ++++++++++++++++++++++++-
 1 file changed, 24 insertions(+), 1 deletion(-)

commit abe91784c4ba98417eabe0649bf73381afbd6fc7
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Feb 1 12:11:58 2010 +0000

    cogl: Let GL do the format conversion when uploading texture data
    
    Cogl accepts a pixel format for both the data in memory and the
    internal format to be used for the texture. If they do not match then
    it would convert them using the CoglBitmap functions before uploading
    the data. However, GL also lets you specify both formats so it makes
    more sense to let GL do the conversion. The driver may need the
    texture in a specific format so it may end up being converted anyway.
    
    The cogl_texture_upload_data functions have been removed and replaced
    with a single function to prepare the bitmap. This will only do the
    premultiplication conversion because that is the only part that GL
    can't do directly.

 clutter/cogl/cogl/cogl-atlas-texture.c     | 111 +++++++--------
 clutter/cogl/cogl/cogl-texture-2d-sliced.c | 220 ++++++++++++++++-------------
 clutter/cogl/cogl/cogl-texture-2d.c        |  92 ++++++------
 clutter/cogl/cogl/cogl-texture-private.h   |  44 ++----
 clutter/cogl/cogl/cogl-texture.c           | 136 ++++++++----------
 5 files changed, 290 insertions(+), 313 deletions(-)

commit e83ffb1fa3436bf1506c32856b2a3ba23254e068
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 29 15:15:08 2010 +0000

    cogl: Do the premult conversion in-place rather than copying to a new buffer
    
    The premult part of _cogl_convert_premult has now been split out as
    _cogl_convert_premult_status. _cogl_convert_premult has been renamed
    to _cogl_convert_format to make it less confusing. The premult
    conversion is now done in-place instead of copying the
    buffer. Previously it was copying the buffer once for the format
    conversion and then copying it again for the premult conversion. The
    premult conversion never changes the size of the buffer so it's quite
    easy to do in place. We can also use the separated out function
    independently.

 clutter/cogl/cogl/cogl-atlas-texture.c     |   6 +-
 clutter/cogl/cogl/cogl-bitmap-fallback.c   | 142 +++++++++++------------------
 clutter/cogl/cogl/cogl-bitmap-pixbuf.c     |   6 +-
 clutter/cogl/cogl/cogl-bitmap-private.h    |  22 ++---
 clutter/cogl/cogl/cogl-bitmap.c            | 102 ++++++++-------------
 clutter/cogl/cogl/cogl-texture-2d-sliced.c |  12 +--
 clutter/cogl/cogl/cogl-texture-2d.c        |  12 +--
 clutter/cogl/cogl/cogl-texture.c           |   6 +-
 8 files changed, 123 insertions(+), 185 deletions(-)

commit 72fba19eac68ffa30c3f60aeecfdbfa6a2da7bd4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 29 12:19:42 2010 +0000

    cogl-atlas-texture: Use a single atlas for both RGB and RGBA textures
    
    The internal format of the atlas texture is still set to the
    appropriate format so Cogl will disable blending for textures that are
    intended to be RGB. This should end up ignoring the alpha channel from
    the texture in the atlas. This makes the code slightly easier to
    maintain and should also improve the chances of batching.

 clutter/cogl/cogl/cogl-atlas-texture.c | 134 ++++++++++++---------------------
 clutter/cogl/cogl/cogl-context.c       |  18 ++---
 clutter/cogl/cogl/cogl-context.h       |   8 +-
 3 files changed, 57 insertions(+), 103 deletions(-)

commit ad6bd2ee88770c2ce86f81f7a64b6b121c3418d6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 1 12:18:10 2010 +0000

    actor: Reword the allocation cycle warning
    
    Since we're allowing allocation cycles saying that calling
    queue_relayout() inside an allocation cycle "is not allowed" is kind of
    confusing. We should say that "it is not recommended".

 clutter/clutter-actor.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5f1c8a17e4f81ead1747b47939d593c80246bf06
Merge: ecbb7ce41 8a4b64715
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 1 11:26:56 2010 +0000

    Merge branch 'device-manager'
    
    * device-manager: (37 commits)
      x11: Re-enable XI1 extension keyboards
      x11: Always handle core device events before XI events
      docs: Documentation fixes for DeviceManager
      device-manager: Fix the signals definition
      docs: Add sections for InputDevice and DeviceManager
      docs: Add clutter_input_device_get_device_name()
      tests: Print out the device details on motion
      Always register core devices
      device: Remove unused is_default member
      win32: Experimental implementation of device support
      tests: Print the device name, as well as its Id
      x11: Fill out the :name property of the InputDevices
      device: Add the :name property to InputDevice
      x11: Store core devices on the X11 Backend singleton
      device: Unset the cursor actor when leaving the stage
      device: Add pointer actor getter
      x11: Discard the LeaveNotify for off-stage ButtonRelease
      device: Do not overwrite the stage for an InputDevice
      event: Off-stage button releases have a click count of 1
      event: Scroll events do not have click count
      ...

commit ecbb7ce41a1a759e246fce07f146b8bed5e3d730
Author: Alejandro Piñeiro <apinheiro@igalia.com>
Date:   Mon Jan 25 16:13:58 2010 +0100

    Fix problems with "position" and "selection-bound" change notification
    
    Added a "selection-bound" notify on clutter_text_clear_selection as it
    changes the value.
    
    Added utility function clutter_text_set_positions, in order to
    change both cursor position and selection bound inside a
    g_object_[freeze/thaw]_notify block
    
    Added g_object_[freeze/thaw]_notify in other functions that changes
    both cursor position and selection bound
    
    Solves http://bugzilla.openedhand.com/show_bug.cgi?id=1955

 clutter/clutter-text.c | 77 ++++++++++++++++++++++++++++++++++----------------
 1 file changed, 53 insertions(+), 24 deletions(-)

commit 579a9a2665b402405820585dacba137984700110
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Feb 1 11:04:59 2010 +0000

    stage: Add :key-focus property
    
    ClutterStage has both set_key_focus() and get_key_focus() methods, but
    there is no :key-focus property. This means that it is not possible to
    get notifications when the key-focus has changes except by connecting to
    both the ::key-focus-in and ::key-focus-out signals and do additional
    bookkeeping.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1956
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-stage.c | 30 +++++++++++++++++++++++++++++-
 1 file changed, 29 insertions(+), 1 deletion(-)

commit 95712f9897db7f06a6ca34661f20b388dd5a5f77
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 29 10:13:57 2010 +0000

    docs: Update the README
    
    Clean up the grammar and some wrinkles in the text.

 README | 91 ++++++++++++++++++++++++++++++++++++++++++------------------------
 1 file changed, 58 insertions(+), 33 deletions(-)

commit 5b9259ba807f4151d08bf2ea868c2cdeed97e975
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 29 09:31:13 2010 +0000

    docs: Update the configure switches in the README

 README | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

commit 763fcabd8b287445d32eadb6086b0438e3962294
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 29 09:29:53 2010 +0000

    build: Warn with --disable-conformance and --enable-gcov
    
    When building Clutter without conformance test suite we ought to warn
    the user that the coverage report is not going to be accurate.

 configure.ac | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 21d21adbc45a6e0023e4a21b357fbf392b469fb2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 29 09:29:37 2010 +0000

    Remove tabs from configure.ac

 configure.ac | 51 ++++++++++++++++++++++++++++-----------------------
 1 file changed, 28 insertions(+), 23 deletions(-)

commit 5f5f6d825f6460f532f0c0448fc403cdb95e4697
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 29 09:26:47 2010 +0000

    build: Allow disabling the conformance test suite
    
    When building Clutter for packaging on headless boxes it's pointless to
    allow building the conformance test to be built (and run on 'make
    check').

 configure.ac      | 14 +++++++++++++-
 tests/Makefile.am | 25 ++++++++++++++++++++-----
 2 files changed, 33 insertions(+), 6 deletions(-)

commit 7a1ebcbced45c21937c4407e28274fdb4a92af52
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 27 21:26:26 2010 +0000

    Whitespace fixes in cogl-util

 clutter/cogl/cogl/cogl-util.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 578e83e463d4d681de27f1b4e5d64dea8161f0f7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 27 21:16:28 2010 +0000

    Whitespace fixes

 clutter/clutter-frame-source.c     |  3 ++-
 clutter/clutter-timeout-interval.c | 38 +++++++++++++++++++++++---------------
 clutter/clutter-timeout-pool.c     |  5 +++--
 3 files changed, 28 insertions(+), 18 deletions(-)

commit 2d5eeba5d89c129f991f367f0e80c3a152f19e52
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 27 21:14:43 2010 +0000

    docs: Fixes for TimeoutPool and Frame sources
    
    The TimeoutPool is not used by ClutterTimeline any more, so we need to
    remove a sentence from its description. We also need to fix the gtk-doc
    syntax errors.

 clutter/clutter-frame-source.c | 25 +++++++++++++------------
 clutter/clutter-timeout-pool.c |  8 +-------
 2 files changed, 14 insertions(+), 19 deletions(-)

commit 046a4b80476794bebdfd9005c826a64b7c8c9f81
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 22 18:14:57 2010 +0000

    cogl: Use the colours of COGL_DEBUG=rectangles to debug batching
    
    Instead of assigning a new colour to each quad of a batch, the
    rectangle debugging code now assigns a new colour to each batch so
    that it can be used to visually see what is being batched. The colour
    is stored in a global variable that is reset during cogl_clear. This
    improves the chances that the same colour will be used for a batch in
    the next frames to avoid flickering.

 clutter/cogl/cogl/cogl-context.h |  6 +++++
 clutter/cogl/cogl/cogl-journal.c | 54 +++++++++++++++++++++++++++-------------
 clutter/cogl/cogl/cogl.c         | 11 ++++++++
 3 files changed, 54 insertions(+), 17 deletions(-)

commit 92a375ab47296a81d739ca29b0972c7abe6eda16
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 26 13:46:27 2010 +0000

    cogl-vertex-buffer: Fix disabling the texture arrays from previous prim
    
    When setting up the state for the vertex buffer,
    enable_state_for_drawing_buffer tries to keep track of the highest
    numbered texture unit in use. It then disables any texture arrays for
    units that were previously enabled if they are greater than that
    number. However if there is no texturing in the VBO then the max used
    unit would be left at 0 which it would later think meant unit 0 is
    still in use so it wouldn't disable it. To fix this it now initialises
    the max used unit to -1 which it should interpret as ‘no units are in
    use’ so it will later disable the arrays for all units.
    
    Thanks to Jon Mayo for reporting the bug.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1957

 clutter/cogl/cogl/cogl-vertex-buffer.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f288eae0fc454876c2beb87b1205681a338d7f65
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jan 27 12:06:22 2010 +0000

    docs: Add some notes about the CoglPixelFormat enums
    
    The pixel format enums didn't explain what order in memory the
    components should be so it was difficult to use them.

 clutter/cogl/cogl/cogl-types.h | 22 +++++++++++++++++++---
 1 file changed, 19 insertions(+), 3 deletions(-)

commit da392e24a55ad34bdc8fe9ac0841eca574f76194
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jan 27 11:02:34 2010 +0000

    docs: Fix some of the examples for the animation docs
    
    In the example for clutter_actor_animate the "x" and "y" properties
    are floats so they need to be passed float values in the var args
    otherwise it will crash. There was also a missing comma.
    
    There were some other minor problems with the behaviours example which
    would cause it not to compile.

 doc/reference/clutter/clutter-animation-tutorial.xml | 11 +++++------
 1 file changed, 5 insertions(+), 6 deletions(-)

commit 52cb54f5fa665fdf06270fc58121617b44877639
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Jan 26 18:47:25 2010 +0000

    cogl: Fix checks of the number of available texture units
    
    We were checking the number of texture units against the GL enum that is
    used in glGetInteger() to query that number. Let's abstract this in a
    little function.
    
    Took the opportunity to dig a bit on the usage of GL limits for the
    number of texture (image) units and document our use of them. We'll need
    something finer grained if we want to fully exploit texture image units
    with a programmable pipeline.

 clutter/cogl/cogl/cogl-internal.h |  2 ++
 clutter/cogl/cogl/cogl-material.c | 10 ++--------
 clutter/cogl/cogl/cogl.c          | 30 ++++++++++++++++++++++++++++++
 3 files changed, 34 insertions(+), 8 deletions(-)

commit 87d19b8d182c2524a5d3c30921fe2c3d4d120606
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Sun Nov 15 20:17:47 2009 +0000

    cogl: Fix gl equivalent of blend string
    
    An example of what could be the equivalent of
        "RBG = REPLACE(TEXTURE)
         A   = MODULATE(PREVIOUS,TEXTURE)"
    using the ARB_texture_env_combine extension was given, but it seems that
    a few typo were left:
        * remove a spurius GL_COMBINE_ALPHA
        * use the _ALPHA variant of SRCN and OPERANDN when setting up the
          alpha combiner

 doc/reference/cogl/blend-strings.xml | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit afb30f4013fdcb58ee35af919fdb739ab587683c
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Wed Nov 18 01:13:11 2009 +0000

    tests: blend-string: use g_assert_cmpint
    
    It's very useful to see the actual number the reference value is
    compared too when the test fails. GTest has g_assert_cmp$type()
    functions for that, so make good use of them.

 tests/conform/test-cogl-blend-strings.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit de31cbf4f7932f8d48583a476c5af9f6eed6adbd
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Jan 26 16:59:50 2010 +0000

    test-cogl-multitexture: use several materials with texture matrices
    
    A small doubt has risen about the use of CoglTextureUnit in materials:
    will texture matrices still work if we have several materials, each of
    them having at texture on the same texture unit? The answer is yes!
    
    test-cogl-multitexture has been extended to use 2 materials with about
    the same setup except a little difference: the texture matrices for the
    lightmaps rotate in opposite directions.
    
    While at it, changed the rotation behaviour by an implicit animation
    with a small additional bonus bling.

 tests/interactive/test-cogl-multitexture.c | 143 ++++++++++++++++++++---------
 1 file changed, 102 insertions(+), 41 deletions(-)

commit 06d8ebb0ba2d468d492eeb94dede095a14eec909
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Sun Nov 15 19:54:17 2009 +0000

    cogl: Create CoglTextureUnit with its associated unit number
    
    The index field of CoglTextureUnit was never set, leading to the
    creation of units with index set to 0. When trying to retrieve a texture
    unit by its index (!= 0) with _cogl_get_texture_unit(), a new one was
    created as it could not find it back in the list of textures units:
    ctx->texture_units.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1958

 clutter/cogl/cogl/cogl.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 8fc07c51a9c71aec77e4b76416ffedc72da309e2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 21 17:41:10 2010 +0000

    actor: Use GParamSpecUint for :opacity
    
    The :opacity property is defined using a GParamSpecUchar. This usually
    leads to issues with language bindings that don't have an 'unsigned
    char' type and that need to explicitly handle the conversion between
    G_TYPE_UCHAR and G_TYPE_INT or G_TYPE_UINT.
    
    The property definition already specifies an interval size of [0, 255]
    on the values; more importantly, GObject already implicitly transforms
    between G_TYPE_UCHAR and G_TYPE_UINT (the GValue transformation
    functions are registered at type system initialization time) so
    switching between a GParamSpecUchar and a GParamSpecUint should not be
    an ABI break.
    
    I have tested a simple program using the opacity property before and
    after the change and I cannot see any run-time warnings related to this
    issue.

 clutter/clutter-actor.c | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit d0f7debfba4879c3df20c0067789b063e18d93ce
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 21:44:28 2010 +0000

    test-easing: Do not reconnect signals multiple times
    
    The test should keep track of the last animation and avoid reconnecting
    signals to the same instance in case the -r argument has been passed.

 tests/interactive/test-easing.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 7073e69b4e504ddbaffad4a6139e93ddbd40b9f8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 21:42:55 2010 +0000

    animation: Verify internal state
    
    Be more drastic if the internal state is broken, and assert() if the
    expected Alpha and Timeline instances we need are not valid. This
    usually implies a library bug or a massive heap corruption.

 clutter/clutter-animation.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 8daa3035e563870fc614813fd6329c63542b129e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 21:42:10 2010 +0000

    docs: Fix the Animation:object property
    
    There is a typo in the Animation:object property gtk-doc declaration.

 clutter/clutter-animation.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0788aa43b29454efed3f60160b87881a1c84f603
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 21:41:33 2010 +0000

    animation: Add more debug annotations
    
    We need some better tracking of the Animation's lifetime.

 clutter/clutter-animation.c | 16 ++++++++++++++--
 1 file changed, 14 insertions(+), 2 deletions(-)

commit 7fa7c4a1b621eff0533ff70b1b6c9be001f62e2a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 21:36:41 2010 +0000

    animation: Transform if necessary
    
    The Animation code does transformation of values between type A and A'
    after checking for compatibility using g_value_type_compatible(). This
    is incorrect: compatibility means that the two types can be copied. The
    correct conversion should follow:
    
            if (compatible (type (A), type (A')))
              copy (A, A');
            else
              if (transformable (type (A), type (A')))
                transform (A, A');
              else
                error("Unable to trasform type A in A'");
    
    The transformation might still fail, so we need to check for errors
    there as well as a fall-through case.

 clutter/clutter-animation.c | 42 ++++++++++++++++++++++--------------------
 1 file changed, 22 insertions(+), 20 deletions(-)

commit 94249efff7ec46bbeaac04800d5a9a30c05dcde3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 21:33:28 2010 +0000

    animation: Check for value transformability
    
    We should not just check for compatibility, but also for the ability to
    transform a GValue of type A into another of type A'.
    
    Usually compatibility is enough, especially if types can be
    introspected beforehand; some times, though, we also need to check for
    transformability as a type can provide the transformation functions
    necessary for the operation.

 clutter/clutter-animation.c | 29 ++++++++++++++++++++---------
 1 file changed, 20 insertions(+), 9 deletions(-)

commit 996614cfaf582bbfbf86874a95b4a7eef3c50630
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 21 15:34:19 2010 +0000

    cogl-atlas-texture: Add a debug option to disable the atlas
    
    If the user specifies the 'disable-atlas' debug option then no texture
    will be put in the atlas.

 clutter/cogl/cogl/cogl-atlas-texture.c | 5 +++++
 clutter/cogl/cogl/cogl-debug.c         | 3 ++-
 clutter/cogl/cogl/cogl-debug.h         | 3 ++-
 3 files changed, 9 insertions(+), 2 deletions(-)

commit 4695383281d4b74baa10d78253a27b2eb541eef3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 22 00:06:17 2010 +0000

    build: Use no-define
    
    We don't need the PACKAGE and VERSION defines in the config.h.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f7e7985344420caf4897777ced6f04cddb7052ee
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 21 23:57:38 2010 +0000

    build: Add no-portability option to automake
    
    We require the GNU version of make for some of our rules, and it's been
    so for a while now.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a545f66a5c34b66d1a31387105d114ca3edd3a46
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 21 23:41:18 2010 +0000

    master clock: Improve the timeline advancement protection
    
    The commit 1c69c61745ed510f0b6ab16cb963ca01994cb9fc which improved the
    protection against timeline removals during the master clock advancement
    was only doing half the job - and actually broke the chaining of
    animations inside the ::completed signal.
    
    We cannot simply take a reference on the timelines and still use the list
    held by the master clock because the do_tick() might result in the
    creation of a new timeline, which gets added at the end of the list with
    no reference increase and thus gets disposed at the end of the iteration.
    
    We also cannot steal the master clock timelines list because a timeline
    might be removed as the direct result of do_tick() and remove_timeline()
    would not find the timeline, failing and leaving a dangling pointer
    behind.
    
    For this reason we copy the list of timelines out of the one that the
    Master Clock holds, take a reference on each timeline, advance them all,
    release the reference and free the list.

 clutter/clutter-master-clock.c | 39 +++++++++++++++++++++++++++------------
 1 file changed, 27 insertions(+), 12 deletions(-)

commit 8a4b64715486699dd8d0ea2146d0adea37d2a6c7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 20 19:40:58 2010 +0000

    x11: Re-enable XI1 extension keyboards
    
    The extension keyboard support in XInput 1.x is hopelessly broken.
    
    Nevertheless, it's possible to use some bits of it, as we prefer the
    core keyboard events to the XInput events, thus at least having proper
    handling for X11 key events on the Stage window.

 clutter/x11/clutter-backend-x11.c      |  2 --
 clutter/x11/clutter-event-x11.c        | 28 ++++++++++++++++++++++++++--
 clutter/x11/clutter-input-device-x11.c | 21 ++++++++++++++-------
 tests/interactive/test-devices.c       | 12 +++++++-----
 4 files changed, 47 insertions(+), 16 deletions(-)

commit 94f9f3bd9345d8eb1551c429615473134e3f4e8f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 16:28:00 2010 +0000

    x11: Always handle core device events before XI events
    
    The XI 1.0 layer is complementary to the X11 core devices handling; this
    means that core events will still be emitted for the core pointer and
    keyboard devices, and that secondary (floating) devices should be
    handled on top of that.
    
    Thus, the XI event handling code should be executed (if explicitly
    compiled in and enabled) if the core device events have not been parsed.
    
    Note: this is going away with XI2, which completely replaces both core and
    XI1 events.

 clutter/x11/clutter-event-x11.c | 499 ++++++++++++++++++----------------------
 1 file changed, 224 insertions(+), 275 deletions(-)

commit dc39e9eff9de0797086ea1a505855724296981f7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 15:29:52 2010 +0000

    docs: Documentation fixes for DeviceManager

 clutter/clutter-device-manager.c           | 7 ++++++-
 doc/reference/clutter/clutter-sections.txt | 2 --
 doc/reference/clutter/clutter.types        | 2 ++
 3 files changed, 8 insertions(+), 3 deletions(-)

commit 65c7ff7d05389a10eed1d881ca572082f03932fe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 15:29:14 2010 +0000

    device-manager: Fix the signals definition
    
    Add documentation for the signals, as well as using the correct type for
    the marshallers.

 clutter/clutter-device-manager.c | 26 +++++++++++++++++++++++---
 1 file changed, 23 insertions(+), 3 deletions(-)

commit 0b47acf60b46b64ae838471765d86e1c65c01cc0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 14:56:43 2010 +0000

    docs: Add sections for InputDevice and DeviceManager

 doc/reference/clutter/clutter-docs.xml.in | 2 ++
 1 file changed, 2 insertions(+)

commit 8ead5abba0ebe9c5b5c1b749bb28f7879d63aa49
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 14:42:19 2010 +0000

    docs: Add clutter_input_device_get_device_name()

 doc/reference/clutter/clutter-sections.txt | 1 +
 1 file changed, 1 insertion(+)

commit 1f5a7b61b761bf8426b1229c481574c273a5964f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 12:24:21 2010 +0000

    tests: Print out the device details on motion
    
    The test-device interactive test should print out the device name and id
    when it detects a motion event.

 tests/interactive/test-devices.c | 31 ++++++++++++++++++++++++++++++-
 1 file changed, 30 insertions(+), 1 deletion(-)

commit d8e167f1519499a27ee04a9a0d167b5ffed3ce8e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 12:22:29 2010 +0000

    Always register core devices
    
    Even with XInput support we should always register core devices. This
    allows us to handle enter and leave events correctly on the Stage and
    to have a working XInput 1.x support in Clutter.

 clutter/x11/clutter-backend-x11.c      | 87 +++++++++++-----------------------
 clutter/x11/clutter-backend-x11.h      |  1 +
 clutter/x11/clutter-event-x11.c        | 47 +++++++++++++++++-
 clutter/x11/clutter-input-device-x11.c | 14 +++---
 4 files changed, 82 insertions(+), 67 deletions(-)

commit e0b8d631593c0539c47de0158d5425391d7cdbc0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 11:52:27 2010 +0000

    device: Remove unused is_default member
    
    The is_default member of the InputDevice structure was not used
    anywhere.

 clutter/clutter-private.h         |  2 --
 clutter/x11/clutter-backend-x11.c | 11 ++---------
 2 files changed, 2 insertions(+), 11 deletions(-)

commit 74dbcede25c9dee5b40cb057a26263d580800e7e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 11:47:05 2010 +0000

    win32: Experimental implementation of device support
    
    Mostly lifted from the core pointer and keyboard X11 backend support.
    
    The win32 backend registers two devices (a core pointer and a core
    keyboard) and assigns them to the event structure when doing the
    translation from native events to Clutter events.
    
    Thanks to: Samuel Degrande <Samuel.Degrande@lifl.fr> for testing this
    patch.

 clutter/win32/clutter-backend-win32.c | 23 +++++++++++++++
 clutter/win32/clutter-backend-win32.h |  3 ++
 clutter/win32/clutter-event-win32.c   | 55 ++++++++++++++++++++++-------------
 3 files changed, 61 insertions(+), 20 deletions(-)

commit 850dd5a38fe17e82b16e19144db4ac516e349dbb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 11:40:01 2010 +0000

    tests: Print the device name, as well as its Id
    
    The test-devices interactive test should display the device name along
    with the id.

 tests/interactive/test-devices.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 66740e8000ea92b04da663a0d2ce890271d2af2f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 11:38:58 2010 +0000

    x11: Fill out the :name property of the InputDevices
    
    For the core pointer and keyboard we assign the names ourselves; for
    devices coming from XI we can use the XDeviceInfo.name member.

 clutter/x11/clutter-backend-x11.c | 5 ++++-
 clutter/x11/clutter-event-x11.c   | 9 ++++++---
 2 files changed, 10 insertions(+), 4 deletions(-)

commit cf4e05930a1243f9b58617a4a50833d5bab705b1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 11:37:43 2010 +0000

    device: Add the :name property to InputDevice
    
    The InputDevice should have a name, possibly user readable, coming from
    the backend.

 clutter/clutter-input-device.c | 46 +++++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-input-device.h |  6 +++---
 clutter/clutter-private.h      |  9 +++++++++
 3 files changed, 57 insertions(+), 4 deletions(-)

commit 79ad2b6a72bd91273e139e72af36d9b6db264001
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 11:21:52 2010 +0000

    x11: Store core devices on the X11 Backend singleton
    
    Instead of overloading the device id of 0 and 1 we should treat the core
    devices as special, and have a pointer inside the X11 backend singleton
    structure, for fast access.

 clutter/x11/clutter-backend-x11.c      |  8 +++--
 clutter/x11/clutter-backend-x11.h      |  3 ++
 clutter/x11/clutter-event-x11.c        | 13 +++----
 clutter/x11/clutter-input-device-x11.c | 63 ++++++++++++++++++++++++++++++++++
 4 files changed, 77 insertions(+), 10 deletions(-)

commit 8a579838d54d2b6f552fd32d9772f6e04f178179
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 14 17:14:33 2010 +0000

    device: Unset the cursor actor when leaving the stage
    
    When an InputDevice leaves a stage we set the stage member of
    InputDevice to NULL. We should also unset the cursor_actor (as the
    device is obviously not on an actor any more).
    
    When the device re-enters the Stage the ENTER/LEAVE event generation
    machinery will then be able to emit the ENTER event on the Stage.

 clutter/clutter-input-device.c | 43 +++++++++++++++++++++++++++---------------
 1 file changed, 28 insertions(+), 15 deletions(-)

commit 55e4315aa5889185a055f3ab2d5b5d4c9cae4dc4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 12 11:53:12 2010 +0000

    device: Add pointer actor getter
    
    ClutterInputDevice should have a getter method for retrieving the
    reactive actor underneath the pointer.

 clutter/clutter-input-device.c             | 37 ++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h             |  3 ++-
 doc/reference/clutter/clutter-sections.txt |  1 +
 3 files changed, 40 insertions(+), 1 deletion(-)

commit 25c6ebbb2c70af7f268036b10dcd8d4a965c34c3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 9 00:03:13 2009 +0000

    x11: Discard the LeaveNotify for off-stage ButtonRelease
    
    If the user presses a button on a pointer device and then moves out the
    Stage X11 will emit the following events:
    
      LeaveNotify ➔ MotionNotify ... ➔ ButtonRelease ➔ LeaveNotify
    
    The second LeaveNotify differs from the first by the state field.
    
    Unfortunately, ClutterCrossingEvent doesn't have a modifier_state field
    like other events, so we cannot provide a way for programmatically
    distinguishing them from a Clutter perspective. This is also an X11-ism
    we might not even want to replicate on every backend with sane
    enter/leave semantics.
    
    For this reason we should check inside the X11 event processing if the
    pointer device has already left the Stage and ignore the second
    LeaveNotify.

 clutter/x11/clutter-event-x11.c | 58 ++++++++++++++++++++++++-----------------
 1 file changed, 34 insertions(+), 24 deletions(-)

commit 8736b53d7cc6fd2b53649c076ef09cb69f9b37d6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 9 00:01:50 2009 +0000

    device: Do not overwrite the stage for an InputDevice
    
    The Stage field of an InputDevice is set by the backend, whenever the
    pointer enters or leaves the Stage. The Stage should not overwrite the
    stage field for every event it processes.

 clutter/clutter-stage.c | 1 -
 1 file changed, 1 deletion(-)

commit cf287db2048eae5eaa58a9cbffd42c703f345ff5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 9 00:00:49 2009 +0000

    event: Off-stage button releases have a click count of 1
    
    The ButtonRelease off-stage should not have a click count of 0 but a
    click count initialized to 1.

 clutter/clutter-main.c | 1 +
 1 file changed, 1 insertion(+)

commit bddabf6d2ca100f4d91461129d4bb097c59ac666
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 8 23:59:56 2009 +0000

    event: Scroll events do not have click count
    
    Remove the unneeded CLUTTER_SCROLL case from the click count checks.

 clutter/clutter-main.c | 1 -
 1 file changed, 1 deletion(-)

commit e30856a54d5d1e012cd2de30e519a487fd0b4f46
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 8 18:33:01 2009 +0000

    Whitespace and indentation fixes

 clutter/x11/clutter-event-x11.c | 24 ++++++++++++------------
 1 file changed, 12 insertions(+), 12 deletions(-)

commit 0f9cfd9911c21933b34c07a9616f79022bcc01e3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Dec 7 23:13:52 2009 +0000

    event: Clean up click-count detection
    
    Avoid a few indirections and direct access to the Event and InputDevice
    structures.

 clutter/clutter-main.c | 65 ++++++++++++++++++++++++++++++++++----------------
 1 file changed, 45 insertions(+), 20 deletions(-)

commit cf8a06f0186e44b3437b06c56c088e8dc465402b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Dec 7 23:05:20 2009 +0000

    device: Store the current state, not the previous
    
    The previous state for the device is used by the click count machinery
    and we should not be overwriting it at every event; instead, we should
    use a parallel storage for the current state coming from the windowing
    system.

 clutter/clutter-input-device.c | 34 +++++++++++++++++-----------------
 clutter/clutter-private.h      |  7 +++++++
 2 files changed, 24 insertions(+), 17 deletions(-)

commit 68b47e3ed479242a94f7a8d302a2900f7e28c840
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Dec 7 23:02:48 2009 +0000

    tests: Fix test-events output
    
    • The enter/leave event line should take into account the case where
      the related field is set to NULL (meaning entering from off-stage
      and leaving the stage).
    
    • The ButtonRelease line shows the click count but uses the button; the
      button *and* the click count should be displayed for both ButtonPress
      and ButtonRelease, to verify they match.

 tests/interactive/test-events.c | 16 +++++++++++-----
 1 file changed, 11 insertions(+), 5 deletions(-)

commit b3a42c3b09e256732395f7c63c4a39956d32d3da
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Dec 7 18:38:18 2009 +0000

    docs: Update the API reference
    
    Add the new symbols for InputDevice and DeviceManager

 clutter/clutter-device-manager.c           |  2 +-
 clutter/clutter-device-manager.h           |  2 +-
 clutter/clutter-main.c                     |  4 +--
 doc/reference/clutter/clutter-sections.txt | 49 +++++++++++++++++++++++++++---
 4 files changed, 49 insertions(+), 8 deletions(-)

commit 130286979d04128b51fa8662aa13b6bbd1867ca2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 24 17:54:02 2009 +0000

    Do not pick when motion event delivery is disabled
    
    The device manager does not need to update the state of the devices
    when the user has disabled the delivery of motion events to actors:
    the events will always be delivered as they are to the stage.

 clutter/clutter-device-manager.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 687c70dffa70a3256e9f734b090cb4a088e97bb1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 24 16:33:03 2009 +0000

    Rework the emission of LEAVE/ENTER event pairs
    
    The LEAVE/ENTER event pairs should be queued during the InputDevice
    update process, when we change the actor under the device pointer.
    
    This commit cleans up the event emission code inside clutter-main.c
    and the logic of the event processing.

 clutter/clutter-device-manager.c |   4 +-
 clutter/clutter-input-device.c   |  81 +++++++++++++++--
 clutter/clutter-main.c           | 190 ++++++---------------------------------
 clutter/clutter-private.h        |   2 -
 4 files changed, 104 insertions(+), 173 deletions(-)

commit 75f05646fa117b8096e033f9fad0ba9de1ee01ac
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 24 16:31:14 2009 +0000

    tests: Clean up test-events
    
    The output of test-events is a bit of a mess; this patch should clean
    it up a little bit - at least enough for it to be useful again during
    visual inspection.

 tests/interactive/test-events.c | 101 ++++++++++++++++++++++++----------------
 1 file changed, 60 insertions(+), 41 deletions(-)

commit a056ae716442e07e50ebd07cbca030776a5b3c28
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 24 16:22:44 2009 +0000

    Add docs and licensing notices

 clutter/clutter-device-manager.c | 125 ++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-device-manager.h |  29 +++++++++
 clutter/clutter-input-device.c   | 109 +++++++++++++++++++++++++++++++++-
 clutter/clutter-input-device.h   |  31 ++++++++++
 4 files changed, 288 insertions(+), 6 deletions(-)

commit 9506510d1cf794ef530f6c4db45103efb60cca63
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 8 17:51:00 2010 +0000

    Move all picking-related operations inside InputDevice
    
    The InputDevice objects stores pointer coordinates, state, stage and
    the actor under the cursor, so if the current backend provides us with
    one attached to the Event structure then we want the InputDevice itself
    to update its state and give us the ClutterActor underneath the
    pointer's cursor.

 clutter/clutter-device-manager.c | 24 +++++++++++
 clutter/clutter-event.c          | 36 ----------------
 clutter/clutter-input-device.c   | 91 ++++++++++++++++++++++++++++++++++++++--
 clutter/clutter-input-device.h   |  7 +++-
 clutter/clutter-main.c           | 60 +++++++++++++++-----------
 clutter/clutter-master-clock.c   |  7 ++--
 clutter/clutter-private.h        | 36 ++++++++++------
 clutter/clutter-stage.c          | 28 +++++++++++--
 clutter/x11/clutter-event-x11.c  | 36 ++++++++++------
 9 files changed, 225 insertions(+), 100 deletions(-)

commit 1f87cac0695dc95be4ed0219752d454d9a285e50
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 24 12:53:57 2009 +0000

    actor: Add :has-pointer property
    
    ClutterActor should be able to tell whether a pointer is within
    its area or not.

 clutter/clutter-actor.c   | 60 ++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-actor.h   |  1 +
 clutter/clutter-private.h |  3 +++
 3 files changed, 63 insertions(+), 1 deletion(-)

commit d23dd9af6bf48c3c02f685505a5a34b477d4d2b3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 23 16:07:16 2009 +0000

    device: Make InputDevice an object and subclass it for X11
    
    ClutterInputDevice should be a type that we can subclass per-backend
    to add functionality.

 clutter/Makefile.am                    |   2 +
 clutter/clutter-event.h                |  35 +------
 clutter/clutter-input-device.c         | 175 +++++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h         |  64 ++++++++++++
 clutter/clutter-main.c                 |  34 +++----
 clutter/clutter-private.h              |  19 +++-
 clutter/clutter.h                      |   1 +
 clutter/x11/Makefile.am                |   2 +
 clutter/x11/clutter-backend-x11.c      | 141 ++++++--------------------
 clutter/x11/clutter-input-device-x11.c | 151 ++++++++++++++++++++++++++++
 clutter/x11/clutter-input-device-x11.h |  25 +++++
 11 files changed, 484 insertions(+), 165 deletions(-)

commit d5331bfb5786b496cfcab925319711853db2f1d3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Nov 20 16:37:58 2009 +0000

    tests: Update the devices test
    
    Use the DeviceManager API instead of the X11 specific API.

 tests/interactive/test-devices.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 157da20e86f88bf906f0b59bafbea171a2e5e678
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Nov 20 16:24:16 2009 +0000

    x11: Always assign a device to pointer and key events
    
    Even when we are not using XInput we now have fallback devices; the
    X11 backend should always assign the default devices when translating
    the X events to Clutter events.

 clutter/x11/clutter-event-x11.c | 37 ++++++++++++++++++++++++++++---------
 1 file changed, 28 insertions(+), 9 deletions(-)

commit ca16446319b6281cf63edf3b1b6d7d4f8d41e499
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Nov 20 15:43:50 2009 +0000

    Add :is-default flag to InputDevice

 clutter/clutter-private.h         | 2 ++
 clutter/x11/clutter-backend-x11.c | 9 ++++++++-
 2 files changed, 10 insertions(+), 1 deletion(-)

commit 3027d4327ae0c5d9bb7cc831f24d5ee5e8fb107f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Nov 20 15:36:43 2009 +0000

    Port the X11 backend to the Device Manager
    
    Use the device manager to store the input devices. Also, provide
    two fallback devices when initializing the X11 backend: device 0
    for the pointer and device 1 for the keyboard.

 clutter/clutter-private.h         |   3 -
 clutter/x11/clutter-backend-x11.c | 514 +++++++++++++++++++-------------------
 clutter/x11/clutter-backend-x11.h |   6 -
 clutter/x11/clutter-event-x11.c   |   5 +-
 clutter/x11/clutter-x11.h         |   2 +
 5 files changed, 256 insertions(+), 274 deletions(-)

commit d34f1aa775e8a66bd0e599b32c761869b319c639
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Nov 20 15:35:40 2009 +0000

    Add ClutterDeviceManager
    
    The ClutterDeviceManager is a singleton object that behaves like the
    StageManager: it holds all input devices and notifies on addition and
    removal.

 clutter/Makefile.am              |   6 +-
 clutter/clutter-device-manager.c | 146 +++++++++++++++++++++++++++++++++++++++
 clutter/clutter-device-manager.h |  30 ++++++++
 clutter/clutter-main.c           |  30 ++++----
 clutter/clutter-marshal.list     |   1 +
 clutter/clutter-private.h        |  43 ++++++++----
 clutter/clutter.h                |   1 +
 7 files changed, 224 insertions(+), 33 deletions(-)

commit 1ef40b882349820d5edb2f1ed8885c3386d2cdf7
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 19 17:14:58 2010 +0000

    test-cogl-npot-texture: Use the COGL_TEXTURE_NO_ATLAS flag
    
    If the texture is put in the atlas it won't be sliced whatever size it
    is so it negates the test. We can avoid this with the NO_ATLAS flag.

 tests/conform/test-cogl-npot-texture.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 08b8b2791f91770d1a6e7aff163167d003b0fad3
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 19 17:06:28 2010 +0000

    cogl-atlas-texture: Don't create atlas textures with the premult bit
    
    Previously the atlas textures were being created with whatever format
    the first sub texture is in. Only three formats are supported so this
    only matters if the first texture is a premultiplied alpha
    texture. Instead it now masks out the premultiplied bit so that the
    textures are always either RGB_888 or RGBA_8888.

 clutter/cogl/cogl/cogl-atlas-texture.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 14a28620ae13ef041696e2e3747ec00738cfd2bd
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 15 22:56:37 2010 +0000

    win32: Use an invisible cursor when cursor-visible is FALSE
    
    The win32 backend now handles the WM_SETCURSOR message and sets a
    fully transparent cursor if the cursor-visible property has been
    cleared on the stage. The icon is stored in the library via a resource
    file. The instance handle for the DLL is needed to load the resource
    so there is now a DllMain function to grab the handle.

 clutter/Makefile.am                   |  21 +++++++++++++++-
 clutter/win32/Makefile.am             |   2 +-
 clutter/win32/clutter-backend-win32.c |  25 +++++++++++++++++++
 clutter/win32/clutter-backend-win32.h |   4 ++++
 clutter/win32/clutter-event-win32.c   |  14 +++++++++++
 clutter/win32/clutter-stage-win32.c   |  44 ++++++++++++++++++++++++++++++----
 clutter/win32/clutter-stage-win32.h   |   2 ++
 clutter/win32/invisible-cursor.cur    | Bin 0 -> 86 bytes
 clutter/win32/resources.rc            |   1 +
 configure.ac                          |   7 ++++++
 10 files changed, 113 insertions(+), 7 deletions(-)

commit 4db89759a0aa91b353ac0bb41562addfff6d76c9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 17:33:08 2010 +0000

    Post-release version bump to 1.1.7

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 07ff8d26f8097a00757e6e3cfcd587bce188ae0d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 15:44:58 2010 +0000

    Release Clutter 1.1.6

 NEWS         | 49 +++++++++++++++++++++++++++++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 50 insertions(+), 1 deletion(-)

commit 8daff42b3bcc9d59d7c87801b3926d8ed7c105a4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 15:43:25 2010 +0000

    README: Clarify the required OpenGL version
    
    Cogl will not allow OpenGL 1.2 if it doesn't have the multitexturing
    extension so we should make this clear in the README.

 README | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit fa51ff25d3555ce938922d7bbd64acb12140a774
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 13:56:56 2010 +0000

    Add build/mingw/{README,mingw-cross-compile.sh} to the dist tarball
    
    It's quite difficult to get git working on Windows so it makes sense
    to put the build instructions somewhere accessible.

 build/Makefile.am       | 2 +-
 build/mingw/Makefile.am | 1 +
 configure.ac            | 1 +
 3 files changed, 3 insertions(+), 1 deletion(-)

commit ff1d9cf090aef74efa1ec04b8cd490a45b148ae4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 12:42:20 2010 +0000

    test-texture-fbo: Disconnect the paint handler for the stage
    
    Otherwise the paint handler will still be run for the subsequent
    tests. This ends up writing to the ‘state’ variable which used to be
    on the stack so it will end up corrupting some stack variable. This
    was causing test-cogl-premult to fail.

 tests/conform/test-texture-fbo.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit ce030a3fce362cf4238d361743aaf9027ceed95a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 12:35:05 2010 +0000

    clutter-group: Use g_list_foreach in clutter_group_real_foreach
    
    g_list_foreach has better protection against the current node being
    removed. This will happen for example if someone calls
    clutter_container_foreach(container, clutter_actor_destroy). This was
    causing valgrind errors for the conformance tests which do just that.

 clutter/clutter-group.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit c4adefffd34d91fdf72365a6d11641f3c9f751cc
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 10:53:00 2010 +0000

    cogl-atlas-texture: Fix premultiplied texture formats
    
    When uploading texture data it was just calling cogl_texture_set_data
    on the large texture. This would attempt to convert the data to the
    format of the large texture. All of the textures with alpha channels
    are stored together regardless of whether they are premultiplied so
    this was causing premultiplied textures to be unpremultiplied
    again. It now just uploads the data ignoring the premult bit of the
    format so that it only gets converted once.

 clutter/cogl/cogl/cogl-atlas-texture.c | 232 ++++++++++++++++++++++-----------
 1 file changed, 158 insertions(+), 74 deletions(-)

commit b78024bd2dbf39cb86a1c1458e477af9c9353d9e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 14 17:57:43 2010 +0000

    cogl-primitives: Ensure the mipmaps for a layer before logging quads
    
    With the atlas texture backend ensuring the mipmaps can make it become
    a completely different texture which will have different texture
    coordinates or may even be sliced. Therefore we need to ensure the
    mipmaps before deciding which quads to log in the journal. This adds a
    new private function to cogl-material which ensures the mipmaps if
    needed.

 clutter/cogl/cogl/cogl-material-private.h |  6 ++++++
 clutter/cogl/cogl/cogl-material.c         | 19 +++++++++++++++----
 clutter/cogl/cogl/cogl-primitives.c       |  6 ++++++
 3 files changed, 27 insertions(+), 4 deletions(-)

commit 36f18e5ac57e068c3987d5b705f68fcc6f18d472
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 18 09:22:04 2010 +0000

    cogl: Make CoglSubTexture only work for quad rendering
    
    The sub texture backend doesn't work well as a completely general
    texture backend because for example when rendering with cogl_polygon
    it needs to be able to tranform arbitrary texture coordinates without
    reference to the other coordintes. This can't be done when the texture
    coordinates are a multiple of one because sometimes the coordinate
    should represent the left or top edge and sometimes it should
    represent the bottom or top edge. For example if the s coordinates are
    0 and 1 then 1 represents the right edge but if they are 1 and 2 then
    1 represents the left edge.
    
    Instead the sub-textures are now documented not to support coordinates
    outside the range [0,1]. The coordinates for the sub-region are now
    represented as integers as this helps avoid rounding issues. The
    region can no longer be a super-region of the texture as this
    simplifies the code quite a lot.
    
    There are two new texture virtual functions:
    
    transform_quad_coords_to_gl - This transforms two pairs of coordinates
         representing a quad. It will return FALSE if the coordinates can
         not be transformed. The sub texture backend uses this to detect
         coordinates that require repeating which causes cogl-primitives
         to use manual repeating.
    
    ensure_non_quad_rendering - This is used in cogl_polygon and
         cogl_vertex_buffer to inform the texture backend that
         transform_quad_to_gl is going to be used. The atlas backend
         migrates the texture out of the atlas when it hits this.

 clutter/cogl/cogl/cogl-atlas-texture.c       |  57 ++-
 clutter/cogl/cogl/cogl-primitives.c          |  21 +-
 clutter/cogl/cogl/cogl-sub-texture-private.h |  15 +-
 clutter/cogl/cogl/cogl-sub-texture.c         | 498 +++++++++------------------
 clutter/cogl/cogl/cogl-texture-2d-sliced.c   |  21 ++
 clutter/cogl/cogl/cogl-texture-2d.c          |  17 +
 clutter/cogl/cogl/cogl-texture-private.h     |  10 +
 clutter/cogl/cogl/cogl-texture.c             |  33 +-
 clutter/cogl/cogl/cogl-texture.h             |  22 +-
 clutter/cogl/cogl/cogl-vertex-buffer.c       |   5 +
 tests/conform/test-cogl-sub-texture.c        |  81 ++---
 tests/conform/test-conform-main.c            |   2 +-
 12 files changed, 348 insertions(+), 434 deletions(-)

commit 3d373c7278c47b18576edc8c8a0074654ce4a60e
Author: Samuel Degrande <Samuel.Degrande@lifl.fr>
Date:   Fri Nov 27 16:53:50 2009 +0100

    win32: Fix computation of the fullscreen size during stage realization
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1905
    
    Signed-off-by: Neil Roberts <neil@linux.intel.com>

 clutter/win32/clutter-stage-win32.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 12a9150f5b455e5700c745de4ad1ac5f2e43631f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 17:32:46 2010 +0000

    docs: Clarify usage of UTF-8 or ASCII art in commit messages

 doc/HACKING | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ea662b9ecaf1dd956f0cdc79ce04880270bf99de
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 17:06:56 2010 +0000

    docs: Display the features section
    
    The features section of the API reference is built but not used, and it
    has some copy-and-paste errors.

 clutter/clutter-feature.c                  | 11 +++++++++--
 clutter/clutter-feature.h                  |  8 --------
 doc/reference/clutter/clutter-docs.xml.in  |  1 +
 doc/reference/clutter/clutter-sections.txt |  2 +-
 4 files changed, 11 insertions(+), 11 deletions(-)

commit cdfd9eb212829df0408431673bedfbe6b566fefe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 14:50:06 2010 +0000

    Add test-cogl-texture-mipmaps to the Git ignore file

 .gitignore | 1 +
 1 file changed, 1 insertion(+)

commit e019547e8c7d110332a9ba071737736a059f5b4b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 14:48:42 2010 +0000

    x11: Fix typo in clutter_x11_set_use_argb_visual() declaration
    
    The function should have a lowercase x11, not an uppercase X11 in its
    name.

 clutter/x11/clutter-x11.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 148145ea1ad24fb1ceca3229c4cae9c7c5755f75
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 15 14:47:20 2010 +0000

    docs: Ignore clutter-profile.h

 doc/reference/clutter/Makefile.am | 57 ++++++++++++++++++++-------------------
 1 file changed, 29 insertions(+), 28 deletions(-)

commit b844653c649277eed63b6a85d29b84aab8abe641
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 11 16:23:38 2010 +0000

    cogl-texture: Fix manual repeating for negative coordinates
    
    When calculating the next integer position for negative coordinates it
    would not increment if the position is already a multiple of one so we
    need to manually add one.

 clutter/cogl/cogl/cogl-texture.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit a01b4eefceb1d490d918eba1729c87354695d1ca
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 11 16:21:56 2010 +0000

    cogl-texture-2d: Fix the coordinate wrapping for negative coordinates
    
    The formula to wrap the coordinates to the [0,1] range was broken when
    the coordinates were negative.

 clutter/cogl/cogl/cogl-texture-2d.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ead43995364bb8865ca5bab15d1bfd295578fff4
Merge: 34b50934b a70ebe4f5
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 15 12:15:46 2010 +0000

    Merge branch 'master' into more-texture-backends

commit a70ebe4f52e192c11f8db6a4fa1f419a5b175ab3
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 15 12:02:09 2010 +0000

    tests: Add a simple conformance test for texture mipmaps
    
    This adds a test which renders a texture into a 1x1 pixel quad with
    and without filters that use mipmaps. The pixel without mipmaps will
    be one of the colors from the texture and the one with will be the
    average of all the pixels in the texture.

 tests/conform/Makefile.am                 |   1 +
 tests/conform/test-cogl-texture-mipmaps.c | 147 ++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c         |   1 +
 3 files changed, 149 insertions(+)

commit ba4622ff8bd1abde577fa26637fd1afec1b3abd6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 14 15:23:41 2010 +0000

    Add a notice of deprecation in the pre-Git ChangeLog

 ChangeLog.pre-git-import | 6 ++++++
 1 file changed, 6 insertions(+)

commit 8247bdf4f9b940fe69165ae6556511fcc9ca3a5d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 12 21:44:40 2010 +0000

    cogl-framebuffer: Return gboolean from try_creating_fbo
    
    When try_creating_fbo fails it returns 0 to report the error and if it
    succeeds it returns ‘flags’. However cogl_offscreen_new_to_texture
    also passes in 0 for the flags as the last fallback to create the fbo
    with nothing but the color buffer. In that case it will return 0
    regardless of whether it succeeded so the last fallback will always be
    considered a failure.
    
    To fix this it now just returns a gboolean to indicate whether it
    succeeded and the flags used for each attempt is assigned when passing
    the argument rather than from the return value of the function.
    
    Also if the only configuration that succeeded was with flags==0 then
    it would always try all combinations because last_working_flags would
    also be zero. To avoid this it now uses a separate gboolean to mark
    whether we found a successful set of flags.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1873

 clutter/cogl/cogl/cogl-framebuffer.c | 56 ++++++++++++++++++------------------
 1 file changed, 28 insertions(+), 28 deletions(-)

commit c6ce9c338966188248c3c1ae7b10480205fe20bf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 14 14:07:04 2010 +0000

    conform: Add operators tests for ClutterColor
    
    The clutter_color_add() and clutter_color_subtract() functions are
    lacking unit testing to catch eventual regressions.

 .gitignore                        |  1 +
 tests/conform/test-color.c        | 57 +++++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c |  1 +
 3 files changed, 59 insertions(+)

commit 4388509a1589dbac7aae0ebe5995ca0e06f7c70c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 14 12:28:07 2010 +0000

    master-clock: Add profiling timers
    
    Use the newly-added profiling timers inside the master clock dispatch
    function to see how much time we spend:
    
      • in the whole function
        • in the event processing for each stage
        • in the timeline advancement

 clutter/clutter-master-clock.c | 31 +++++++++++++++++++++++++++++++
 1 file changed, 31 insertions(+)

commit 6e82d11daf8b1d7259c26e6a0816392a71c726f3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 13 17:31:13 2010 +0000

    units: Improve coverage of clutter_units_from_string()
    
    Add a unit for an empty string as well as units for the missing unit
    types like cm, mm and px.

 tests/conform/test-clutter-units.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit ed735ae730ea2140ef4d1be9d1947dbdce8b1f28
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 13 16:57:55 2010 +0000

    Add test-cogl-multitexture to the Git ignore file

 .gitignore | 1 +
 1 file changed, 1 insertion(+)

commit a076e0e11d222ca17dbdbadb3aa2c762d32a5730
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 13 16:35:53 2010 +0000

    build: Add a script to format gcov report lines
    
    Instead of using echo let's try Perl and the format() built-in.

 build/Makefile.am                |  2 ++
 build/autotools/Makefile.am.gcov |  2 +-
 build/gen-gcov.pl                | 44 ++++++++++++++++++++++++++++++++++++++++
 3 files changed, 47 insertions(+), 1 deletion(-)

commit 948db40c875f8eb7032582a32515737be6587067
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 4 14:53:03 2010 +0000

    Add gcov support to the build
    
    Using gcov it's possible to get a coverage report, that is a break down
    of how much the exposed API is exercised by the conformance test suite.

 .gitignore                       |  2 ++
 Makefile.am                      |  3 +++
 build/autotools/Makefile.am      |  1 +
 build/autotools/Makefile.am.gcov | 33 +++++++++++++++++++++++++++++++++
 clutter/Makefile.am              | 20 +++++++++++---------
 configure.ac                     | 26 ++++++++++++++++++++++++++
 6 files changed, 76 insertions(+), 9 deletions(-)

commit 5322546a4e2100bcec8aba651f8de7d849d67711
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 13 15:40:36 2010 +0000

    build: Clean up COGL build flags

 clutter/cogl/cogl/Makefile.am | 53 +++++++++++++++++++++----------------------
 1 file changed, 26 insertions(+), 27 deletions(-)

commit 18d96005ec4d1395d70d71f2bef6cc378f4afb43
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Nov 2 17:08:55 2009 +0000

    texture: Remove reading the texture data back in ::unrealize()
    
    Reading back the texture data in unrealize does not seem like a
    desirable feature any more, clutter has evolved a lot since it was
    implemented.
    
    What's wrong with it now:
    
      * It takes *a lot* of time to read the data back with glReadPixel(),
      * When several textures share the same CoglTexture, the same data can
        be read back multiple times,
      * If the underlying material uses multiple texture units, only the
        first one was copied back,
      * In ClutterCairoTexture, we end up having two separate copies of the
        data,
      * GL actually manages texture memory accross system/video memory
        for us!
    
    For all the reasons above, let's get rid of the glReadPixel() in
    Texture::unrealize()
    
    Fixes: OHB#1842

 clutter/clutter-texture.c | 163 +++-------------------------------------------
 1 file changed, 8 insertions(+), 155 deletions(-)

commit 778e08e4e24822b0875e6aeaf168cb5cecfc8a7f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 12 14:49:55 2010 +0000

    cogl-framebuffer: Add some missing GL defines
    
    Since 755cce33a7 the framebuffer code is using the GL enums
    GL_DEPTH_ATTACHMENT and GL_DEPTH_COMPONENT16. These aren't available
    directly under GLES except with the OES suffix so we need to define
    them manually as we do with the other framebuffer constants.

 clutter/cogl/cogl/cogl-framebuffer.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit bb8352ca95f18ca5582abb97e20e78f69300adde
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 12 14:43:36 2010 +0000

    cogl: Remove the CGL_* defines
    
    These macros used to define Cogl wrappers for the GLenum values. There are
    now Cogl enums everywhere in the API where these were required so we
    shouldn't need them anymore. They were in the public headers but as
    they are not neccessary and were not in the API docs for Clutter 1.0
    it should be safe to remove them.

 clutter/cogl/cogl/cogl-material.c                  |  10 +-
 clutter/cogl/cogl/cogl-primitives.c                |   2 +-
 clutter/cogl/cogl/cogl-shader.h                    |   2 +-
 clutter/cogl/cogl/cogl-texture.h                   |   7 +-
 clutter/cogl/cogl/driver/gl/cogl-defines.h.in      | 655 ---------------------
 clutter/cogl/cogl/driver/gl/cogl-texture-driver.c  |   2 +-
 clutter/cogl/cogl/driver/gles/cogl-defines.h.in    | 597 -------------------
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c |   4 +-
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h |  65 +-
 clutter/glx/clutter-glx-texture-pixmap.c           |   8 +-
 10 files changed, 55 insertions(+), 1297 deletions(-)

commit 1c6ffc8a238e5e7de429f35f7653695d91d9d26d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 12 15:44:28 2010 +0000

    stage: Add the delete-event signal
    
    Using the ::event signal to match the CLUTTER_DELETE event type (and
    block the stage destruction) can be costly, since it means checking
    every single event.
    
    The ::delete-event signal is similar in spirit to any other specialized
    signal handler dealing with events, and retains the same semantics.

 clutter/clutter-main.c  |  9 +--------
 clutter/clutter-stage.c | 49 ++++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-stage.h |  6 +++++-
 3 files changed, 54 insertions(+), 10 deletions(-)

commit 8b950bdc87fae2626af8a96916b7f51fdea40a17
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jan 12 11:02:09 2010 +0000

    journal: Fixes logging of multiple sets of texture coordinates
    
    If a user supplied multiple groups of texture coordinates with
    cogl_rectangle_with_multitexture_coords() then we would repeatedly log only
    the first group in the journal.  This fixes that bug and adds a conformance
    test to verify the fix.
    
    Thanks to Gord Allott for reporting this bug.

 clutter/cogl/cogl/cogl-journal.c       |   8 +-
 tests/conform/Makefile.am              |   1 +
 tests/conform/test-cogl-multitexture.c | 209 +++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c      |   1 +
 4 files changed, 215 insertions(+), 4 deletions(-)

commit bc8a80fee53c9eed17fab6d821846c1a0fa3460f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 11 17:08:42 2010 +0000

    text: Zero out the cursor_pos member
    
    Do not trust the zero-ing done by GObject on the private data structure,
    and use memset() instead to zero the ClutterGeometry structure.

 clutter/clutter-text.c | 1 +
 1 file changed, 1 insertion(+)

commit 5c14538c1406b1358a2747428c73fe0cf1198e94
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 11 17:06:52 2010 +0000

    Remove obsolete code from test-text
    
    The test-text "fake scrolling" code stopped working somewhere between
    0.8 and 0.9, with the new layout code. Instead of the ::cursor-event
    signal it should use an approach similar to the Scrollable interface in
    the Moblin User Experience toolkit.
    
    Right now, it makes sense to ignore this code entirely.

 tests/interactive/test-text.c | 26 ++------------------------
 1 file changed, 2 insertions(+), 24 deletions(-)

commit 755cce33a729817aebe4cf5c08d97c31a327c863
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 30 20:04:41 2009 +0000

    cogl: Support multiple fallbacks in cogl_offscreen_new_to_texture()
    
    The Intel drivers in Mesa 7.6 (and possibly earlier versions) don't
    support creating FBOs with a stencil buffer but without a depth
    buffer. This reworks framebuffer allocation so that we try a number
    of fallback options before failing.
    
    The options we try in order are:
    - the same options that were sucessful last time if available
    - combined depth and stencil
    - separate depth and stencil
    - just stencil, no depth
    - just depth, no stencil
    - neither depth or stencil

 clutter/cogl/cogl/cogl-framebuffer-private.h |   2 +-
 clutter/cogl/cogl/cogl-framebuffer.c         | 238 +++++++++++++++++----------
 2 files changed, 156 insertions(+), 84 deletions(-)

commit 4c1231c7fe545a7764d06754d7d6be0906686e0a
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Wed Jan 6 11:48:46 2010 +0000

    media: Add an API to specify which font should be used for subtitles
    
    Allow the user of the ClutterMedia interface to specify a Pango font
    description to display subtitles. Even if the underlying implementation
    of the interface does not natively use Pange, it must be capable of
    parsing the grammar that pango_font_description_from_string() accepts.

 clutter/clutter-media.c                    | 64 ++++++++++++++++++++++++++++++
 clutter/clutter-media.h                    | 45 +++++++++++----------
 doc/reference/clutter/clutter-sections.txt |  2 +
 3 files changed, 90 insertions(+), 21 deletions(-)

commit 8e9f56c41160452166be68202227b206a690472d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jan 10 11:35:26 2010 +0000

    build: Clean up private header/source files
    
    Some source files should not be passed through the introspection parser,
    as they are fully private and do not expose any valuable API.
    
    Also the clutter-profile.h header is private and should not be
    installed.

 clutter/Makefile.am | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit d9b91d61f5730e9ce29627f467c89070b78fb6b6
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Nov 25 14:26:32 2009 +0000

    framebuffers: cogl_offscreen_new_to_texture should take a ref on the texture
    
    We weren't taking a reference on the texture to be used as the color buffer
    for offscreen rendering, so it was possible to free the texture leaving the
    framebuffer in an inconsistent state.

 clutter/cogl/cogl/cogl-framebuffer-private.h | 1 +
 clutter/cogl/cogl/cogl-framebuffer.c         | 3 +++
 2 files changed, 4 insertions(+)

commit 30b557c4653d15eeb1311b516ab1f4c0035a5e83
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jul 3 16:22:35 2009 +0100

    profiling: Adds initial UProf accounting to Cogl
    
    This adds gives Cogl a dedicated UProf context which will be linked together
    with Clutter's context during clutter_init_real().
    
    Initial timers cover _cogl_journal_flush and _cogl_journal_log_quad
    
    You can explicitly ask for a report of Cogl statistics by exporting
    COGL_PROFILE_OUTPUT_REPORT=1 but since the context is linked with Clutter's
    the statisitcs will also be shown in the automatic Clutter reports.

 clutter/clutter-main.c           |  7 ++++++
 clutter/cogl/cogl/Makefile.am    |  2 ++
 clutter/cogl/cogl/cogl-journal.c | 19 ++++++++++++++
 clutter/cogl/cogl/cogl-profile.c | 30 ++++++++++++++++++++++
 clutter/cogl/cogl/cogl-profile.h | 54 ++++++++++++++++++++++++++++++++++++++++
 configure.ac                     |  2 +-
 6 files changed, 113 insertions(+), 1 deletion(-)

commit 0b6515a1d53571fea13417d47e7bf0f4749321f8
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Apr 17 12:15:56 2009 +0100

    profiling: Allow limiting statisics just to picking
    
    This suspends and resumes all uprof timers and counters except while dealing
    with picking, so as to give more focused statistics.
    
    Be aware that there are still some issues with this profile option since
    there are a few special case counters and timers that shouldn't be
    suspended; noteably the frame counters are incorrect so the per frame stats
    can't be trusted.

 clutter/clutter-main.c    | 22 ++++++++++++++++++++--
 clutter/clutter-profile.c | 29 +++++++++++++++++++++++++++++
 clutter/clutter-profile.h |  9 +++++++++
 3 files changed, 58 insertions(+), 2 deletions(-)

commit 9cb530d42e7860d1a44f441b97910fd3903480f1
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 6 18:15:13 2010 +0000

    profiling: Parse --clutter-profile and CLUTTER_PROFILE= options
    
    As we have for debugging, this adds the ability to control profiling flags
    either via the command line or an environment variable.
    
    The first option added is CLUTTER_PROFILE=disable-report
    
    This also changes the reporting to be opt-out so you don't need to export
    CLUTTER_PROFILE_OUTPUT_REPORT=1 to see a report but you can use
    CLUTTER_PROFILE=disable-report to disable it if desired.

 clutter/clutter-main.c    | 51 +++++++++++++++++++++++++++++++++++++++++++++++
 clutter/clutter-profile.c |  2 +-
 clutter/clutter-profile.h |  8 ++++++++
 3 files changed, 60 insertions(+), 1 deletion(-)

commit 00577558540db2c9f7bf24e870ff6231abb2b99d
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Mar 30 16:41:02 2009 +0100

    profiling: Adds initial UProf support across clutter
    
    UProf is a small library that aims to help applications/libraries provide
    domain specific reports about performance.  It currently provides high
    precision timer primitives (rdtsc on x86) and simple counters, the ability
    to link statistics between optional components at runtime and makes report
    generation easy.
    
    This adds initial accounting for:
    - Total mainloop time
    - Painting
    - Picking
    - Layouting
    - Idle time
    
    The timing done by uprof is of wall clock time. It's not based on stochastic
    samples we simply sample a counter at the start and end.  When dealing with
    the complexities of GPU drivers and with various kinds of IO this form of
    profiling can be quite enlightening as it will be able to represent where
    your application is blocking unlike tools such as sysprof.
    
    To enable uprof accounting you must configure Clutter with --enable-profile
    and have uprof-0.2 installed from git://git.moblin.org/uprof
    
    If you want to see a report of statistics when Clutter applications exit you
    should export CLUTTER_PROFILE_OUTPUT_REPORT=1 before running them.
    
    Just a final word of caution; this stuff is new and the manual nature of
    adding uprof instrumentation means it is prone to some errors when modifying
    code.  This just means that when you question strange results don't rule out
    a mistake in the instrumentation.  Obviously though we hope the benfits out
    weigh e.g.  by focusing on very key stats and by having automatic reporting.

 clutter/Makefile.am               |   2 +
 clutter/clutter-actor.c           |  14 ++++
 clutter/clutter-backend.c         |  15 ++++
 clutter/clutter-main.c            |  94 ++++++++++++++++++++-
 clutter/clutter-profile.c         | 170 ++++++++++++++++++++++++++++++++++++++
 clutter/clutter-profile.h         |  57 +++++++++++++
 clutter/clutter-stage.c           |   9 ++
 clutter/glx/clutter-backend-glx.c |  17 ++++
 8 files changed, 376 insertions(+), 2 deletions(-)

commit bd41db7c00fc54aa8077f53177ff33bd33a19c83
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Mar 17 13:07:46 2009 +0000

    Adds a --enable-profile option to configure.ac
    
    There is nothing else hooked up to this option so far

 README       |  4 ++++
 configure.ac | 58 +++++++++++++++++++++++++++++++++++++++++++++-------------
 2 files changed, 49 insertions(+), 13 deletions(-)

commit 5157da9fc8340cebdd29989a4ea02ccf607d3c52
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 8 15:04:56 2010 +0000

    x11: Switch back to RGB visuals by default
    
    Since asking for ARGB by default is still somewhat experimental on X11
    and not every toolkit or complex widgets (like WebKit) still do not like
    dealing with ARGB visuals, we should switch back to RGB by default - now
    that at least we know it works.
    
    For applications (and toolkit integration libraries) that want to enable
    the ClutterStage:use-alpha property there is a new function:
    
      void clutter_x11_set_use_argb_visual (gboolean use_argb);
    
    which needs to be called before clutter_init().
    
    The CLUTTER_DISABLE_ARGB_VISUAL environment variable can still be used
    to force this value off at run-time.

 clutter/glx/clutter-backend-glx.c          |  2 +-
 clutter/x11/clutter-backend-x11.c          | 70 +++++++++++++++++++++++++++++-
 clutter/x11/clutter-stage-x11.c            |  6 ++-
 clutter/x11/clutter-x11.h                  |  9 +++-
 doc/reference/clutter/clutter-sections.txt |  3 ++
 5 files changed, 83 insertions(+), 7 deletions(-)

commit 9599adbd820db7526d77790d8b611a6b61cb2dc7
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Wed Jan 6 00:44:24 2010 +0000

    doc: Fix media::{get,set}_subtitle_uri() symbol names
    
    At first, those symbols were called {get,set}_subtitles_uri() but were
    renamed to {get,set}_subtitle_uri() without updating the
    clutter-section.txt file.
    
    This fix makes gtk-doc document those symbols again.

 doc/reference/clutter/clutter-sections.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit bf4818bd759f612a9cec62c2e072544d54cc104c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 7 11:08:52 2010 +0000

    actor: Just emit a relayout cycle warning
    
    Currently, ClutterActor detects a relayout cycle (an actor causing a
    relayout to be queued from within an allocate() function) and aborts
    after printing out a warning. This might be a little bit too anal
    retentive, and it currently breaks GTK+ embedding inside clutter-gtk
    so we should probably relax the behaviour a bit. Now we just emit the
    warning but we still go ahead with the relayout.

 clutter/clutter-actor.c | 1 -
 1 file changed, 1 deletion(-)

commit 821e622de671ad4e18a55e9dbd33aee004e822df
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 7 15:58:53 2010 +0000

    Don't set the GLX_TRANSPARENT_TYPE attribute to choose an FBConfig
    
    When Clutter tries to pick an ARGB visual it tried to set the
    GLX_TRANSPARENT_TYPE attribute of the FBConfig to
    GLX_TRANSPARENT_RGB. However the code to do this was broken so that it
    was actually trying to set the non-existant attribute number 0x8008
    instead. Mesa silently ignored this so it appeared as if it was
    working but the Nvidia drivers do not like it.
    
    It appears that the TRANSPARENT_TYPE attribute is not neccessary for
    getting an ARGB visual anyway and instead it is intended to support
    color-key transparency. Therefore we can just remove it and get all of
    the FBConfigs. Then if we need an ARGB visual we can just walk the
    list to look for one with depth == 32.
    
    The fbconfig is now stored in a single variable instead of having a
    separate variable for the rgb and rgba configs because the old code
    only ever retrieved one of them anyway.

 clutter/glx/clutter-backend-glx.c | 145 +++++++++++++++-----------------------
 clutter/glx/clutter-backend-glx.h |   5 +-
 2 files changed, 57 insertions(+), 93 deletions(-)

commit 8b59573190907da97c2af5a5be2e563fc66f8d51
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 18:02:29 2010 +0000

    Covert stb_image.c to Unix format
    
    The file is still in DOS format (CRLF instead of LF) and this confuses
    the hell out of some versions of Git.

 clutter/cogl/cogl/stb_image.c | 7544 ++++++++++++++++++++---------------------
 1 file changed, 3772 insertions(+), 3772 deletions(-)

commit 58b5a46e0e6b263bd32808e4a9a46bbdd81eedfe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 17:54:45 2010 +0000

    Include cogl-defines.h before using GL types
    
    If we are using GL* types we should also be including cogl-defines.h, as
    that will include the right GL header.

 clutter/cogl/cogl/cogl-shader.h  | 1 +
 clutter/cogl/cogl/cogl-texture.h | 1 +
 2 files changed, 2 insertions(+)

commit 793fec8138b478ba1f1ea419f9ef8bed4f453e77
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 16:11:45 2010 +0000

    cogl: Fix array annotations
    
    The arrays in the cogl_program_set_uniform_* API should be marked as
    such, and have their length arguments specified.

 clutter/cogl/cogl/cogl-shader.h | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 59105341bce12b2ec009ff953facbb7f7b10e85f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 5 11:58:12 2010 +0000

    text: Store the markup attributes separately
    
    Previously when the markup property is set it would generate an
    attribute list from the markup and then merge it with the attributes
    from the attribute property and store it as the effective
    attributes. The markup attributes and the marked up text would then be
    forgotten. This breaks if the application then later changes the
    attributes property because it would try to regenerate the effective
    attributes from the markup text but the stored text no longer contains
    any markup. If the original markup text happened to contain entities
    like '&lt;' they would end up causing parse errors because they would
    be converted to the actual symbols.
    
    To fix this the attributes from the markup are now stored
    independently from the effective attributes. The effective attributes
    are now regenerated if either set of attributes changes right before a
    layout is created.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1940

 clutter/clutter-text.c | 134 ++++++++++++++++++++++++++++++-------------------
 1 file changed, 82 insertions(+), 52 deletions(-)

commit 32b456fc8c4e8743c1b2c32164f7e9f67188a60e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 5 11:44:17 2010 +0000

    text: Free the Pango attribute list resources
    
    The ClutterText owns three PangoAttrList resources which were not
    being unref'd. This adds the unref calls to the finalize method.

 clutter/clutter-text.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 64c1294cc26e034fbf8a9a05b4413f63b9cd882d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 14:10:19 2010 +0000

    x11 tfp: Plug a leak
    
    Destroy the dummy XImage we create even on success.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1918
    
    Based on a patch by: Carlos Martín Nieto <carlos@cmartin.tk>
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/x11/clutter-x11-texture-pixmap.c | 22 +++++++++++++---------
 1 file changed, 13 insertions(+), 9 deletions(-)

commit fa298b45b530c6b6821e73b011c3c7d226950ce0
Merge: 4207524e9 4adc2c2d8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 11:04:50 2010 +0000

    Merge branch 'matrix-mode'
    
    * matrix-mode:
      build: Move CoglMatrixMode to cogl-matrix-stack.h

commit 4207524e950efd3f1fa5334f6d0b9b374a0b3f93
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 11:02:39 2010 +0000

    Remove trailing comma from test UI definition
    
    The animation definition test has a trailing comma at the end of an
    array item.

 tests/data/test-script-animation.json | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2aa9d7bdc78703fc9a6354d2e54f880fde96db39
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 5 10:55:28 2010 +0000

    script: Copy the JSON node in PropertyInfo
    
    PropertyInfo should store a copy of the JsonNodes it references, so
    that property_info_free() can safely dispose them, and we can reference
    values across different UI definition data.
    
    The implicit timeline parsing code is not copying the JsonNode; this
    leads to a double free in some cases, which is masked by the GSlice
    allocator and produces a heap corruption later on.

 clutter/clutter-script-parser.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 10963d1ae03920e202ccbd0107854f489117f89b
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Dec 28 17:52:43 2009 +0100

    [media] Add an API to play a subtitle file along with the media
    
    Allow the user of the ClutterMedia interface to specify an external (as
    in not multiplexed with the audio/video streams) location of a subtitle
    stream.

 clutter/clutter-media.c                    | 55 ++++++++++++++++++++++++++++++
 clutter/clutter-media.h                    |  3 ++
 doc/reference/clutter/clutter-sections.txt |  2 ++
 3 files changed, 60 insertions(+)

commit 5d5c7142f7fa2447e13bcb80a272b0d9dfc28f06
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 4 12:03:47 2010 +0000

    text: Use G_SIGNAL_ACTION for ::insert-text and ::delete-text
    
    Both the ::insert-text and ::delete-text are "action" signals, that is
    signals that are safe to (and should) be emitted using g_signal_emit()
    directly.

 clutter/clutter-text.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit bf43cb6cdc84e646add7adc592487274331d4930
Author: Alejandro Piñeiro <apinheiro@igalia.com>
Date:   Fri Nov 20 15:17:41 2009 +0100

    Added ClutterText::insert-text and ClutterText::delete-text signals
    
    * clutter/clutter-marshal.list: added new marshaller
    * clutter/clutter-text.c
    (clutter_text_class_init): added insert-text and delete-text signals
    (clutter_text_insert_unichar): emits insert-text signal
    (clutter_text_insert_text): emits insert-text signal
    (clutter_text_delete_text): emits delete-text signal
    (clutter_text_delete_chars): emits delete-text signal
    (clutter_text_set_markup_internal): emits delete-text and insert-text signals
    (clutter_text_set_text): emits delete-text and insert-text signals
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1894

 clutter/clutter-marshal.list |  1 +
 clutter/clutter-text.c       | 87 ++++++++++++++++++++++++++++++++++++++++++--
 2 files changed, 84 insertions(+), 4 deletions(-)

commit 4adc2c2d839c42eccc7187735ddcce061d25f14b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 4 11:58:32 2010 +0000

    build: Move CoglMatrixMode to cogl-matrix-stack.h
    
    This avoids a redeclaration of _cogl_matrix_stack_flush_to_gl() from
    using GLenum to CoglMatrixMode.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1928

 clutter/cogl/cogl/cogl-internal.h     | 7 -------
 clutter/cogl/cogl/cogl-matrix-stack.h | 9 +++++++--
 2 files changed, 7 insertions(+), 9 deletions(-)

commit eb9029504124daf4c032f027c2f068ec25548f3f
Author: Halton Huo <halton.huo@sun.com>
Date:   Mon Jan 4 11:49:50 2010 +0000

    cogl-texture: Remove return in void functions
    
    http://bugzilla.o-hand.com/show_bug.cgi?id=1929
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/cogl/cogl/cogl-texture.c | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit b98d486fc99fd46626877be728961190dbf831dc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 4 11:49:13 2010 +0000

    build: Maintainer cflags go in the _CFLAGS target
    
    The maintainer compiler flags are not pre-processor flags.

 clutter/cogl/cogl/Makefile.am | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 0fb51658fdba886fd5d9cb53cfca6df13aa1f7a0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 4 11:43:00 2010 +0000

    cogl: Const-ify vertices in cogl_polygon()
    
    The CoglTextureVertex array passed to cogl_polygon() is a pure
    in-argument and should be const-ified.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1917

 clutter/cogl/cogl/cogl-primitives.c | 27 ++++++++++++++-------------
 clutter/cogl/cogl/cogl-texture.h    |  6 +++---
 2 files changed, 17 insertions(+), 16 deletions(-)

commit 1c69c61745ed510f0b6ab16cb963ca01994cb9fc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Nov 11 11:00:29 2009 +0000

    master-clock: Take a reference before advancing timelines
    
    A timeline advancement might cause another timeline to be
    destroyed, which will likely lead to a segmentation fault.
    
    Before advancing the timelines we should take a reference
    on them - just like we do for the stages before doing
    event processing. This will prevent dispose() from running
    until the end of the advancement.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1854

 clutter/clutter-master-clock.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 5ae88f5777c5ed0663937f990350f145b254692c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jan 3 20:41:17 2010 +0000

    Post-release version bump to 1.1.5

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6d7e1e5434d3da27cf23a9c16f9990523eedba4e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jan 3 20:11:43 2010 +0000

    Release Clutter 1.1.4

 NEWS         | 56 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 configure.ac |  4 ++--
 2 files changed, 58 insertions(+), 2 deletions(-)

commit 3355c2ab2518711d7ab79f3ffe1f4a8ce105af84
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jan 3 20:24:39 2010 +0000

    build: Remove dist rule for non-existing image files

 doc/cookbook/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8d40cb947031f90a7b8cf459720278c6a6fe295d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jan 3 20:12:49 2010 +0000

    Disable g_set_prgname()
    
    Apparently, calling g_set_prgname() multiple times is not allowed
    anymore, and hence clutter_init_* calls should not do that. Though this
    is really GLib's fault - and a massive nuisance for us - we should
    prolly comply to avoid the test suite dying on us.

 clutter/clutter-main.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 3d350078a8aa6f1bdf38c12de62e2708c5369247
Merge: a09ac0b27 934eee17a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 23 10:38:02 2009 +0000

    Merge branch 'animate-layout-manager' into ebassi-next
    
    * animate-layout-manager:
      layout-manager: Document the animation support
      layout-manager: Rewind the timeline in begin_animation()
      box-layout: Remove the allocations hash table
      docs: Clean up the README file
      layout: Let begin_animation() return the Alpha
      box-layout: Add knobs for controlling animations
      box-layout: Animate layout properties
      layout: Add animation support to LayoutManager
      Add ActorBox animation methods

commit 934eee17ae34098773ff5876747061b5a1d1f1a5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 23 10:35:16 2009 +0000

    layout-manager: Document the animation support
    
    Add a section inside the LayoutManager class API reference documenting,
    with examples, how to implement animation support inside a layout
    manager sub-class.

 clutter/clutter-layout-manager.c | 213 ++++++++++++++++++++++++++++++++++-----
 1 file changed, 190 insertions(+), 23 deletions(-)

commit 713c2952410e99e681825dac51da3e0b575ef2cf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 23 08:39:16 2009 +0000

    layout-manager: Rewind the timeline in begin_animation()
    
    If the default implementation begin_animation() is called twice then we
    should rewind the timeline, as well as updating its duration and the
    easing mode of the alpha.

 clutter/clutter-layout-manager.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit b9c1de0ec7001ce6a6b62dbd8d1fd9ee15539093
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 23 08:34:08 2009 +0000

    box-layout: Remove the allocations hash table
    
    The BoxLayout uses a HashTable to map the latest stable allocation of
    each child, in order to use that as the initial value during an
    animation; this in spite of already having a perfectly valid per-child
    storage as part of the layout manager: ClutterBoxChild.
    
    The last stable allocation should be stored inside the ClutterBoxChild
    instead of having it in the private data for ClutterBoxLayout. The
    access remains O(1), since there is a 1:1 mapping between child and
    BoxChild instances, but we save a little bit of memory and we avoid
    keeping aroud allocations for old children.

 clutter/clutter-box-layout.c | 47 ++++++++++++++++++++------------------------
 1 file changed, 21 insertions(+), 26 deletions(-)

commit c8c5e0ee39626d434c2d3e5486c6520eff17f519
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 22 18:10:39 2009 +0000

    docs: Clean up the README file

 README | 137 +++++++++++++++++++++++++++++++++++++++--------------------------
 1 file changed, 83 insertions(+), 54 deletions(-)

commit a09ac0b27ccb4a9c08a4e42e00776bf627f0e163
Merge: b6bd8be6c 34913378f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Dec 20 17:39:12 2009 +0000

    Merge branch 'stage-use-alpha' into ebassi-next
    
    * stage-use-alpha:
      tests: Use accessor methods for :use-alpha
      stage: Add accessors for :use-alpha
      tests: Allow setting the stage opacity in test-paint-wrapper
      stage: Premultiply the stage color
      stage: Composite the opacity with the alpha channel
      glx: Always request an ARGB visual
      stage: Add :use-alpha property
      materials: Get the right blend function for alpha

commit b6bd8be6cb0fabf2ddf3eedadce68c8d3a60c3d9
Merge: 7b53aa751 c7e8ddb7a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Dec 20 17:33:51 2009 +0000

    Merge branch 'internal-flag' into ebassi-next
    
    * internal-flag:
      conform: Add test unit for the destruction of Containers
      actor: Add internal child flag
      Clean up whitespace, indentation and comments

commit c7e8ddb7a60dd76d5f62027383693575f30e2473
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 18 23:29:11 2009 +0000

    conform: Add test unit for the destruction of Containers
    
    Verify that internal children do not go through the remove()
    implementation, and that non-internal children do.

 .gitignore                         |   1 +
 tests/conform/Makefile.am          |   1 +
 tests/conform/test-actor-destroy.c | 168 +++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c  |   1 +
 4 files changed, 171 insertions(+)

commit 1520ba6190165dc8902b622833efbccf23716751
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 18 23:20:04 2009 +0000

    actor: Add internal child flag
    
    ClutterActor checks, when destroying and reparenting, if the parent
    actor implements the Container interface, and automatically calls the
    remove() method to perform a clean removal.
    
    Actors implementing Container, though, might have internal children;
    that is, children that are not added through the Container API. It is
    already possible to iterate through them using the Container API to
    avoid breaking invariants - but calling clutter_actor_destroy() on
    these children (even from the Container implementation, and thus outside
    of Clutter's control) will either lead to leaks or to segmentation
    faults.
    
    Clutter needs a way to distinguish a clutter_actor_set_parent() done on
    an internal child from one done on a "public" child; for this reason, a
    push/pop pair of functions should be available to Actor implementations
    to mark the section where they wish to add internal children:
    
      ➔ clutter_actor_push_internal ();
        ...
        clutter_actor_set_parent (child1, parent);
        clutter_actor_set_parent (child2, parent);
        ...
      ➔ clutter_actor_pop_internal ();
    
    The set_parent() call will automatically set the newly added
    INTERNAL_CHILD private flag on each child, and both
    clutter_actor_destroy() and clutter_actor_unparent() will check for the
    flag before deciding whether to call the Container's remove method.

 clutter/clutter-actor.c                    | 110 +++++++++++++++++++++++++++--
 clutter/clutter-actor.h                    |   3 +
 clutter/clutter-private.h                  |  29 ++++++--
 doc/reference/clutter/clutter-sections.txt |   2 +
 4 files changed, 132 insertions(+), 12 deletions(-)

commit 4a21425f4837798d01f4435b68582faf9029c61c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Dec 13 01:23:54 2009 +0000

    layout: Let begin_animation() return the Alpha
    
    When beginning a new animation for a LayoutManager, the implementation
    should return the ClutterAlpha used. This allows controlling the
    timeline and/or modifying the animation parameters on the fly.

 clutter/clutter-box-layout.c     |  5 +++--
 clutter/clutter-layout-manager.c | 30 ++++++++++++++++++++++--------
 clutter/clutter-layout-manager.h |  5 +++--
 3 files changed, 28 insertions(+), 12 deletions(-)

commit 2e6397c39132007e79f5f87743fe9378fd8d5387
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Dec 13 01:07:44 2009 +0000

    box-layout: Add knobs for controlling animations
    
    ClutterLayoutManager does not have any state associated with it, and
    defers all the state to its sub-classes.
    
    The BoxLayout is thus in charge of controlling:
    
      • whether or not animations should be used
      • the duration of the animation
      • the easing mode of the animation
    
    By adding three new properties:
    
      • ClutterBoxLayout:use-animations
      • ClutterBoxLayout:easing-duration
      • ClutterBoxLayout:easing-mode
    
    And their relative accessors pairs we can make BoxLayout decide whether
    or not, and with which parameters, call the begin_animation() method of
    ClutterLayoutManager.
    
    The test-box-layout has been modified to reflect this new functionality,
    by checking the key-press event for the 'a' key symbol to toggle the use
    of animations.

 clutter/clutter-box-layout.c               | 320 +++++++++++++++++++++++++++--
 clutter/clutter-box-layout.h               |  90 ++++----
 doc/reference/clutter/clutter-sections.txt |   8 +
 tests/interactive/test-box-layout.c        |   6 +
 4 files changed, 370 insertions(+), 54 deletions(-)

commit 3c2e91aef586de5521aa9674b80d449cf96da0e1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Dec 12 00:13:05 2009 +0000

    box-layout: Animate layout properties
    
    Use the newly added animation support inside LayoutManager to animate
    between state changes of the BoxLayout properties.
    
    The implementation is based on equivalent code from Mx, written by:
    
      Thomas Wood <thomas.wood@intel.com>

 clutter/clutter-box-layout.c | 130 +++++++++++++++++++++++++++++++++++++------
 1 file changed, 113 insertions(+), 17 deletions(-)

commit f94a903d9ebdbc055010bb4a4c6fe7e76f418bd8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Dec 12 00:02:43 2009 +0000

    layout: Add animation support to LayoutManager
    
    In order to animate a fluid layout we cannot use the common animation
    code paths as they will override the size request and allocation paths
    that are handled by the layout manager itself.
    
    One way to introduce animations in the allocation sequence is to use a
    Timeline and an Alpha to compute a progress value and then use that
    value to interpolate an ActorBox between the initial and final states of
    the animation - with the initial state being the last allocation of the
    child prior to the animation start, and the final state the allocation
    of the child at the end; for every frame of the Timeline we then queue a
    relayout on the layout manager's container, which will result in an
    animation.
    
    ClutterLayoutManager is the most likely place to add a generic API for
    beginning and ending an animation, as well as the place to provide a
    default code path to create the ancillary Timeline and Alpha instances
    needed to drive the animation.
    
    A LayoutManager sub-class will need to:
    
      • call clutter_layout_manager_begin_animation() whenever it should
        animate between two states, for instance: whenever a layout property
        changes value;
      • eventually override begin_animation() and end_animation() in case
        further state needs to be set up, and then chain up to the default
        implementation provided by LayoutManager;
      • if a completely different implementation is required, the layout
        manager sub-class should override begin_animation(), end_animation()
        and get_animation_progress().
    
    Inside the allocate() implementation the sub-class should also
    interpolate between the last known allocation of a child and the newly
    computed allocation.

 clutter/clutter-layout-manager.c           | 159 ++++++++++++++++++++++++++++-
 clutter/clutter-layout-manager.h           |  68 +++++++-----
 doc/reference/clutter/clutter-sections.txt |   5 +
 3 files changed, 207 insertions(+), 25 deletions(-)

commit 999359d64ccfbdbcc952662c14fa47441d6a5225
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 11 23:48:58 2009 +0000

    Add ActorBox animation methods
    
    ClutterActorBox should have an interpolate() method that allows to
    compute the intermediate values between two states, given a progress
    value, e.g.:
    
            clutter_actor_box_interpolate (start, end, alpha, &result);
    
    Another utility method, useful for layout managers, is a modifier
    that clamps the members of the actor box to the nearest integer
    value.

 clutter/clutter-actor.c                    | 47 ++++++++++++++++++++++++++++++
 clutter/clutter-types.h                    |  5 ++++
 doc/reference/clutter/clutter-sections.txt |  2 ++
 3 files changed, 54 insertions(+)

commit d2ea7cd6a8a1eb4ff04f11cb53aa387458a8e128
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 11 20:17:58 2009 +0000

    Clean up whitespace, indentation and comments

 clutter/clutter-main.c | 70 ++++++++++++++++++++++++++------------------------
 1 file changed, 36 insertions(+), 34 deletions(-)

commit 7b53aa7510adc60d3287740772ec97117ce78ab9
